<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"> 
<?LassoScript
	var: 'security_token' = 'migration';
	auth_admin;
	library: (lassoapp_link: 'library.lasso');
?>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" >
	<head>
		<title>[var: 'admin_title', -encodenone]</title>
		<style>[include: (lassoapp_link: 'default_css.lasso')]</style><?LassoScript

		inline: (action_params), -nothing, -database='lasso_internal';

		// This variable holds the default tab for each section
		_migration_addvar: -name='admin_memory', -session='_migration', -default=(map);
	
		// Library One
		
		If: ($admin_tab1 == '') || (_migration_array_find: -array=$admin_tab_array1, -pattern=$admin_tab1) == 'None';
			var: 'admin_tab1' = $admin_memory->(find: '_root');
		/If;
		If: ($admin_tab1 == '') || (_migration_array_find: -array=$admin_tab_array1, -pattern=$admin_tab1) == 'None';
			var: 'admin_tab1' = $admin_tab_array1->(get:1)->first;
		/If;
		$admin_memory->(insert: '_root' = $admin_tab1);
	
		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (admin_link: (string:  $admin_tab1 + '/library.lasso'));
			Handle: ((Error_CurrentError) != (Error_NoError)) && ((Error_CurrentError: -ErrorCode) != (Error_NoError: -ErrorCode)) && ((Error_CurrentError: -ErrorCode) != (Error_FileNotFound: -ErrorCode));
				_debug: (Error_CurrentError: -encodebreaks) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;
		if: (var: 'abort') == true;
			abort;
			var: 'abort' = false;
		/if;

		// Reset admin_link based on actual tab visited
		
		var: 'admin_link' = $admin_file +
			'?tab1=' + $admin_tab1 +
			'&-session=_migration:' + (session_id: -name='_migration') +
			'&increment=' + $admin_increment;
	?>
	</head>
	<body>

		<div id="frame_main" class="frame_main">

[if: (client_type >> 'MSIE') && (client_type >> 'Mac_PowerPC')]
			<div id="header_tab1" align="center">
				<img class="graphic_left" src="[admin_link:'images/logo_left.jpg']" alt="" width="144" height="36" />
				<a href="http://www.lassosoft.com/" target="_new"><img class="graphic_right" src="[admin_link:'images/logo_right.jpg']" alt="" width="144" height="36" border=0 /></a>[loop: $admin_tab_array1->size][var: 'temp' = $admin_tab_array1->(get: loop_count)]
				<a href="[Response_FilePath]?tab1=[Output: $temp->First]" class="tab1[If: $temp->First == $admin_tab1] active1[/If]"><img class="corner_left1" src="images/1x1.gif" border="0" alt="" width="1" height="1" />&nbsp;&nbsp;&nbsp;[encode_html: $temp->Second]&nbsp;&nbsp;&nbsp;<img class="corner_right1" src="images/1x1.gif" border="0" alt="" width="1" height="1" /></a>[/loop]
			</div>
[else]
			<div id="header_tab1" class="header_tab1" align="center">
				<img class="graphic_left" src="[admin_link:'images/logo_left.jpg']" alt="" width="144" height="36" />
				<a href="http://www.lassosoft.com/" target="_new"><img class="graphic_right" src="[admin_link:'images/logo_right.jpg']" alt="" width="144" height="36" border=0 /></a>[loop: $admin_tab_array1->size][var: 'temp' = $admin_tab_array1->(get: loop_count)]
				<a href="[Response_FilePath]?tab1=[Output: $temp->First]" class="tab1[If: $temp->First == $admin_tab1] active1[/If]"><img class="corner_left1" src="images/corner_ffffff_left.gif" border="0" alt="" width="2" height="2" /><span class="tab1">[encode_html: $temp->Second]</span><img class="corner_right1" src="images/corner_ffffff_right.gif" border="0" alt="" width="2" height="2" /></a>[/loop]
			</div>
[/if]

			<div id="frame_header">&nbsp;</div>

	<?LassoScript
	
		// Default One

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (admin_link: (string:  $admin_tab1 + '/default.lasso'));
			Handle: ((Error_CurrentError) != (Error_NoError)) && ((Error_CurrentError: -ErrorCode) != (Error_NoError: -ErrorCode)) && ((Error_CurrentError: -ErrorCode) != (Error_FileNotFound: -ErrorCode));
				_debug: (Error_CurrentError) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;
		if: (var: 'abort') == true;
			abort;
			var: 'abort' = false;
		/if;
		
	?>

			<div id="frame_footer" class="frame_footer">
				<table style="margin:0px">
					<tr>
						<th width="36"><a href="[var: 'admin_link']?migrat_action=refresh">Refresh</a></th>
						<td align="center">Lasso Settings Migrator</td>
						<th width="36"><a href="[response_filepath]?logout=true">Logout</a></th>
					</tr>
				</table>
			</div>
		
			<p>&copy; 1996[if: (date_getyear: date_getcurrentdate) > 1996]-[date_getyear: date_getcurrentdate][/if] LassoSoft, LLC</p>					

		</div>[/inline]

	</body>
</html>
