#ifndef _MOD_LASSO_H_
#define _MOD_LASSO_H_

#include "httpd.h"
#ifdef strtoul
#undef strtoul // seriously...
				// what they were pulling causes compiler errors
#endif
#include <http_config.h>
#include <http_protocol.h>
#include <http_protocol.h>
#include <http_main.h>
#include <http_core.h>
#include <ap_compat.h>
#include "LassoProto.h"
#include "LassoProtoUtils.h"
#include "RequestParams.h"

#ifndef WIN32
#define SOCKET int
#endif

class LP8POSTReader;

/*
	Prototypes:
*/
/* returns the socket or -1 */
static SOCKET open_connection();
static void release_connection(SOCKET s, bool justKillIt=false);

static int lasso_handler (request_rec *r);
static void child_init_handler(apr_pool_t *pchild, server_rec *s);
static int get_param( request_rec * r, RequestParamKeyword word, const char * param, char ** data, int * outLen );
static int get_post( SOCKET sock, request_rec * r, LP8POSTReader * reader );

#endif
