#ifndef _MOD_LASSO_H_
#define _MOD_LASSO_H_

#include <httpd.h>
#include <http_config.h>
#include <http_protocol.h>
#include <http_protocol.h>
#include <http_main.h>
#include <http_core.h>
#include <ap_compat.h>
#include "LassoProto.h"
#include "LassoProtoUtils.h"
#include "RequestParams.h"

#if __cplusplus
extern "C"
{
#endif

/*
	Prototypes:
*/
/* returns the socket or -1 */
static int open_connection(pool * p, server_rec * s);
int lasso8_handler (request_rec *r);
static void init_module(server_rec*, pool*);
static void child_term_handler(server_rec*, pool*);
static void child_init_handler(server_rec*, pool*);
static int get_param( request_rec * r, RequestParamKeyword word, const char * param, char ** data, int * outLen );
static int get_post( int sock, request_rec * r, class LP8POSTReader * reader );

#if __cplusplus
}
#endif

#endif
