#ifndef __LASSO4ISAPI_H__
#define __LASSO4ISAPI_H__

#define WIN32_LEAN_AN_MEAN
#include <windows.h>
#include <httpext.h>

#include "LassoProto.h"
#include "RequestParams.h"

int GetParamSize( EXTENSION_CONTROL_BLOCK* pECB, char* szVarName );
DWORD GetParam( int sock, EXTENSION_CONTROL_BLOCK* pECB, RequestParamKeyword word, const char * param, char ** data, int * outLen, const class LP8POSTReader * reader );

int GetPOST( int sock, EXTENSION_CONTROL_BLOCK* pECB, class LP8POSTReader * postReader );

int open_connection(); /* returns the socket or -1 */
void release_connection( int socket, bool justKillIt = false );

int get_conf_value( char * x, char * y );

void send_error( EXTENSION_CONTROL_BLOCK* pECB, const char * msg ) ;


static const char* kLassoCommError = "<html>\r<body><h1>Lasso Error</h1>Lasso Connector could not communicate with \
										Lasso Service.<br>";




#endif //__LASSO4ISAPI_H__
