#ifndef _IMAGETAG_H_
#define _IMAGETAG_H_

#include "LassoCAPI.h"
#include <magick/api.h>
#include <wand/MagickWand.h>

#ifdef WIN32
#define IMEXPORT __declspec(dllexport)
#else
#define IMEXPORT
#endif

typedef struct 
{
	Image			*image;
	ImageInfo		*info;
	int				refcount;
} im_type_t, *im_type_ptr;


extern "C" IMEXPORT void registerLassoModule(void);

osError im_transform( lasso_request_t token, tag_action_t );
osError im_info( lasso_request_t token, tag_action_t );
osError im_callback( lasso_request_t token, tag_action_t action );
osError ResolveFileName(lasso_request_t token, char ** argv, secure_operation_t perm);
#endif
