<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">
  <xsl:template match="/">

	  <!-- 
        - FMP XML Output Format 
       -->
      <xsl:for-each select="FMPXMLRESULT/RESULTSET/ROW">
        <P>
	      <xsl:for-each select="COL">
	          <xsl:value-of select="DATA"/><BR/>
	      </xsl:for-each>
        </P>
      </xsl:for-each>

	  <!-- 
        - DSO XML Output Format (FMP) 
       -->
      <xsl:for-each select="FMPDSORESULT/ROW">
        <P>
	      <xsl:for-each>
	          <xsl:value-of select="."/><BR/>
	      </xsl:for-each>
        </P>
      </xsl:for-each>

	  <!-- 
        - SQL XML Raw Elements Output Format (MS) 
       -->
      <xsl:for-each select="root/row">
        <P>
	      <xsl:for-each match="*">
	          <xsl:value-of select="."/><BR/>
	      </xsl:for-each>
        </P>
      </xsl:for-each>

  </xsl:template>
</xsl:stylesheet>
