#ifndef _LASSOPROTOUTILS_H_
#define _LASSOPROTOUTILS_H_

#include "LassoProto.h"
#ifndef WIN32
#define UNIXSUCKS // static
#else
#define UNIXSUCKS 
#endif

/* TO host endian */
UNIXSUCKS void convert_endian_h( LPCommandBlock * block );
/* TO network endian */
UNIXSUCKS void convert_endian_n( LPCommandBlock * block );

/* The data buffer is allocated using malloc and should be free'd by the caller */
typedef enum READ_RESULT
{
	READ_TIMEOUT,
	READ_OK,
	READ_ERROR
} READ_RESULT;

UNIXSUCKS READ_RESULT read_block( int sock, LPCommandBlock* block, char** data, unsigned int* time_out );
UNIXSUCKS int send_block( int sock, const LPCommandBlock* block, const char * data );

//UNIXSUCKS int log_message(int sock, const char * msg);

#endif
