<?LassoScript

if: ($browse_action >> 'Add');

	var: 'add_inline' = (array: -add='', -database=$browse_databasealias, -table=$browse_tablealias, -keyfield=$browse_keyfield);

	var: 'inline_size' = $add_inline->size;
	
	var: 'browse_keyvalue' = null;

	loop: $browse_fieldmap->size;
		var: 'temp'=$browse_fieldmap->(get: loop_count)->second;
		var: 'name'=$temp->(find: 'name');
		var: 'value'=(action_param: 'add_' + $name);
		if: ($value != '');
			$add_inline->(insert: $name = $value);
			if: $name == $browse_keyfield;
				var: 'browse_keyvalue' = $value;
			/if;
		/if;
	/loop;

	if: ($add_inline->size == $inline_size);
		// No fields have been added, populate the keyfield with NULL
		$add_inline->(insert: $browse_keyfield=null);
	/if;

	protect;
		inline: $add_inline;
			var:'found_count'=found_count, 'shown_first'=shown_first, 'shown_last'=shown_last;
			if: $browse_keyvalue == null;
				var:'browse_keyvalue'=(keyfield_value);
			/if;
		/inline;
		handle_error;
			var: 'err_msg' = error_msg + ' (' + error_code + ').';
		/handle_error;
	/protect;
	
	if: ($browse_keyvalue != '');
		var:'browse_inline' = (array: -search='', -database=$browse_databasealias, -table=$browse_tablealias, -keyfield=$browse_keyfield, -keyvalue=$browse_keyvalue);

		var: 'add_link' = (var: 'admin_link') +
			'&tab2=detail' +
			'&browse_databaseid=' + $browse_databaseid +
			'&browse_tableid=' + $browse_tableid +
			'&browse_fieldid=' + $browse_fieldid +
			'&browse_keyvalue=' + $browse_keyvalue +
			'&browse_skiprecords=0';
		redirect_url: $add_link;
		abort;

	/if;

/if;

?>
