<?LassoScript

//
// Variables
//

_admin_addvar: -session='_browse', 'browse_datasourceid', -default=1, -override=(action_param: 'browse_datasourceid');
_admin_addvar: -session='_browse', 'browse_hostid', -default=1, -override=(action_param: 'browse_hostid');
_admin_addvar: -session='_browse', 'browse_databaseid', -override=(action_param: 'browse_databaseid');
_admin_addvar: -session='_browse', 'browse_tableid', -override=(action_param: 'browse_tableid');
_admin_addvar: -session='_browse', 'browse_fieldid', -override=(action_param: 'browse_fieldid');

_admin_addvar: -session='_browse', 'browse_keyfield', -default='id', -override=(action_param: 'browse_keyfield');
_admin_addvar: -session='_browse', 'browse_sortfield', -override=(action_param: 'browse_sortfield');
_admin_addvar: -session='_browse', 'browse_sortorder', -override=(action_param: 'browse_sortorder');
_admin_addvar: -session='_browse', 'browse_skiprecords';
_admin_addvar: -session='_browse', 'browse_maxrecords';
_admin_addvar: -session='_browse', 'browse_keyvalue';

_admin_addvar: 'browse_tablesettings', -default=(map); // -session='_browse'
_admin_addvar: 'browse_fieldsettings', -default=(array); // -session='_browse'

_admin_addvar: 'browse_exportformat', -session='_browse', -default='tab', -override=(action_param: 'browse_exportformat');
_admin_addvar: 'browse_exportlines', -session='_browse', -default=(((lasso_version: -platform) >> 'win') ? 'win' | 'unix'), -override=(action_param: 'browse_exportlines');
_admin_addvar: 'browse_exportfields', -session='_browse', -default='y', -override=(action_param: 'browse_exportfields');

_admin_addvar: -session='_browse', 'browse_inline';

_admin_addvar: 'browse_databasename';
_admin_addvar: 'browse_databasealias';
_admin_addvar: 'browse_tablename';
_admin_addvar: 'browse_tablealias';

_admin_addvar: 'browse_action', -default='None', -override=(action_param: 'browse_action');

if: ($browse_datasourceid < 1);
	$browse_datasourceid = 1;
/if;

if: ((action_param: 'header') >> 'Select') && ((action_param: 'browse_navigation') == '');

	var: 'browse_inline' = null;

	if: ((var: 'admin_tab2') == 'update') || ((var: 'admin_tab2') == 'detail');
		redirect_url: (var: 'admin_link') +
			'&tab2=search' +
			'&referrer='  + $admin_tab2 +
			'&browse_databaseid=' + $browse_databaseid +
			'&browse_tableid=' + $browse_tableid +
			'&browse_fieldid=' + $browse_fieldid  +
			'&browse_sortfield=' + $browse_sortfield +
			'&browse_action=' + $browse_action;
		abort;
	else: ((var: 'admin_tab2') == 'list');
		var: 'browse_action' = 'Find All';
		var: 'browse_skiprecords' = 0;
	/if;

	var: 'reset_inline' = true;

/if;


//
// Build Menus
//

var: 'browse_datasourcemap' = (array);
var: 'browse_hostmap' = (array);
var: 'browse_databasemap' = (array);
var: 'browse_tablemap' = (array);
var: 'browse_fieldmap' = (array);

if: ($browse_action >> 'Refresh') && ($browse_datasourceid != 0);
	_admin_refreshsecurity;
/if;

var: 'browse_datasourcemap' = (_admin_listconnectors);
loop: -loopfrom=$browse_datasourcemap->size, -loopto=1, -loopincrement=(-1);
	if: $browse_datasourcemap->(get: loop_count)->second->(find: 'status') != 'enabled';
		$browse_datasourcemap->(remove: loop_count);
	/if;
/loop;
var: 'temp' = (_admin_defaultconnector: -id=$browse_datasourceid, $browse_datasourcemap);
if: ($temp != null);
	var: 'browse_datasourceid' = $temp->first;
	var: 'browse_datasourcedetail' = $temp->second;
	var: 'browse_datasourcealias' = $browse_datasourcedetail->(find: 'alias');
else;
	var: 'browse_datasourceid' = 0;
	var: 'browse_datasourcedetail' = null;
/if;

var: 'browse_datasourcetype' = (_admin_connectortype: $browse_datasourcedetail->(find: 'name'));

if: ($browse_action >> 'Refresh') && ($browse_datasourceid != 0);
	_admin_refreshconnector: $browse_datasourceid;
/if;

if: ($browse_datasourceid > 0);
	var: 'browse_hostmap' = (_admin_listhosts: $browse_datasourceid);
	loop: -loopfrom=$browse_hostmap->size, -loopto=1, -loopincrement=(-1);
		if: $browse_hostmap->(get: loop_count)->second->(find: 'status') != 'enabled';
			$browse_hostmap->(remove: loop_count);
		/if;
	/loop;
	var: 'temp' = (_admin_defaulthost: $browse_hostid, $browse_hostmap);
	if: ($temp != null);
		var: 'browse_hostid' = $temp->first;
		var: 'browse_hostdetail' = $temp->second;
	else;
		var: 'browse_hostid' = 0;
		var: 'browse_hostdetail' = null;
	/if;
else;
	var: 'browse_hostid' = 0;
	var: 'browse_hostdetail' = null;
/if;

if: ($browse_hostid > 0);
	var: 'browse_databasemap' = (_admin_listdatabases: $browse_hostid);
	loop: -loopfrom=$browse_databasemap->size, -loopto=1, -loopincrement=(-1);
		if: $browse_databasemap->(get: loop_count)->second->(find: 'status') != 'enabled';
			$browse_databasemap->(remove: loop_count);
		/if;
	/loop;
	var: 'temp' = (_admin_defaultdatabase: $browse_databaseid, $browse_databasemap);
	if: ($temp != null);
		var: 'browse_databaseid' = $temp->first;
		var: 'browse_databasedetail' = $temp->second;
		var: 'browse_databasename' = $browse_databasedetail->(find: 'name');
		var: 'browse_databasealias' = $browse_databasedetail->(find: 'alias');
	else;
		var: 'browse_databaseid' = 0;
		var: 'browse_databasedetail' = null;
	/if;
else;
	var: 'browse_databaseid' = 0;
	var: 'browse_databasedetail' = null;
/if;

if: ($browse_databaseid > 0);
	var: 'browse_tablemap' = (_admin_listtables: $browse_databaseid);
	loop: -loopfrom=$browse_tablemap->size, -loopto=1, -loopincrement=(-1);
		if: $browse_tablemap->(get: loop_count)->second->(find: 'status') != 'enabled';
			$browse_tablemap->(remove: loop_count);
		/if;
	/loop;
	var: 'temp' = (_admin_defaulttable: $browse_tableid, $browse_tablemap);
	if: ($temp != null);
		var: 'browse_tableid' = $temp->first;
		var: 'browse_tabledetail' = $temp->second;
		var: 'browse_tablename' = $browse_tabledetail->(find: 'name');
		var: 'browse_tablealias' = $browse_tabledetail->(find: 'alias');
	else;
		var: 'browse_tableid' = 0;
		var: 'browse_tabledetail' = null;
	/if;
else;
	var: 'browse_tableid' = 0;
	var: 'browse_tabledetail' = null;
/if;

if: ($browse_tableid > 0);
	var: 'browse_fieldmap' = (_admin_listfields: $browse_tableid);
	var: 'temp' = (_admin_defaultfield: $browse_fieldid, $browse_fieldmap);
	if: ($temp != null);
		var: 'browse_fieldid' = $temp->first;
		var: 'browse_fielddetail' = $temp->second;
		var: 'browse_fieldname' = $browse_fielddetail->(find: 'name');
		var: 'browse_keyfield' = $browse_fielddetail->(find: 'name');
	else;
		var: 'browse_fieldid' = 0;
		var: 'browse_fielddetail' = null;
	/if;
else;
	var: 'browse_fieldid' = 0;
	var: 'browse_fielddetail' = null;
/if;


// 
// Correct browse_sortfield
//

if: ($browse_sortfield == '-');
		var: 'browse_sortfield' = '';
else: ($browse_sortfield != '');
	var: 'need_sortfield' = true;
	iterate: $browse_fieldmap, (var: 'temp');
		if: $temp->second->(find: 'name') == $browse_sortfield;
			var: 'need_sortfield' = false;
			loop_abort;
		/if;
	/iterate;
	if: $need_sortfield;
		var: 'browse_sortfield' = '';
	/if;
/if;

//
// Correct name of 'site' database
//

if: ($browse_datasourceid == 1) && ($browse_databasename == 'site');
	var: 'browse_databasename' = 'lasso_site_1';
/if;


//
// Add Field Types
//

if: (var:'browse_databasealias') && (var:'browse_databasename') && (var:'browse_tablename');
	if: ((var: 'browse_datasourcetype') >> 'mysql');
		
		// Re-order the fields in the order they exist in the actual database
		var: 'browse_fieldorder' = (array);
		
		inline: -log=$__startup_loglevel__, -database=$browse_databasealias, -maxrecords='all', -sql='DESCRIBE `' + $browse_databasename + '`.`' + $browse_tablename + '`';
			records;
				var: 'rawtype' = (field: 'type');
				var: 'type' = $rawtype;
				var: 'param' = '';
				var: 'precision' = '';
	
				if: ($rawtype >> '(');
					var: 'param' = (string_replace
					: $rawtype, -find='([^(]+)\\(([^)]+)\\).*', -replace='\\2');
					var: 'type'  = (string_replaceregexp: $rawtype, -find='([^(]+)\\(([^)]+)\\).*', -replace='\\1');
				else: ($rawtype >> ' ');
					var: 'type'  = (string_replaceregexp: $rawtype, -find='([^ ]+) .*', -replace='\\1');
				/if;
	
				if: ($type >> 'FLOAT') || ($type >> 'DECIMAL') || ($type >> 'DOUBLE');
					if: $param >> ',';
						var: 'precision' = (string_replaceregexp: $param, -find='([^,]+),(.+)', -replace='\\2');
						var: 'param'  = (string_replaceregexp: $param, -find='([^,]+),(.+)', -replace='\\1');
					/if;
				else: ($type >> 'SET') || ($type >> 'ENUM');
					var: 'temp_array'=(string_findregexp: -search='\'[^\']*\'', $param);
					loop: $temp_array->size;
						$temp_array->(get:loop_count)->(removeleading: '\'');
						$temp_array->(get:loop_count)->(removetrailing: '\'');
					/loop;
					var: 'values' = $temp_array;
				/if;
	
				loop: $browse_fieldmap->size;
					var: 'id' = $browse_fieldmap->(get:loop_count)->first;
					var: 'temp' = $browse_fieldmap->(get:loop_count)->second;
					if: ($temp != null) && ($temp->(find: 'name') == (field: 'field'));
						$temp->(insert: 'rawtype'=$rawtype);
						$temp->(insert: 'type'= (string_uppercase: $type));
						$temp->(insert: 'param'= $param);
						$temp->(insert: 'precision'= $precision);
						if: (field: 'null') == 'YES';
							$temp->(insert: 'allownull'='Yes');
						else;
							$temp->(insert: 'allownull'='No');
						/if;
						if: (field: 'rawtype') >> 'BINARY';
							$temp->(insert: 'casesensitive'='Yes');
						/if;
						if: (field: 'rawtype') >> 'UNSIGNED';
							$temp->(insert: 'unsigned'='Yes');
						/if;
						if: ($type >> 'SET') || ($type >> 'ENUM');
							$temp->(insert: 'values'=$values);
						/if;
						$browse_fieldorder->(insert: (pair: $id=$temp));
					//	loop_abort;
					/if;
				/loop;
	
			/records;
		/inline;
			
		var: 'browse_fieldmap' = $browse_fieldorder;
		
	else;
		
		inline: -log=$__startup_loglevel__, -database=$browse_databasealias, -table=$browse_tablename, -show;
			loop: (field_name: -count);
				var: 'rawtype' = (field_name: loop_count, -type);
				var: 'type' = $rawtype;
				var: 'name' = (field_name: loop_count);
	
				loop: $browse_fieldmap->size;
					var: 'id' = $browse_fieldmap->(get:loop_count)->first;
					var: 'temp' = $browse_fieldmap->(get:loop_count)->second;
					if: ($temp != null) && ($temp->(find: 'name') == $name);
						$temp->(insert: 'rawtype'=$rawtype);
						$temp->(insert: 'type'= (string_uppercase: $type));
						$browse_fieldmap->(get: loop_count) = (pair: $id=$temp);
					/if;
				/loop;
	
			/loop;
		/inline;
	/if;
/if;

if: (!var_defined: 'browse_fielddetail') && ($browse_fieldmap->size > 0);
	var: 'browse_fielddetail' = $browse_fieldmap->(find: $browse_fieldid)->(get:1)->second;
	var: 'browse_fieldname' = $browse_fielddetail->(find: 'name');
/if;


//
// Preferences
//

_admin_addvar: 'view_action', -default='Hide', -override=(action_param: 'view_action', (action_param: 'view_action', -count));

if: ($view_action >> 'Reset');
	inline: -log=$__startup_loglevel__, -database='lasso_admin', -sql='DELETE FROM admin_prefs WHERE type=\'table7\' AND database_name=\'' + $browse_databasealias + '\' AND table_name=\'' + $browse_tablealias + '\'';
	/inline;
/if;

if: ($admin_tab2 != 'settings');
	var: 'browse_fieldsettings' = (array);
	inline: -log=$__startup_loglevel__, -database='lasso_admin', -sql='SELECT id,pref_value FROM admin_prefs WHERE type=\'table7\' AND pref_name=\'' + $admin_tab2 + '\' AND database_name=\'' + $browse_databasealias + '\' AND table_name=\'' + $browse_tablealias + '\'';
		var: 'temp'=(field: 'pref_value');
		if: (found_count > 0) && ($temp != '');
			protect;
				$browse_fieldsettings->(unserialize: $temp);
			/protect;
		/if;
	/inline;
/if;

if: ($browse_fieldsettings->type != 'array');
	$browse_fieldsettings = (array);
/if;

loop: $browse_fieldmap->size;
	var: 'temp_name' = $browse_fieldmap->(get: loop_count)->second->(find: 'name');
	if: $browse_fieldsettings->(find: $temp_name) == (array);
		$browse_fieldsettings->(insert: $temp_name = (map));
	/if;
/loop;

inline: -log=$__startup_loglevel__, -database='lasso_admin', -sql='SELECT id,pref_value FROM admin_prefs WHERE type=\'table7\' AND pref_name=\'settings\' AND database_name=\'' + $browse_databasealias + '\' AND table_name=\'' + $browse_tablealias + '\'';
	var: 'browse_tablesettings' = (map);
	var: 'temp'=(field: 'pref_value');
	if: (found_count > 0) && ($temp != '');
		protect;
			$browse_tablesettings->(unserialize: $temp);
		/protect;
	/if;
/inline;

if: ($browse_tablesettings->type != 'map');
	$browse_tablesettings = (map);
/if;

if: ((var: 'browse_tablesettings') == (map)) || ((var: 'browse_tablesettings') == (null));
	var: 'browse_tablesettings' = (map);
	$browse_tablesettings->(insert: 'search_allow' = 'Yes');
	$browse_tablesettings->(insert: 'search_findall' = 'Yes');
	$browse_tablesettings->(insert: 'add_allow' = 'Yes');
	$browse_tablesettings->(insert: 'add_response' = 'Detail');
	$browse_tablesettings->(insert: 'list_allow' = 'Yes');
	$browse_tablesettings->(insert: 'list_jumpdetail' = 'No');
	$browse_tablesettings->(insert: 'list_length' = '50');
	$browse_tablesettings->(insert: 'list_response' = 'Detail');
	$browse_tablesettings->(insert: 'detail_allow' = 'Yes');
	$browse_tablesettings->(insert: 'update_allow' = 'Yes');
	$browse_tablesettings->(insert: 'update_response' = 'Detail');
	$browse_tablesettings->(insert: 'delete_allow' = 'Yes');
	$browse_tablesettings->(insert: 'delete_confirm' = 'Yes');
	$browse_tablesettings->(insert: 'field_readonly' = 'Yes');
	$browse_tablesettings->(insert: 'valuelist_type' = 'Automatic');
	$browse_tablesettings->(insert: 'textfield_type' = 'Automatic');
	$browse_tablesettings->(insert: 'field_readonly' = 'Yes');
	$browse_tablesettings->(insert: 'field_nullblanks' = 'No');
	$browse_tablesettings->(insert: 'field_displaytypes' = 'Yes');
	$browse_tablesettings->(insert: 'field_displaymax' = '64');
	$browse_tablesettings->(insert: 'field_sortorder' = 'Ascending');
/if;

if: ((var: 'view_action') >> 'Apply') || ((var: 'view_action') >> 'Automatic');

	var: 'view_field_insert' = (map);
	var: 'view_table_insert' = (map);

	var: 'view_field_current' = (action_param: 'view_field_current');
	var: 'view_field_move' = (action_param: 'view_field_move');
	var: 'view_field_name' = (action_param: 'view_field_name');

	var: 'view_fieldsettings' = $browse_fieldsettings->(find: $view_field_name)->(get:1)->second;

	search_arguments;
		var: 'name'=(search_fielditem);
		var: 'value'=(search_valueitem);
		if: $name->(beginswith: 'field');
			$name -= 'field_';
			$view_fieldsettings->(insert: $name=$value);
		else: $name->(beginswith: 'table');
			$name -= 'table_';
			$browse_tablesettings->(insert: $name=$value);
		/if;
	/search_arguments;

	$browse_fieldsettings->(removeall: $view_field_name);
	$browse_fieldsettings->(insert: $view_field_name=$view_fieldsettings, (integer: $view_field_move));

	inline: -log=$__startup_loglevel__, -database='lasso_admin', -sql='DELETE FROM admin_prefs WHERE type=\'table7\' AND pref_name=\'' + $admin_tab2 + '\' AND database_name=\'' + $browse_databasealias + '\' AND table_name=\'' + $browse_tablealias + '\'';
	/inline;

	var: 'temp' = '';
	protect;
		var: 'temp' = $browse_fieldsettings->serialize;
	/protect;

	inline: -log=$__startup_loglevel__, -add,
			-database='lasso_admin', 
			-table='admin_prefs',
			'type' = 'table7',
			'database_name' = $browse_databasealias,
			'table_name' = $browse_tablealias,
			'pref_name' = $admin_tab2,
			'pref_value' = $temp,
			-maxrecords=0;
	/inline;
			
	inline: -log=$__startup_loglevel__, -database='lasso_admin', -sql='DELETE FROM admin_prefs WHERE type=\'table7\' AND pref_name=\'settings\' AND database_name=\'' + $browse_databasealias + '\' AND table_name=\'' + $browse_tablealias + '\'';
	/inline;
	
	var: 'temp' = '';
	protect;
		var: 'temp' = $browse_tablesettings->serialize;
	/protect;

	inline: -log=$__startup_loglevel__, -add,
			-database='lasso_admin', 
			-table='admin_prefs',
			'type' = 'table7',
			'database_name' = $browse_databasealias,
			'table_name' = $browse_tablealias,
			'pref_name' = 'sesttings',
			'pref_value' = $temp,
			-maxrecords=0;
	/inline;

/if;


//
// Reorder Field List
//

var: 'temp_map' = (array);
loop: $browse_fieldsettings->size;
	var: 'name' = $browse_fieldsettings->(get: loop_count)->first;
	loop: $browse_fieldmap->size;
		var: 'field' = $browse_fieldmap->(get: loop_count)->second;
		var: 'id' = $browse_fieldmap->(get: loop_count)->first;
		if: $field->(find: 'name') == $name;
			$temp_map->(insert: $id = $field);
			loop_abort;
		/if;
	/loop;
/loop;


var: 'browse_fieldmap' = $temp_map;

if: false && (var_defined: 'admin_tab2_array');
	// Disable other tabs until field array is defined
	if: $browse_fieldmap != (array);
		loop: -loopfrom=2, -loopto=$admin_tab2_array->size;
			$admin_tab2_array->(get:loop_count)->(insert:'active' = true);
			$admin_tab2_array->(get:loop_count)->(insert:'visible' = true);
		/loop;
	else;
		loop: -loopfrom=2, -loopto=$admin_tab2_array->size;
			$admin_tab2_array->(get:loop_count)->(insert:'active' = false);
		/loop;
	/if;

	if: (var_defined: 'admin_tab2') && ($admin_tab2!='detail') && ($admin_tab2!='update');
		if: ($admin_tab2=='settings') || !(var:'browse_keyfield') || !(var:'browse_keyvalue');
			loop: -loopfrom=5, -loopto=6;
				$admin_tab2_array->(get:loop_count)->(insert:'active' = false);
			/loop;
		/if;
	/if;

	if: $browse_tablesettings->(find: 'update_allow') == null;
		$admin_tab2_array->(get:6)->(insert: 'enabled'=false);
	else;
		$admin_tab2_array->(get:6)->(insert: 'enabled'=true);
	/if;
	if: $browse_tablesettings->(find: 'search_allow') == null;
		$admin_tab2_array->(get:2)->(insert: 'enabled'=false);
		$admin_tab2_array->(get:4)->(insert: 'enabled'=false);
		$admin_tab2_array->(get:8)->(insert: 'enabled'=false);
		if: $browse_tablesettings->(find: 'add_allow') == null;
			$admin_tab2_array->(get:5)->(insert: 'enabled'=false);
			$admin_tab2_array->(get:6)->(insert: 'enabled'=false);
		/if;
	else;
		$admin_tab2_array->(get:2)->(insert: 'enabled'=true);
		$admin_tab2_array->(get:4)->(insert: 'enabled'=true);
		$admin_tab2_array->(get:8)->(insert: 'enabled'=true);
		$admin_tab2_array->(get:5)->(insert: 'enabled'=true);
	/if;
	if: $browse_tablesettings->(find: 'add_allow') == null;
		$admin_tab2_array->(get:3)->(insert: 'enabled'=false);
		$admin_tab2_array->(get:7)->(insert: 'enabled'=false);
	else;
		$admin_tab2_array->(get:3)->(insert: 'enabled'=true);
		$admin_tab2_array->(get:7)->(insert: 'enabled'=true);
		$admin_tab2_array->(get:5)->(insert: 'enabled'=true);
	/if;

	if: (var_defined: 'admin_tab2') && ($admin_tab2 != 'settings') && ($browse_fieldmap == (array));

		redirect_url: (var: 'admin_file') + '?tab1=' + $admin_tab1 +
			'&tab2=' + $admin_tab2 +
			'&tab2=search' +
			'&referrer='  + $admin_tab2 +
			'&browse_databaseid=' + $browse_databaseid +
			'&browse_tableid=' + $browse_tableid +
			'&browse_fieldid=' + $browse_fieldid  +
			'&browse_sortfield=' + $browse_sortfield +
			'&browse_action=' + $browse_action;
		abort;
	/if;

/if;

?>
