<?LassoScript

//
// Variables
//

_admin_addvar: 'browse_action', -default='none', -override=(action_param: 'browse_action');
_admin_addvar: 'dialog_action', -default='none', -override=(action_param: 'dialog_action');
_admin_addvar: 'browse_referrer', -default='search', -override=(action_param: 'browse_referrer');

_admin_addvar: 'browse_keyvalue', -override=(action_param: 'browse_keyvalue');
_admin_addvar: 'browse_skiprecords', -default=0, -override=(action_param: 'browse_skiprecords');
_admin_addvar: 'found_count', -default=0, -override=(action_param: 'found_count');

_admin_addvar: 'browse_navigation', -override=(action_param: 'browse_navigation');

var: 'browse_maxrecords' = 1;

var: 'browse_skiprecords' = (integer: $browse_skiprecords);
var: 'browse_maxrecords' = (integer: $browse_maxrecords);
var: 'found_count' = (integer: $found_count);

if: ($browse_navigation >> 'Next');
	$browse_skiprecords = (integer: ($browse_skiprecords + $browse_maxrecords));
else: ($browse_navigation >> 'Prev');
	$browse_skiprecords = (integer: (math_max: $browse_skiprecords - $browse_maxrecords, 0));
else: ($browse_navigation >> 'Last');
	$browse_skiprecords = (integer: (var: 'found_count'));
else: ($browse_navigation >> 'First') || ($browse_navigation >> 'Sort');
	$browse_skiprecords = 0;
else: ($browse_navigation >> 'Jump') || (($browse_referrer == $admin_tab2) && ((action_param: 'browse_navigation_skip') != ''));
	$browse_skiprecords = (math_max: (integer: (action_param: 'browse_navigation_skip')) - 1, 0);
/if;

if: ($browse_skiprecords > 0) && ((integer: (var: 'found_count')) > 0);
	$browse_skiprecords = (math_max: (math_min: (integer: (var: 'found_count')) - 1, $browse_skiprecords), 0);
/if;


// -----------
// main

if: ($browse_action >> 'Update');

	var: 'update_inline' = (array: -update='', -database=$browse_databasealias, -table=$browse_tablealias, -keyfield=$browse_keyfield, -keyvalue=$browse_keyvalue);

	loop: $browse_fieldmap->size;
		var: 'temp'=$browse_fieldmap->(get: loop_count)->second;
		var: 'name'=$temp->(find: 'name');
		var: 'value'=(action_param: 'update_' + $name);
		if: ($temp->(find: 'type') == 'SET');
			var: 'value' = (string_replace: -find='\r', -replace=',', $value);
		/if;
		if: (if_null: $temp->(find: 'update_allow'), 'Yes') != 'No';
			$update_inline->(insert: (string: $name) = (string:$value));
		/if;
	/loop;

	inline: $update_inline;
		var:'found_count'=found_count, 'shown_first'=shown_first, 'shown_last'=shown_last;
		var:'browse_keyvalue'=(keyfield_value);
		if: (error_currenterror) == (error_noerror);
			var:'update_message' = 'The record was updated successfully.';
		else;
			var:'update_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
		/if;
	/inline;

else: ($dialog_action >> 'Delete');

	if: ($browse_databasealias != '') && ($browse_tablealias != '') && ($browse_keyfield != '') && ($browse_keyvalue != '');
		inline: -delete,
			-database=$browse_databasealias,
			-table=$browse_tablealias,
			-keyfield=$browse_keyfield,
			-keyvalue=$browse_keyvalue;
		/inline;

		$browse_keyvalue = '';

		var: 'delete_link' = (var: 'admin_link') +
			'&tab2=detail' +
			'&browse_databaseid=' + $browse_databaseid +
			'&browse_tableid=' + $browse_tableid +
			'&browse_fieldid=' + $browse_fieldid +
			'&browse_skiprecords=' + $browse_skiprecords +
			'&found_count=' + ((integer: $found_count) - 1);
		redirect_url: $delete_link;
		abort;

	/if;
/if;

if: ($browse_keyvalue != '') && ($browse_inline == null) || ( ($browse_inline->(find: -search) == (array)) && ($browse_inline->(find: -findall) == (array)) );
	var:'detail_inline' = (array: -search='', -database=$browse_databasealias, -table=$browse_tablealias, -keyfield=$browse_keyfield), -keyvalue=$browse_keyvalue;
else;
	var: 'detail_inline' = $browse_inline;

	if: ($browse_sortfield != '');
		$detail_inline->(insert: (pair: '-sortfield'=$browse_sortfield));
		if: ($detail_inline != '');
			$detail_inline->(insert: (pair: '-sortorder'=$browse_sortorder));
		/if;
	/if;

	$detail_inline->(insert: (pair: '-skiprecords'=$browse_skiprecords));
/if;

$detail_inline->(insert: (pair: '-maxrecords'=$browse_maxrecords));

inline: $detail_inline, -inlinename='browse_results';
	var:'found_count'=found_count, 'shown_first'=shown_first, 'shown_last'=shown_last, 'shown_count'=shown_count;
	$browse_keyvalue = (keyfield_value);
/inline;

if: (var:'found_count') == 0;

	var: 'detail_link' = (var: 'admin_link') +
		'&tab2=' + $browse_referrer +
		'&browse_databaseid=' + $browse_databaseid +
		'&browse_tableid=' + $browse_tableid +
		'&browse_keyfield=' + $browse_keyfield  +
		'&err=1&err_msg=No+records+found';
	redirect_url: $detail_link;
	abort;

/if;

?>