<?LassoScript

//
// Variables
//

_admin_addvar: 'build_action', -default='None', -override=(action_param: 'build_action', 1);
_admin_addvar: 'build_datasourceid', -default='1', -session='_browse', -override=(action_param: 'build_datasourceid');
_admin_addvar: 'build_hostid', -session='_browse', -override=(action_param: 'build_hostid');
_admin_addvar: 'build_databaseid', -session='_browse', -override=(action_param: 'build_databaseid');

_admin_addvar: 'build_alias', -override=(action_param: 'build_alias');
_admin_addvar: 'build_enabled', -override=(action_param: 'build_enabled');

_admin_addvar: 'create_action', -default='None', -override=(action_param: 'create_action', 1);
_admin_addvar: 'create_datasourceid', -default='1', -session='_browse', -override=(action_param: 'create_datasourceid');
_admin_addvar: 'create_hostid', -session='_browse', -override=(action_param: 'create_hostid');
_admin_addvar: 'create_databaseid', -session='_browse', -override=(action_param: 'create_databaseid');

_admin_addvar: 'create_name', -default='New_Database', -override=(action_param: 'create_name');
_admin_addvar: 'create_enabled', -override=(action_param: 'create_enabled');
_admin_addvar: 'create_data', -default='No', -override=(action_param: 'create_data', (action_param: 'create_data', -count));

_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');


//
// Process Action
//

if: ($build_action >> 'Update') || ($dialog_action >> 'Delete') || ($build_action >> 'Detail');

	var: 'build_databasedetail' = (admin_database: -id=$build_databaseid);

	var: 'datasource_type' = $build_databasedetail->datasource->(find: 'name');
	
	if: ($build_action >> 'Update');
	
		$build_databasedetail->(insert: 'alias' = $build_alias);
		$build_databasedetail->(insert: 'enabled' = $build_enabled);
		$build_databasedetail->store;
	
		var: 'build_action' = 'Detail';

	else: ($dialog_action >> 'Delete');
	
		if: ($datasource_type == 'sqliteconnector');
			
			file_delete: (admin_lassoservicepath + '/SQLiteDBs/' + $build_databasedetail->(find: 'name'));

		else;
		
			inline: -database=$build_databasedetail->(find: 'alias'), -sql='DROP DATABASE ' + $build_databasedetail->(find: 'name');
				if: (error_currenterror) != (error_noerror);
					var: 'build_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
				/if;
			/inline;
			
		/if;
		
		_admin_deletedatabase: $build_databaseid;
	
		var: 'build_action' = 'Refresh';

	/if;
	
else: $build_action >> 'Create Table';

	var: 'link' = $admin_link + '&tab2=tables' +
		'&build_datasourceid=' + $build_datasourceid +
		'&build_hostid=' + $build_hostid +
		'&build_databaseid=' + $build_databaseid +
		'&build_action=Create+Table';
	redirect_url: $link;

else: $build_action >> 'List Tables';

	var: 'link' = $admin_link + '&tab2=tables' +
		'&build_datasourceid=' + $build_datasourceid +
		'&build_hostid=' + $build_hostid +
		'&build_databaseid=' + $build_databaseid;
	redirect_url: $link;

else: ($build_action >> 'Create') || ($build_action >> 'Duplicate');

	if: ($create_action >> 'Create');

		protect;
			var: 'build_databaseid' = (admin_host: -id=$build_hostid)->(createdatabase: -name=$create_name, -enabled=$create_enabled);
			var: 'build_databasedetail' = (admin_database: -id=$build_databaseid);
			var: 'build_action' = 'Detail';
			
			handle_error;
				var: 'build_error' = error_msg + ' (' + error_code + ').';
			/handle_error;
			
		/protect;
		
	else: ($create_action >> 'Duplicate');
	
		var: 'build_navigation' = 'last';

		// Create Database

		protect;
			var: 'build_databaseid' = (admin_host: -id=$build_hostid)->(createdatabase: -name=$create_name, -enabled=$create_enabled);
			var: 'build_databasedetail' = (admin_database: -id=$build_databaseid);
			var: 'build_action' = 'Detail';

			// Copy Tables
		
			var: 'build_type' = $build_databasedetail->datasource->(find: 'name');
			var: 'create_databasedetail' = (admin_database: -id=$create_databaseid);
	
			iterate: $create_databasedetail->tables, (var: 'temp_table');
				var: 'new_sql' = $temp_table->(sql: $build_type);
				if: $new_sql != '';
					var: 'new_id' = $build_databasedetail->(createtable: -name=$temp_table->(find: 'name'), -sql=$new_sql, -enabled=$create_enabled);
					if: $create_data >> 'Yes';
						var: 'new_table' = (admin_table: $new_id);
						if: $create_databasedetail->host->(find: 'id') == $build_databasedetail->host->(find: 'id');
							$new_table->(copydata: $create_databasedetail->(find: 'alias'), $temp_table->(find: 'alias'), -direct);
						else;
							$new_table->(copydata: $create_databasedetail->(find: 'alias'), $temp_table->(find: 'alias'));
						/if;
					/if;
				/if;
			/iterate;
			
			handle_error;
				var: 'build_error' = error_msg + ' (' + error_code + ').';
			/handle_error;
			
		/protect;

	else;
		
		if: $create_datasourceid != $build_datasourceid;
			// Set the database id so the right host is shown
			var: 'create_datasourceid' = $build_datasourceid;
			var: 'create_hostid' = $build_hostid;
			var: 'create_databaseid' = $build_databaseid;
		/if;
		
	/if;

/if;

if: ($build_action >> 'Refresh');
	_admin_refreshsecurity;
	if: ($build_action >> 'Refresh') && ($build_datasourceid != 0);
		_admin_refreshconnector: $build_datasourceid;
	/if;
/if;

?>