<?LassoScript

//
// Variables
//

_admin_addvar: 'build_action', -default='None', -override=(action_param: 'build_action', (action_param: 'build_action', -count));
_admin_addvar: 'build_datasourceid', -default='1', -session='_browse', -override=(action_param: 'build_datasourceid');
_admin_addvar: 'build_hostid', -session='_browse', -override=(action_param: 'build_hostid');
_admin_addvar: 'build_databaseid', -session='_browse', -override=(action_param: 'build_databaseid');
_admin_addvar: 'build_tableid', -session='_browse', -override=(action_param: 'build_tableid');
_admin_addvar: 'build_indexid', -session='_browse', -override=(action_param: 'build_indexid');

_admin_addvar: 'database_name', -override=(action_param: 'database_name');
_admin_addvar: 'database_alias', -override=(action_param: 'database_alias');

_admin_addvar: 'table_name', -override=(action_param: 'table_name');
_admin_addvar: 'table_alias', -override=(action_param: 'table_alias');
_admin_addvar: 'table_enabled', -override=(action_param: 'table_enabled');

_admin_addvar: 'create_datasourceid', -default='1', -session='_browse', -override=(action_param: 'create_datasourceid');
_admin_addvar: 'create_hostid', -session='_browse', -override=(action_param: 'create_hostid');
_admin_addvar: 'create_databaseid', -session='_browse', -override=(action_param: 'create_databaseid');
_admin_addvar: 'create_tableid', -session='_browse', -override=(action_param: 'create_tableid');

_admin_addvar: 'create_action', -default='None', -override=(action_param: 'create_action');
_admin_addvar: 'create_name', -default='New_Index', -override=(action_param: 'create_name');
_admin_addvar: 'create_options', -override=(action_param: 'create_options');

var: 'create_fields' = (array);
loop: (action_param: 'create_fields', -count);
	$create_fields->(insert: (action_param: 'create_fields', loop_count));
/loop;

var: 'create_options' = (array);
loop: (action_param: 'create_options', -count);
	$create_options->(insert: (action_param: 'create_options', loop_count));
/loop;


_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');

var: 'reserved_words' = (array:
	'add','all','alter','analyze','and','as','asc','auto_increment','bdb',
	'berkeleydb','between','bigint','binary','blob','both','by','cascade',
	'case','change','char','character','column','columns','constraint',
	'create','cross','current_date','current_time','current_timestamp',
	'database','databases','day_hour','day_minute','day_second','dec',
	'decimal','default','delayed','delete','desc','describe','distinct',
	'distinctrow','double','drop','else','enclosed','escaped','exists',
	'explain','fields','float','for','foreign','from','fulltext','function',
	'grant','group','having','high_priority','hour_minute','hour_second',
	'if','ignore','in','index','infile','inner','innodb','insert','int',
	'integer','interval','into','is','join','key','keys','kill','leading',
	'left','like','limit','lines','load','lock','long','longblob','longtext',
	'low_priority','master_server_id','match','mediumblob','mediumint',
	'mediumtext','middleint','minute_second','mrg_myisam','natural','not',
	'null','numeric','on','optimize','option','optionally','or','order',
	'outer','outfile','partial','precision','primary','privileges',
	'procedure','purge','read','real','references','regexp','rename',
	'replace','require','restrict','returns','revoke','right','rlike',
	'select','set','show','smallint','soname','sql_big_result',
	'sql_calc_found_rows','sql_small_result','ssl','starting','straight_join',
	'striped','table','tables','terminated','then','tinyblob','tinyint',
	'tinytext','to','trailing','union','unique','unlock','unsigned','update',
	'usage','use','user_resources','using','values','varbinary','varchar',
	'varying','when','where','with','write','xor','year_month','zerofill');

//
// Process Action
//
var: 'build_tabledetail' = (admin_table: -id=$build_tableid);
var: 'build_indexmap' = $build_tabledetail->(indices);

var: 'datasource_type' = $build_tabledetail->datasource->(find: 'name');

if: ($dialog_action >> 'Delete');

	var: 'build_error' = '';
	
	select: $datasource_type;
		case: 'sqliteconnector';

			inline: -database=$build_tabledetail->database->(find: 'alias'), -sql='DROP INDEX ' + (encode_sql: $build_indexid);
				if: (error_currenterror) != (error_noerror);
					var: 'build_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
				/if;
			/inline;

			var: 'build_indexmap' = $build_tabledetail->(indices);
			var: 'build_indexid' = null;
			var: 'build_action' = 'none';

		case: 'mysqlds';
				
			inline: -database=$build_tabledetail->database->(find: 'alias'), -sql='ALTER TABLE `' + $build_tabledetail->(find: 'name') + '` DROP INDEX ' + (encode_sql: $build_indexid);
				if: (error_currenterror) != (error_noerror);
					var: 'build_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
				/if;
			/inline;

			var: 'build_indexmap' = $build_tabledetail->(indices);
			var: 'build_indexid' = null;
			var: 'build_action' = 'none';

		case;
		
	/select;
	
	var: 'build_action' = 'Refresh';

else: $build_action >> 'Create';

	var: 'build_error' = '';

	if: ($create_action >> 'Create');

		select: $datasource_type;
			case: 'sqliteconnector';
		
				var: 'temp_options' = '';
				if: $create_options >> 'UNIQUE';
					$temp_options += 'UNIQUE ';
				/if;
				inline: -database=$build_tabledetail->database->(find: 'alias'), -sql='CREATE ' + $temp_options + 'INDEX ' + (encode_sql: $create_name) + ' ON ' + $build_tabledetail->(find: 'name') + ' (' + $create_fields->(join: ',') + ')';
					if: (error_currenterror) != (error_noerror);
						var: 'build_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
					/if;
				/inline;
	
				var: 'build_indexmap' = $build_tabledetail->(indices);
				var: 'build_indexid' = $create_name;
				var: 'build_action' = 'detail';
	
			case: 'mysqlds';
					
				var: 'temp_options' = '';
				if: $create_options >> 'UNIQUE';
					$temp_options += 'UNIQUE ';
				else: $create_options >> 'FULLTEXT';
					$temp_options += 'FULLTEXT ';
				else: $create_options >> 'SPATIAL';
					$temp_options += 'SPATIAL ';
				/if;
				inline: -database=$build_tabledetail->database->(find: 'alias'), -sql='ALTER TABLE `' + $build_tabledetail->(find: 'name') + '` ADD ' + $temp_options + ' INDEX ' + (encode_sql: $create_name) + ' (' + $create_fields->(join: ',') + ')';
					if: (error_currenterror) != (error_noerror);
						var: 'build_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
					/if;
				/inline;
	
				var: 'build_indexmap' = $build_tabledetail->(indices);
				var: 'build_indexid' = $create_name;
				var: 'build_action' = 'detail';
	
			case;
			
		/select;
			
	/if;

/if;

if: ($build_indexmap->size > 0);
	var: 'build_indexdetail' = $build_indexmap->first;
/if;
if: ($build_indexid != '');
	iterate: $build_indexmap, (var: 'temp_index');
		if: ($temp_index->(find: 'name') == $build_indexid);
			var: 'build_indexdetail' = $temp_index;
			loop_abort;
		/if;
	/iterate;
/if;

var: 'create_name' = 'New_Index' + ($build_indexmap->size + 1);

if: ($build_action >> 'Refresh');
	_admin_refreshsecurity;
	if: ($build_action >> 'Refresh') && ($build_datasourceid != 0);
		_admin_refreshconnector: $build_datasourceid;
	/if;
/if;

?>
