<?LassoScript

	_admin_addvar: -name='groupadmin_action', -default='None', -override=(action_param: 'groupadmin_action');
	_admin_addvar: -name='user_name', -default='', -override=(action_param: 'user_name');
	_admin_addvar: -name='user_pass', -default='', -override=(action_param: 'user_pass');
	_admin_addvar: -name='user_groups', -default=(array);

	var: 'success'=false;
	var: 'error'=false;

	if: ($groupadmin_action >> 'Add');
	
		var: 'user_groups' = (array);
		loop: (action_param: 'user_groups', -count);
			var: 'temp' = (action_param: 'user_groups', loop_count);
			if: $temp != '';
				$user_groups->(insert: $temp);
			/if;
		/loop;

		if: ($user_name == '');
			var: 'error' = true;
			var: 'error_msg' = 'Please specify a username.';
		else: ($user_pass == '');
			var: 'error' = true;
			var: 'error_msg' = 'Please specify a password.';
		else: ($user_groups->size == 0);
			var: 'error' = true;
			var: 'error_msg' = 'Please select one or more groups.';
		/if;
		
		if: $error == false;
			var: 'result'=(admin_createuser: (var: 'user_name'), (var: 'user_pass'));
	
			if: ($result == true);
				var: 'success'=true;
				var: 'success_msg'='The user "' + $user_name + '" was created.';
			else;
				var: 'error'=true;
				var: 'error_msg'='A user with the username "' + $user_name + '" already exists.';
			/if;
		/if;
		
		if: $error == false;
			var: 'result' = false;
			iterate: $user_groups, (var: 'temp_new');
				var: 'result' = (admin_groupassignuser: $temp_new, (var: 'user_name')) || $result;
			/iterate;
		
			if: ($result == true) && ($success == true);
				var: 'success'=true;
				var: 'success_msg'='The user was created and added to the selected groups.';
			else: ($result == true);
				var: 'success'=true;
				var: 'success_msg'='The existing user was added to the selected groups.';
			else;
				var: 'error'=true;
				var: 'error_msg'='The user "' + $user_name + '" could not be assigned to the selected groups.';
			/if;

		/if;

		_security_flushcaches;
		
	/if;

	var: 'groupadmin_groups' = (admin_listgroups);

	if: $groupadmin_groups == false;
		var: 'groupadmin_groups' = array;
	/if;

	$groupadmin_groups->(removeall: 'ANYUSER');
	$groupadmin_groups->(removeall: 'ADMINISTRATORS');
		
	if: (var: 'success') == true;
		var: 'user_name' = '';
		var: 'user_pass' = '';
		var: 'user_groups' = (array);
	/if;
?>