<?LassoScript

	//
	// Store Search Variables in Session
	//
	
	_admin_addvar: 'ls_action', -override=(action_param: 'action', (action_param: 'action', -count)), -default='None';
	_admin_addvar: -session='_reference', 'ls_toggle', -override=(action_param: 'toggle', (action_param: 'toggle', -count)), -default='';
	
	_admin_addvar: -session='_reference', 'ls_tag', -override=(action_param: 'tag');
	_admin_addvar: -session='_reference', 'ls_category', -override=(action_param: 'cat');
	_admin_addvar: -session='_reference', 'ls_type', -override=(action_param: 'type');
	_admin_addvar: -session='_reference', 'ls_set', -override=(action_param: 'set'), -default='Any';
	_admin_addvar: -session='_reference', 'ls_support', -override=(action_param: 'support'), -default='Preferred';
	_admin_addvar: -session='_reference', 'ls_change', -override=(action_param: 'change'), -default='Any';
	_admin_addvar: -session='_reference', 'ls_description', -override=(action_param: 'description'), -default='Any';

	if: ($client_getparams->size > 0);

		var: 'param_type' = (array);
		
		iterate: $client_getparams, (var: 'param');
			if: $param->(beginswith: '[') || $param->(beginswith: '-');
				var: 'ls_id' = $param;
			else: $param->(beginswith: '@');
				var: 'ls_id' = (integer: $param - '@');
			else: $param == (string: (integer: $param));
				var: 'ls_id' = (integer: $param);
			else: $param->(beginswith: '!');
				$param_type->(insert: 'delete');
				$param >> 'tag' ? var: 'ls_tag' = '';
				$param >> 'cat' ? var: 'ls_category' = 'any';
				$param >> 'typ' ? var: 'ls_type' = 'any';
				$param >> 'set' ? var: 'ls_set' = 'any';
				$param >> 'sup' ? var: 'ls_support' = 'any';
				$param >> 'cha' ? var: 'ls_change' = 'any';
				$param >> 'des' ? var: 'ls_description' = 'any';
			else: (array: 'container', 'command', 'data type', 'delimiters', 'member', 'proces', 'substitution', 'symbol') >> $param;
				$param_type->(insert: 'type');
				var: 'ls_type' = $param;
			else: (array: 'action', 'administration', 'array', 'bytes', 'client', 'comparator', 'conditional', 'constant', 'custom tag', 'data type', 'database', 'date', 'delimeter', 'email', 'encoding', 'encryption', 'error', 'file', 'image', 'include', 'javabeans', 'link', 'matchers', 'math', 'namespace', 'networking', 'operator', 'output', 'pdf', 'response', 'results', 'session', 'string', 'symbol', 'tags', 'techical', 'threads', 'utility', 'variable', 'xml') >> $param;
				$param_type->(insert: 'category');
				var: 'ls_category' = $param;
			else: (array: 'new', 'updated', 'unchanged') >> $param;
				$param_type->(insert: 'change');
				var: 'ls_change' = $param;
			else: (array: 'preferred', 'deprecated', 'synonym','abbreviation') >> $param;
				$param_type->(insert: 'support');
				var: 'ls_support' = $param;
			else: (string_replaceregexp: $param, -find='(lasso|ldml)[0-9\\.]+', -replace='', -ignorecase) == '';
				$param_type->(insert: 'set');
				$param -= 'lasso';
				$param -= '.';
				($param !>> 'ldml') ? $param = 'ldml' + $param;
				if: ($param->size == 5);
					$param += ((($param >> '1') || ($param >> '3')) ? 'x' | '');
					$param += ((($param !>> '1') && ($param !>> '3')) ? '0' | '');
				/if;
				var: 'ls_set' = ($param == 'ldml' ? 'any' | 'ldml');
			else;
				$param_type->(insert: 'tag');
				var: 'ls_tag' = $param;
			/if;
		/iterate;
		
		if: (var: 'ls_id') != '';
		
			inline: $ref_tag_inline, -search, -log=$__startup_loglevel__, -opbegin='or', -op='eq', 'tag_id' = $ls_id, -op='eq', 'tag_name' = $ls_id, -opend='or', -maxrecords=1, -returnfield='tag_id', -returnfield='tag_name';
				if: (found_count == 1);
					var: 'ls_id' = (field: 'tag_id');
					$param_type->(insert: 'id');
				else;
					inline: $ref_tag_inline, -search, -log=$__startup_loglevel__, -op='bw', 'tag_name' = $ls_id, -maxrecords=1, -returnfield='tag_id', -returnfield='tag_name';
						if: (found_count == 1);
							var: 'ls_id' = (field: 'tag_id');
							$param_type->(insert: 'id');
						/if;
					/inline;
				/if;
			/inline;
			if: $param_type !>> 'id';
				$param_type->(insert: 'tag');
				var: 'ls_tag' = $ls_id;
				var: 'ls_id' = '';
			/if;		
		/if;
 		
 		if: (($param_type !>> 'id') && ($param_type !>> 'delete')) || ($param_type->size > 1);
			$param_type !>> 'tag' ? var: 'ls_tag' = '';
			$param_type !>> 'category' ? var: 'ls_category' = 'any';
			$param_type !>> 'type' ? var: 'ls_type' = 'any';
			$param_type !>> 'set' ? var: 'ls_set' = 'any';
			$param_type !>> 'support' ? var: 'ls_support' = 'any';
			$param_type !>> 'change' ? var: 'ls_change' = 'any';
		/if;
	
		if: ($param_type->size > 0);
			var: 'admin_tab2' = 'browse';
			var: 'ls_action' = 'quick';
		else;
			var: 'admin_tab2' = 'basics';
		/if;
	/if;
	
	_admin_addvar: -session='_reference', 'ls_sort', -override=(action_param: 'sort'), -default='Name';
	_admin_addvar: -session='_reference', 'ls_maxrecords', -override=(action_param: 'max'), -default=100;
	_admin_addvar: -session='_reference', 'ls_skiprecords', -override=(action_param: 'skip'), -default=0;
	_admin_addvar: -session='_reference', 'ls_foundcount', -default=0;
		
	//
	// Overrides
	//
	
	if: ($ls_action >> 'Search') || ($ls_action >> 'Find All');
		if: (action_param: 'tag') == '';
			var: 'ls_tag' = '';
		/if;
		if: (action_param: 'description') == '';
			var: 'ls_description' = '';
		/if;
	/if;


	//
	// Base Inline
	//

	variable: 'ls_inline' = array;
	

	//
	// Search Parameters
	//

	$ls_inline->(insert: -op='eq');
	$ls_inline->(insert: 'tag_display' = 'Y');

	if: ($ls_action >> 'Find All');
		var: 'ls_foundcount'=0;
		var: 'ls_skiprecords'=0;
		var: 'ls_id' = '';
		var: 'ls_tag' = '';
		var: 'ls_category' = 'Any';
		var: 'ls_type' = 'Any';
		var: 'ls_set' = 'Any';
		var: 'ls_support' = 'Any';
		var: 'ls_platform' = 'Any';
		var: 'ls_datasource' = 'Any';
		var: 'ls_description' = '';
		var: 'ls_edition' = 'Any';
		var: 'ls_version' = 'Any';
		var: 'ls_change' = 'Any';
		var: 'ls_security' = 'Any';
		var: 'ls_implementation' = 'Any';
		var: 'ls_sourceavailable' = 'Any';
		var: 'ls_output' = '';
	else: ($ls_action >> 'search') || ($ls_action >> 'quick');
		var: 'ls_foundcount'=0;
		var: 'ls_skiprecords'=0;
	/if;
	
	if: ((var:'ls_tag') == 'Any');
		var: 'ls_tag' = '';
	else: ((var:'ls_tag') != '');
		$ls_inline->(insert: -op='cn');
		$ls_inline->(insert: 'tag_name'=(var: 'ls_tag'));
	/if;
	if: ((var:'ls_category') != 'Any') && ((var:'ls_category') != '');
		$ls_inline->(insert: 'tag_category'=(var: 'ls_category'));
	/if;
	if: ((var:'ls_type') != 'Any') && ((var:'ls_type') != '');
		$ls_inline->(insert: 'tag_type'=(var: 'ls_type'));
	/if;
	if: ((var:'ls_set') != 'Any') && ((var:'ls_set') != '');
		$ls_inline->(insert: -op='cn');
		$ls_inline->(insert: 'tag_language'=(var: 'ls_set'));
	/if;
	if: ((var:'ls_support') != 'Any') && ((var:'ls_support') != '');
		$ls_inline->(insert: 'tag_support'=(var: 'ls_support'));
	/if;
	if: ((var:'ls_platform') != 'Any') && ((var:'ls_platform') != '');
		$ls_inline->(insert: 'tag_platform'=(var: 'ls_platform'));
	/if;
	if: ((var:'ls_datasource') != 'Any') && ((var:'ls_datasource') != '');
		$ls_inline->(insert: 'tag_datasource'=(var: 'ls_datasource'));
	/if;
	if: ((var:'ls_description') == 'Any');
		var: 'ls_description' = '';
	else: ((var:'ls_description') != '');
		$ls_inline->(insert: -opbegin='or');
		$ls_inline->(insert: -op='cn');
		$ls_inline->(insert: 'tag_description'=(var: 'ls_description'));
		$ls_inline->(insert: -op='cn');
		$ls_inline->(insert: 'tag_syntax'=(var: 'ls_description'));
		$ls_inline->(insert: -op='cn');
		$ls_inline->(insert: 'tag_changenotes'=(var: 'ls_description'));
		$ls_inline->(insert: -opend='or');
	/if;
	if: ((var:'ls_edition') != 'Any') && ((var:'ls_edition') != '');
		$ls_inline->(insert: 'tag_edition'=(var: 'ls_edition'));
	/if;
	if: ((var:'ls_version') != 'Any') && ((var:'ls_version') != '');
		$ls_inline->(insert: 'tag_version'=(var: 'ls_version'));
	/if;
	if: ((var:'ls_change') != 'Any') && ((var:'ls_change') != '');
		$ls_inline->(insert: 'tag_history'=(var: 'ls_change'));
	/if;
	if: ((var:'ls_output') != 'Any') && ((var:'ls_output') != '');
		$ls_inline->(insert: -op='cn');
		$ls_inline->(insert: 'tag_output'=(var: 'ls_output'));
	/if;
	if: ((var:'ls_security') != 'Any') && ((var:'ls_security') != '');
		$ls_inline->(insert: -op='cn');
		$ls_inline->(insert: 'tag_security'=(var: 'ls_security'));
	/if;
	if: ((var:'ls_implementation') != 'Any') && ((var:'ls_implementation') != '');
		$ls_inline->(insert: -op='cn');
		$ls_inline->(insert: 'tag_implementation'=(var: 'ls_implementation'));
	/if;
	if: ((var:'ls_sourceavailable') != 'Any') && ((var:'ls_sourceavailable') != '');
		$ls_inline->(insert: -op='cn');
		$ls_inline->(insert: 'tag_sourceavailable'=(var: 'ls_sourceavailable'));
	/if;
	if: ((var:'ls_id') != '');
		$ls_inline->(insert: -opbegin='and', 1);
		$ls_inline->(insert: -opbegin='or', 1);
		$ls_inline->(insert: -opend='and');
		$ls_inline->(insert: -op='eq');
		$ls_inline->(insert: 'tag_id'=(var: 'ls_id'));
		$ls_inline->(insert: -opend='or');
	/if;

	//
	// Inline Parameters
	//
	
	$ls_inline->(merge: $ref_tag_inline);
	$ls_inline->(insert: -search='');
	$ls_inline->(insert: -maxrecords=(math_range: (integer: $ls_maxrecords), 10, 100));

	//
	// Sorting Parameters
	//

	if: ($ls_sort >> 'Type');
		$ls_inline->(insert: -SortField='tag_type');
	else: ($ls_sort >> 'Set');
		$ls_inline->(insert: -SortField='tag_language');
	else: ($ls_sort >> 'Support');
		$ls_inline->(insert: -SortField='tag_support');
	/if;
	$ls_inline->(insert: -SortField='tag_sort');

	if: ((var: 'ls_id') != '') || ($ls_action >> 'search') || ($ls_action >> 'find all') || ($ls_action >> 'quick');
		inline: -log=$__startup_loglevel__, $ls_inline, -maxrecords='all', -returnfield='tag_id';
			var: 'ls_foundcount' = found_count;
			if: ((var: 'ls_id') != '');
				var: 'ls_skiprecords' = 1;
				iterate: (records_array), (var: 'temp');
					if: $temp->first == $ls_id;
						var: 'ls_skiprecords' = loop_count - 1;
						loop_abort;
					/if;
				/iterate;
			/if;
		/inline;
		if: ($ls_foundcount == 1) || ((var: 'ls_id') != '');
			var: 'admin_tab2' = 'detail';
		else;
			var: 'admin_tab2' = 'browse';
		/if;
	/if;

?>
