<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">

<div class="content_split_solo">
	<div class="content_left">
		<h2>Chart FX Activation</h2>
[if: (lasso_tagexists: 'chartfx')]
		<p class="error">
			The Chart FX module is not installed.
		</p>
[else]
		<table>
			<tr>
				<th>Serial Number</th>
				<td>
					<input type="text" name="chartfx_serial_number" size="32" value="[var:'chartfx_serialdisplay']" class="large">
				</td>
			</tr>
			<tr>
				<th>Status</th>
				<td>[var: 'chartfx_status']</td>
			</tr>
[if: $chartfx_status >> 'pending' && (var: 'chartfx_error') == '']			
			<tr><th>&nbsp;</th></tr>			
			<tr>
				<th></th>
				<td class="red">
					An error has occurred activating Chart FX.  
					In order to activate Chart FX you will need to follow these steps.
				</td>
			</tr>			
			<tr><th>&nbsp;</th></tr>			
			<tr>
				<th>Step 1</th>
				<td>
					Visit the following URL on a machine with Internet access.  
					This URL will generate an Activation String.
				</td>
			</tr>			
			<tr><th>&nbsp;</th></tr>			
			<tr>
				<th></th>
				<td>
					<a href="http://register.softwarefx.com/licensecode/GetNetLicense.aspx?Data=[encode_stricturl: (bytes: $chartfx_challenge_string, 'iso-8859-1')]&Install=1&Process=1" target="new">Get Challenge Code</a>
				</td>
			</tr>			
			<tr><th>&nbsp;</th></tr>			
			<tr>
				<th>Step 2</th>
				<td>
					Paste the provided Activation String below and select Activate
					Chart FX to complete the process.
				</td>
			</tr>			
			<tr><th>&nbsp;</th></tr>			
			<tr>
				<th>Activation String</th>
				<td>
					<input type="text" name="chartfx_activation_string" size="32" value="" class="large">
				</td>
			</tr>
[/if]
		</table>
[/if]
[if: (var: 'chartfx_error') != '']
		<p class="error">
			[var: 'chartfx_error']
		</p>
[/if]
[if: $chartfx_status >> 'activated']			
		<p align="right">
			<input type="Submit" name="chartfx_action" value="Remove Chart FX Activation" class="large" />
		</p>
[else]
		<p align="right">
			<input type="Submit" name="chartfx_action" value="Activate Chart FX" class="large" />
		</p>
		<p align="right">
			<br /><input type="Submit" name="chartfx_action" value="Reset Chart FX Activation" class="large" />
		</p>
[/if]
	<hr />
	<h2>Alternate Method</h2>
	<table>
			<tr>
				<th></th>
				<td>
					If you have any issues with the URL above you can visit the 
					following URL and manually enter the Challenge String shown below.  
				</td>
			</tr>			
			<tr><th>&nbsp;</th></tr>			
			<tr>
				<th></th>
				<td>
					<a href="http://register.softwarefx.com/licensecode/" target="new">http://register.softwarefx.com/licensecode</a>
				</td>
			</tr>			
			<tr><th>&nbsp;</th></tr>			
			<tr>
				<th>Challenge String</th>
				<td>
					<textarea name="dummy" rows="10" cols="40" class="std_area_large">[var: 'chartfx_challenge_string']</textarea>
				</td>
			</tr>
	</table>

[if: $chartfx_status >> 'developer']			
			<br />
			<p>
				Enter a Chart FX module serial number in order to activate the Chart FX module for deployment.
			</p>
			<p>
				The Chart FX module is running with developer functionality.  This allows charts to be designed and viewed through
				Lasso for development and demonstration purposes.  A separate license for the Chart FX module must be purchased in 
				order to deploy a Web site using Chart FX.  Visit the LassoSoft store for more information.
			</p>
			<p>
				<a href="http://store.lassosoft.com/" target="_new">http://store.lassosoft.com/</a>
			</p>			
[/if]
	</div>
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0"></div>
</div>

</form>
