<?LassoScript

_admin_addvar: 'action', -override=(action_param: 'action');

// ---------
// prefs

var: 'settings_defaults' = (map: 
		'lasso_classic_enabled' = 'N',
		'error_reporting' = 'minimal',
		'default_page_encoding' = 'UTF-8',
		'lasso_apps_enabled' = 'Y',
		'lasso_digest_auth' = 'N',
	);		
var: 'settings_prefs' = $settings_defaults;
var: 'settings_prefs' = (admin_getpref: $settings_prefs);

if: $settings_prefs->(find: 'execution_override') !>> 'N';
	$settings_prefs->(insert: 'execution_override' = 'Y');
/if;

// ---------
// action

if: (var:'action') >> 'Update';

	iterate: $settings_prefs->keys, (var: 'key');
		if: (action_param: $key, -count) > 0;
			if: (action_param: $key) == '';
				$settings_prefs->(insert: $key = $settings_defaults->(find: $key));
			else;
				$settings_prefs->(insert: $key = (action_param: $key));
			/if;
		/if;
	/iterate;

	admin_setpref: $settings_prefs;
	
	protect;
		_execution_timelimit: $settings_prefs->(find: 'execution_timelimit');
	/protect;

	protect;
		lasso_errorreporting: $settings_prefs->(find: 'error_reporting'), -global;
	/protect;
	
	global: '__encoding__' = $settings_prefs->(find: 'default_page_encoding');

	global: '__digest_auth__' = $settings_prefs->(find: 'lasso_digest_auth');

	_security_flushcaches;

/if;

?>
