<form autocomplete="off" action="[var: 'admin_link']" method="post">
<input type="hidden" name="header" value="Select" />

<div class="content_top">
	<h2 style="float: right">
			<select name="site_id" onchange="this.form.submit();" class="std_pop_medium">
			[iterate: $sites_map, (var: 'sites_temp')]
				<option value="[$sites_temp->(find: 'id')]" [if: $site_id == $sites_temp->(find: 'id')]selected="selected"[/if]>[$sites_temp->(find: 'name')]</option>
			[/iterate]
			</select>&nbsp;<input type="submit" name="header" value="Switch Site" class="medium" />
	</h2>
	<h2>Site Import/Export</h2>
</div>
	
</form>

<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post" enctype="multipart/form-data">
<input type="hidden" name="dialog_action" value="" />

<div class="content_split">
	<div class="content_left">
		<h2>Import Site Settings</h2>
		<p>
			This page allows site settings to be imported into the site selected above.  This interface 
			works similarly to the Setup &gt; Site &gt; Import/Export page in SiteAdmin.LassoApp.  In order to
			import Server settings the <a href="[Response_FilePath]?tab1=setup&tab2=global&tab3=importexport">Setup
			&gt; Server &gt; Import/Export</a> page should be used instead.
		</p>
		<p>
			Important - This interface should only be used to import a settings file created by the Lasso
			Settings Migrator which shipped with Lasso 8 or an export from a Lasso Professional 8 site.
		</p>
		<table>
			<tr>
				<th>File</th>
				<td width="65%">
					<input type="file" name="import_file" value="[action_param: 'import_file']" />
				</td>
			</tr>
		</table>
[if: (var_defined: 'import_error') && ($import_error != '')]
		<p class="error">[var: 'import_error', -encodenone]</p>
[/if]
[if: (var_defined: 'import_success') && ($import_success != '')]
		<p class="message">[var: 'import_success']</p>
[/if]
[if: ($action >> 'Import') && ($import_cancel == false)]
		<p>
              The site has been restarted.  
              Wait a few seconds and follow this link to enter Site Administration for the site.  
              If you receive an error from your browser, wait 10-15 seconds and click on the link again.
		</p>
		<p class="message">
				[var: 'visit_url' = (admin_getpref: 'lasso_site_admin_url', -site=$site_detail->(find: 'id'))]
				[if: $visit_url != '']
					<a href="[encode_html: $visit_url]" target="_blank">[encode_html: $site_detail->(find: 'name')] ([var: 'site_id']) SiteAdmin.LassoApp</a>
				[else: $site_detail->(find: 'url') != '']
					<a href="[encode_html: $site_detail->(find: 'url')]" target="_blank">[encode_html: $site_detail->(find: 'name')] ([var: 'site_id']) SiteAdmin.LassoApp</a>
				[else: $site_detail->(find: 'id') == 1]
					<a href="http[(server_port == 443)?'s']://[server_name]:[server_port]/SiteAdmin.LassoApp" target="_blank">[encode_html: $site_detail->(find: 'name')] ([var: 'site_id']) SiteAdmin.LassoApp</a>
				[/if]
		</p>
[/if]
		<p>&nbsp</p>
		<p align="right">
			<input type="submit" value="Import" name="action" class="medium" onclick="return confirm('Warning - Importing a setup file will overwrite all settings in Lasso Administration.  Are you sure you want to do this?');" />
		</p>
	</div>
	<div class="content_right">
		<h2>Export Site Settings</h2>
		<p>
			This page allows site settings to be imported into the site selected above.  This interface 
			works similarly to the Setup &gt; Site &gt; Import/Export page in SiteAdmin.LassoApp.  In order to
			export Server settings the <a href="[Response_FilePath]?tab1=setup&tab2=global&tab3=importexport">Setup
			&gt; Server &gt; Import/Export</a> page should be used instead.
		</p>
		<p>
			Select the "Export..." button to download a text file with all the
			security settings for the site selected above.  The file will be named
			Lasso_Site_[var: 'site_id']_YYYYMMDDHHMMSS.txt.
		</p>
		<p>&nbsp</p>
		<p align="right">
			<input type="submit" name="action" value="Export..." class="medium" />
		</p>
	</div>
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0"></div>
</div>

</form>
