[inline: -log=$__startup_loglevel__, $error_inline][var: 'error_found' = found_count]
	[var: 'found_count' = (found_count)]
	[var: 'shown_count' = (shown_count)]
	[var: 'shown_first' = (shown_first)]
	[var: 'shown_last' = (shown_last)]

<div class="sidebar">

<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">
<input type="hidden" name="error_oldstatus" value="[var: 'error_status']">
<input type="hidden" name="error_skip" value="[var: 'error_skip']">
<input type="hidden" name="error_found" value="[var: 'found_count']">

	<h2 onclick="toggleDisplayBlock('srch')">Lasso Errors</h2>
	<div id="srch">
		<p>
			<b>Level</b>
			<br />
			<select name="error_status" onchange="this.form.submit();">
				<option value="all" [if: (var: 'error_status') >> 'all']selected="selected"[/if]>All Errors</option>
				<option value="critical" [if: (var: 'error_status') >> 'critical']selected="selected"[/if]>Critical Errors</option>
				<option value="warning" [if: (var: 'error_status') >> 'warning']selected="selected"[/if]>Warnings</option>
				<option value="detail" [if: (var: 'error_status') >> 'detail']selected="selected"[/if]>Details</option>
				<option value="sql" [if: (var: 'error_status') >> 'sql']selected="selected"[/if]>Action Statements</option>
				<option value="deprecated" [if: (var: 'error_status') >> 'deprecated']selected="selected"[/if]>Deprecated</option>
			[if: (var: 'error_status') >> 'query']
				<option value="query" selected="selected">Search Results</option>
			[/if]
			</select>
		</p>
		<p>
			<b>Filter</b>
			<br />
			<input type="text" name="error_filter" value="[var: 'error_filter']" size="16" />
		</p>
		<p style="margin-bottom: 3px; align: right;">
			<input type="submit" name="error_action" value="Select" class="half" />
			<input type="submit" name="error_action" value="Refresh" class="half" />
		</p>
	</div>

	<h2 onclick="toggleDisplayBlock('sum')">Summary</h2>
	<div id="sum">
		<p>
			[if: ((var: 'found_count') > 0) && ((var: 'shown_count') > 0)]
				Showing 
				[if: (var: 'shown_count') == 1] Record [var: 'shown_first'][else][var: 'shown_count'] Records[/if]
				[if: (var: 'found_count') > 1]of [var: 'found_count'] Found[/if]
			[else]
				No Records Found
			[/if]
		</p>
	</div>

	<h2 onclick="toggleDisplayBlock('act')">Actions</h2>
	<div id="act"[if: (var: 'found_count') == 0] style="display: none;"[/if]>

		[if: (var: 'error_status') >> 'critical']
		<p>
			<input type="submit" name="error_action" value="Delete All Critical" />
		</p>
		[else: (var: 'error_status') >> 'warning']
		<p>
			<input type="submit" name="error_action" value="Delete All Warnings" />
		</p>
		[else: (var: 'error_status') >> 'detail']
		<p>
			<input type="submit" name="error_action" value="Delete All Details" />
		</p>
		[else: (var: 'error_status') >> 'deprecated']
		<p>
			<input type="submit" name="error_action" value="Delete All Deprecated" />
		</p>
		[else: (var: 'error_status') >> 'sql']
		<p>
			<input type="submit" name="error_action" value="Delete All Actions" />
		</p>
		[/if]
		<p>
			<input type="submit" name="error_action" value="Delete All Errors" />
		</p>
	</div>
	
	<h2 onclick="toggleDisplayBlock('nav')">Navigation</h2>
	<div id="nav"[if: ((var: 'found_count') <= (var: 'shown_count'))] style="display: none;"[/if]>
		<table border="0" cellpadding="0" cellspacing="0">
		[if:((var: 'shown_first') > 1) || ((var: 'shown_last') < (var: 'found_count'))]
			<tr>
			[if:((var: 'shown_first') > 1)]
				<td><input type="submit" value="Prev" name="error_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			[if:((var: 'shown_last') < (var: 'found_count'))]
				<td><input type="submit" value="Next" name="error_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			</tr>
		[/if]
			<tr>
				<td><input type="text" value="[var: 'shown_first']" name="error_navigation_skip" class="half"></td>
				<td><input type="submit" value="Jump" name="error_navigation" class="half" /></td>
			</tr>
		[if:((var: 'shown_first') > 1) || ((var: 'shown_last') < (var: 'found_count'))]
			<tr>
			[if:((var: 'shown_first') > 1)]
				<td><input type="submit" value="First" name="error_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			[if:((var: 'shown_last') < (var: 'found_count'))]
				<td><input type="submit" value="Last" name="error_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			</tr>
		[/if]
		</table>
	</div>

</form>

</div>

<div class="content_full2">
	[records]
	<div class="content_panel"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b><div class="content_inner">
		<span>
			<span class="twothird"><b>Message: </b> [field: 'message']</span>
			[protect]<b>Time:</b> [date_format: (field: 'date_time'), -format='%Q %T']<br />[/protect]
			<b>Level:</b> [if: (field: 'code') == log_level_critical]Critical[else: (field: 'code') == log_level_warning]Warning[else: (field: 'code') == log_level_detail]Detail[else: (field: 'code') == log_level_deprecated]Deprecated[else: (field: 'code') == log_level_sql]Action[else][field: 'code'][/if]
		</span>
	</div><b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b></div>
	[/records]
[if: (found_count) == 0]
	<p class="error">No Errors Found</p>
[/if]

</div>
	
[/inline]
