<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">
<input type="hidden" name="dialog_action" value="" />

[if: ($admin_serial == false)]
<div class="content_top">
	<p>
		Note - Lasso Developer is licensed for the development and
		demonstration of Lasso powered Web sites. It includes a 5 IP limit and
		a limit on the number of transactions which can be performed each
		minute. Lasso Professional should be used to deploy Lasso powered Web
		sites. Consult the Lasso 8.6 Setup Guide for additional details
		about the development and deployment options for Lasso.
	</p>
</div>
[/if]

[if: ($login_action >> 'Restart')]

<div class="content_split_solo">
	<div class="content_left">
		<h2>Stopping Site</h2>
		<p>
              Your site will be stopped in a couple seconds.  
              Wait a few seconds and follow this link to re-enter Site Administration.  The first click on the link will re-start your site.  
              If you receive an error from your browser, wait 10-15 seconds and click on the link again.
		</p>
		<p class="message">
              <a href="[var: 'admin_link', -encodenone]&tab1=setup&tab2=global&tab3=login">Site Administration</a>
		</p>
	</div>
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0"></div>
</div>

[else]

<div class="content_split">
	<div class="content_left">
[if: ($admin_serial == true)]
		<h2>Lasso Professional 8.6</h2>
[else]
		<h2>Lasso Developer 8.6</h2>
[/if]
		<table>
[if: ($admin_expires != '')]
			<tr>
				<th>Binary Expiration</th>
				<td style="color:red">Build Expires [var: 'admin_expires']</td>
			</tr>
[/if]
			<tr>
				<th>Product</th>
[if: ($admin_serial == true)]
				<td>Lasso Professional 8.6</td>
[else]
				<td>Lasso Developer 8.6</td>
[/if]
			</tr>
			<tr>
				<th>Version</th>
				<td>[lasso_version: -lassoversion]</td>
			</tr>
			<tr>
				<th>Platform</th>
				<td>[lasso_version: -lassoplatform]</td>
			</tr>
			<tr>
				<th>Authentication</th>
				<td>[client_authorization->(find: 'type')]</td>
			</tr>			
		[protect]
			[var: 'seconds' = (integer: lasso_uptime)][var: 'temp' = 0]
			<tr>
				<th>Uptime</th>
				<td>
          	[if: $seconds >= 86400][integer: $temp := $seconds / 86400] Day[if: $temp > 1]s[/if]
				[if: ($seconds := ($seconds % 86400)) >= 3600][integer: $temp := $seconds / 3600] Hour[if: $temp > 1]s[/if][/if]
			[else: ($seconds := ($seconds % 86400)) >= 3600][integer: $temp := $seconds / 3600] Hour[if: $temp > 1]s[/if]
			[else: ($seconds := ($seconds % 3600)) >= 60][integer: $temp := $seconds / 60] Minute[if: $temp > 1]s[/if]
			[else: ($seconds := ($seconds % 60)) > 0][integer: $temp := $seconds] Second[if: $temp > 1]s[/if][/if]
				</td>
			</tr>
		[/protect]
		[if: (global: '__startup_version__') != 'Unknown' && (global: '__startup_version__') != '']
			<tr>
				<th>Startup Build Date</th>
				<td>[date_format: (global: '__startup_version__'), -format='%Q']</td>
			</tr>
		[/if]
			<tr>
				<th colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<th>Site</th>
				<td>[Site_Name] ([Site_ID])</td>
			</tr>
[var: 'lasso_site_criteria' = (admin_getpref: 'lasso_site_criteria')]			
[if: $lasso_site_criteria != '']
			<tr>
				<th>Site Criteria</th>
				<td>[var: 'lasso_site_criteria', -encodenone]</td>
			</tr>
[/if]
		</table>
		<p align="right">
			<input type="Submit" name="action" value="Restart Site" class="medium" />
		</p>
		<p align="right">
			<input type="Submit" name="action" value="Update Site Admin Login" class="large" />
		</p>

		<h2>Quick Links</h2>
		[var: 'temp' = (response_filepath)->(split: '/')]
		[$temp->remove]
		[var: 'root' = 'http' + ((server_port == 443)?'s'|'') + '://' + server_name + (server_port != 80 ? ':' + server_port | '') + $temp->(join: '/')]
		[$root += ($root->(endswith: '/') ? '' | '/')]
		<table>
			<tr>
				<th width="50%">Lasso Reference</th>[var: 'link' = $root + 'Reference.LassoApp']
				<td><a href="[var: 'link']" target="_blank">Reference.LassoApp</a></td>
			</tr>
			<tr>
				<th width="50%">Database Browser</th>[var: 'link' = $root + 'DatabaseBrowser.LassoApp']
				<td><a href="[var: 'link']" target="_blank">DatabaseBrowser.LassoApp</a></td>
			</tr>
			<tr>
				<th width="50%">Group Administration</th>[var: 'link' = $root + 'GroupAdmin.LassoApp']
				<td><a href="[var: 'link']" target="_blank">GroupAdmin.LassoApp</a></td>
			</tr>
			<tr>
				<th width="50%">Server Administration</th>[var: 'link' = $root + 'ServerAdmin.LassoApp']
				<td><a href="[var: 'link']" target="_blank">ServerAdmin.LassoApp</a></td>
			</tr>
		</table>
	</div>
	<div class="content_right">
		<h2>Data Sources Summary</h2>
		<table>
			<tr>
				<th>&nbsp;</th>
				<th>Name</th>
				<th>Summary</th>
			</tr>
[var: 'connectors' = (_admin_listconnectors)]
[iterate: $connectors, (var: 'connector')]
[if: $connector->second->(find: 'status') == 'enabled']
			<tr>
				<th>[encode_html: $connector->second->(find: 'alias') - 'Lasso Connector for ']</th>
[var: 'hosts' = (_admin_listhosts: $connector->first)]
[if: $hosts->size > 0]
	[iterate: $hosts, (var: 'host')]
		[if: (loop_count > 2)][loop_abort][/if]
		[var: 'databases' = (_admin_listdatabases: $host->first, 'enabled'='Y')]
		[var: 'count' = 0][iterate: $databases, (var: 'database')][if: $database->second->(find: 'status') == 'enabled'][$count += 1][/if][/iterate]
				<td>
					<a href="[var: 'admin_link']&tab2=datasources&tab3=host&datasource_action=detail&datasource_connectorid=[integer: $connector->first]&datasource_hostid=[integer: $host->first]">[encode_html: $host->second->(find: 'alias')]</a>
				[if: ($connector->first > 1)]
					<br />[_admin_short_cleanup: $host->second->(find: 'name'), 32] [_admin_short_cleanup: $host->second->(find: 'port'), 8]<br />
				[/if]
				</td>
				<td>
					<a href="[var: 'admin_link']&tab2=datasources&tab3=databases&datasource_action=list&datasource_connectorid=[integer: $connector->first]&datasource_hostid=[integer: $host->first]">[integer: $count] Database[if: $count != 1]s[/if]</a>
				</td>
		[if: (loop_count != $hosts->size)]
			</tr>
			<tr>
				<th>&nbsp;</th>
		[/if]
	[/iterate]
			</tr>
[/if]
[if: ($connector->first > 1) && ($hosts->size == 0)]
	[if: $hosts->size > 0]
			<tr>
				<th>&nbsp;</th>
	[/if]
				<td colspan="2"><a href="[var: 'admin_link']&tab2=datasources&tab3=hosts&datasource_action=add+host&datasource_connectorid=[integer: $connector->first]">(Add Host)</a></td>
			</tr>
[/if]
[if: $hosts->size > 2]
			<tr>
				<th>&nbsp;</th>
				<td><a href="[var: 'admin_link']&tab2=datasources&tab3=hosts&datasource_action=list+hosts&datasource_connectorid=[integer: $connector->first]">([integer: $hosts->size - 2] More)</a></td>
				<td>&nbsp;</td>
			</tr>
[/if]
[/if]
[/iterate]
		</table>

		<h2>Security Summary</h2>
		<table>
			<tr>
				<th>&nbsp;</th>
				<th>Name</th>
				<th>Summary</th>
			</tr>
[inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql='SELECT security_groups.id, security_groups.name, COUNT(security_ug_map.id) AS cnt FROM security_groups LEFT JOIN security_ug_map ON security_ug_map.id_group = security_groups.id WHERE security_groups.enabled = "Y" AND security_groups.id <> 2 GROUP BY security_groups.id ORDER BY security_groups.id', -maxrecords=5]
	[records]
			<tr>
				<th>[if: loop_count == 1]Groups[else]&nbsp;[/if]</th>
				<td><a href="[var: 'admin_link']&tab2=security&tab3=groups&groups_groupid=[field: 'id']&groups_action=detail">[if: (field: 'id') == 1]Any User[Else][field: 'name'][/if]</a></td>
				<td><a href="[var: 'admin_link']&tab2=security&tab3=users&users_groupfilter=[field: 'id']&users_action=refresh">[if: (field: 'id') == 1]All Users[else][field: 'cnt'] User[if: (field: 'cnt') != 1]s[/if][/if]</a></td>
			</tr>
	[/records]
	[if: found_count > 5]
			<tr>
				<th>&nbsp;</th>
				<td><a href="[var: 'admin_link']&tab2=security&tab3=groups">([integer: found_count - 5] More)</a></td>
				<td>&nbsp;</td>
			</tr>
	[/if]
[/inline]
[inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql='SELECT security_users.id, security_users.name, COUNT(security_ug_map.id) AS cnt FROM security_users LEFT JOIN security_ug_map ON security_ug_map.id_user = security_users.id WHERE security_users.id <> 2 GROUP BY security_users.id ORDER BY security_users.id', -maxrecords=5]
	[records]
			<tr>
				<th>[if: loop_count == 1]Users[else]&nbsp;[/if]</th>
				<td><a href="[var: 'admin_link']&tab2=security&tab3=users&users_userid=[field: 'id']&users_action=detail">[if: (field: 'name') == 'Anonymous']Anonymous[Else][field: 'name'][/if]</a></td>
				<td>[field: 'cnt'] Group[if: (field: 'cnt') != 1]s[/if]</td>
			</tr>
	[/records]
	[if: found_count > 5]
			<tr>
				<th>&nbsp;</th>
				<td><a href="[var: 'admin_link']&tab2=security&tab3=users">([integer: found_count - 5] More)</a></td>
				<td>&nbsp;</td>
			</tr>
	[/if]
[/inline]

		</table>

		<h2>URL Rewrite Summary</h2>
[inline: -log=$__startup_loglevel__,
		-search,
		-database='site',
		-table='rewrite_rule',
		-op='eq', 'status'='Y',
		-op='neq', 'name'='',
		-sortfield='sort',
		-maxrecords=4]
	[if: (found_count > 0)]
		<table>
			<tr>
				<th width="25%">Name</th>
				<th>Description</th>
			</tr>
		[records]
			<tr>
				<td><a href="[var: 'admin_link']&tab2=rewrite&tab3=edit&rewrite_ruleid=[integer: (field: 'id')]&rewrite_action=detail">[_admin_short_cleanup: (if_empty: (field: 'name'), '(None)'), 48]</a></td>
				<td>[_admin_short_cleanup: (if_empty: (field: 'description'), '(None)'), 96, -encodenone]</td>
			</tr>
		[/records]
		[if: (found_count > 4)]
			<tr>
				<td colspan="2"><a href="[var: 'admin_link']&tab2=rewrite&tab3=list">[found_count - 4] More...</a></td>
			</tr>
		[/if]
		</table>
	[else]
		<p class="error">No Rules Found</p>
	[/if]
[/inline]

	</div>
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0"></div>

</div>

[/if]

</form>
