<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">
<div class="content_split">
	<div class="content_left">
		<h2>Syntax Settings</h2>
		<table>
			<tr>
				<th>Inline Host Specification</th>
				<td>
					<select name="lasso_inline_hosts" class="std_pop_medium">
						<option value="Y"[if: $settings_prefs->(find: 'lasso_inline_hosts') == 'Y'] selected="selected"[/if]>Enabled</option>
						<option value="N"[if: $settings_prefs->(find: 'lasso_inline_hosts') == 'N'] selected="selected"[/if]>Disabled</option>
					</select>
				</td>
			</tr>
			<tr>
				<th>URL Rewrite</th>
				<td>
					<select name="lasso_urlrewrite" class="std_pop_medium">
						<option value="Y"[if: $settings_prefs->(find: 'lasso_urlrewrite') == 'Y'] selected="selected"[/if]>Enabled</option>
						<option value="N"[if: $settings_prefs->(find: 'lasso_urlrewrite') == 'N'] selected="selected"[/if]>Disabled</option>
					</select>
				</td>
			</tr>
			<tr>
				<th>Classic Lasso Syntax</th>
				<td>
					<select name="lasso_classic_enabled" class="std_pop_medium">
						<option value="Y"[if: $settings_prefs->(find: 'lasso_classic_enabled') == 'Y'] selected="selected"[/if]>Enabled</option>
						<option value="N"[if: $settings_prefs->(find: 'lasso_classic_enabled') == 'N'] selected="selected"[/if]>Minimal</option>
						<option value="X"[if: $settings_prefs->(find: 'lasso_classic_enabled') == 'X'] selected="selected"[/if]>Disabled</option>
					</select>
				</td>
			</tr>
			<tr>
				<th>Error Reporting</th>
				<td>
					<select name="error_reporting" class="std_pop_medium">
						<option value="none"[if: $settings_prefs->(find: 'error_reporting') >> 'none'] selected="selected"[/if]>None</option>
						<option value="minimal"[if: $settings_prefs->(find: 'error_reporting') >> 'minimal'] selected="selected"[/if]>Minimal</option>
						<option value="full"[if: $settings_prefs->(find: 'error_reporting') >> 'full'] selected="selected"[/if]>Full</option>
					</select>
				</td>
			</tr>
			<tr>
				<th>LassoApps</th>
				<td>
					<select name="lasso_apps_enabled" class="std_pop_medium">
						<option value="Y"[if: $settings_prefs->(find: 'lasso_apps_enabled') != 'N'] selected="selected"[/if]>Enabled</option>
						<option value="N"[if: $settings_prefs->(find: 'lasso_apps_enabled') == 'N'] selected="selected"[/if]>Disabled</option>
					</select>
				</td>
			</tr>
			<tr>
				<th>Digest Authentication</th>
				<td>
					<select name="lasso_digest_auth" class="std_pop_medium">
						<option value="Y"[if: $settings_prefs->(find: 'lasso_digest_auth') != 'N'] selected="selected"[/if]>Enabled</option>
						<option value="N"[if: $settings_prefs->(find: 'lasso_digest_auth') == 'N'] selected="selected"[/if]>Disabled</option>
					</select>
				</td>
			</tr>
		</table>
		<p align="right">
			<input type="submit" value="Update" name="action" class="small" />
		</p>
	</div>
	<div class="content_right">
		<h2>Recursion Limit</h2>
		<table>
			<tr>
				<th width="50%">Limit Recursion</th>
				<td>
					<select name="recursion_enable" class="std_pop_small">
						<option value="Y"[if: (integer: $settings_prefs->(find: 'recursion_limit')) > 0] selected="selected"[/if]>Yes</option>
						<option value="N"[if: (integer: $settings_prefs->(find: 'recursion_limit')) <= 0] selected="selected"[/if]>No</option>
					</select>
				</td>
			</tr>
[if: (integer: $settings_prefs->(find: 'recursion_limit')) === 0][$settings_prefs->(insert: 'recursion_limit' = 50)][/if]
			<tr>
				<th>Recursion Threshold</th>
				<td>
					<input name="recursion_limit" class="small" value="[integer: $settings_prefs->(find: 'recursion_limit')]">
				</td>
			</tr>
		</table>

		<h2>Thread Time Limit</h2>
		<table>
			<tr>
				<th width="50%">Limit Execution Time</th>
				<td>
					<select name="execution_enable" class="std_pop_small">
						<option value="Y"[if: (integer: $settings_prefs->(find: 'execution_timelimit')) > 0] selected="selected"[/if]>Yes</option>
						<option value="N"[if: (integer: $settings_prefs->(find: 'execution_timelimit')) <= 0] selected="selected"[/if]>No</option>
					</select>
				</td>
			</tr>
[if: (integer: $settings_prefs->(find: 'execution_timelimit')) === 0][$settings_prefs->(insert: 'execution_timelimit' = 600)][/if]
			<tr>
				<th>Time Limit</th>
				<td>
					<input name="execution_timelimit" class="small" value="[integer: $settings_prefs->(find: 'execution_timelimit')]"> Seconds
				</td>
			</tr>
		</table>

		<p align="right">
			<input type="submit" value="Update" name="action" class="small" />
		</p>
	</div>
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0"></div>
</div>
<div class="content_split">
	<div class="content_left">
		<h2>Default Page Encoding</h2>
		<table>
			<tr>
				<th>Encoding</th>
				<td nowrap>
<?LassoScript
	var: 'default_page_encoding' = (string: (global: '__encoding__'));
	$default_page_encoding->trim;
	var: 'done' = false;
	if: ($default_page_encoding == '');
		var: 'default_page_encoding' = 'utf-8';
	else: ($default_page_encoding == 'utf8');
		var: 'default_page_encoding' = 'utf-8';
	else: ($default_page_encoding == 'iso8859-1');
		var: 'default_page_encoding' = 'iso-8859-1';
	/if;
?>
					<select name="default_page_encoding" class="std_pop_medium">
						<option value="utf-8"[if: ($default_page_encoding == 'utf-8')][var: 'done' = true] selected="selected"[/if]>UTF-8 (Unicode)</option>
						<option value="iso-8859-1"[if: ($default_page_encoding == 'iso-8859-1')][var: 'done' = true] selected="selected"[/if]>Latin-1 (ISO 8859-1)</option>
					[if: ($done == false)]
						<option value="[var: 'default_page_encoding']" selected="selected">[var: 'default_page_encoding']</option>
					[/if]
						<option value="...">Other...</option>
					</select>
					<input type="text" name="page_encoding_other" value="" class="small" />
				</td>
			</tr>
		</table>
		<p align="right">
			<input type="submit" value="Update" name="action" class="small" />
		</p>
	</div>
	<div class="content_right">
		<h2>Domain Name Lookups</h2>
[var: 'default' = dns_default]
[var: 'current' = $settings_prefs->(find: 'domain_name_server')]
[var: 'custom' = true]
		<table>
			<tr>
				<th>Domain Name Server</th>
				<td>
					<input type="radio" name="domain_name_server" value="" [if: $current == ''] [var: 'custom' = false]checked="checked"[/if] /> Default [protect]([encode_html: $default->first])[/protect]
				</td>
			</tr>
[iterate: $default, (var: 'temp')]
			<tr>
				<th>&nbsp;</th>
				<td>
					<input type="radio" name="domain_name_server" value="[encode_html: $temp]" [if: $current == $temp] [var: 'custom' = false]checked="checked"[/if] /> Use [encode_html: $temp]
				</td>
[/iterate]
			<tr>
				<th>&nbsp;</th>
				<td>
					<input type="radio" name="domain_name_server" value="custom"[if: $custom] checked="checked"[/if] /> Custom <input type="text" name="custom_name_server" value="[if_true: $custom, $current, '']" />
				</td>
			</tr>
		</table>
[if: (var_defined: 'test_message')]
		<p class="message">[var: 'test_message']</p>
[else: (var_defined: 'test_error')]
		<p class="error">[var: 'test_error']</p>
[/if]
		<p align="right">
			<input type="submit" value="Test" name="action" class="small" />
			<input type="submit" value="Update" name="action" class="small" />
		</p>
	</div>
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0"></div>
</div>
</form>

