<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">
	<input type="hidden" value="" name="dialog_action" />
[if: ((var: 'rewrite_ruledetail') != null)]
	<input type="hidden" name="rewrite_ruleid" value="[encode_html: $rewrite_ruledetail->(find: 'id')]">
[/if]
[if: ((var: 'rewrite_triggerdetail') != null)]
	<input type="hidden" name="rewrite_triggerid" value="[encode_html: $rewrite_triggerdetail->(find: 'id')]" />
[/if]
[if: ((var: 'rewrite_actiondetail') != null)]
	<input type="hidden" name="rewrite_actionid" value="[encode_html: $rewrite_actiondetail->(find: 'id')]" />
[/if]

[if: ((var: 'rewrite_ruleid') >> 'new') || ((var: 'rewrite_actiondetail') != null) || ((var: 'rewrite_triggerdetail') != null)]
<div class="content_split">
[else]
<div class="content_split_solo">
[/if]
	<div class="content_left" style="min-height: 288px">
[if: ((var: 'rewrite_ruleid') == 'new')]
		<h2>Add Rule</h2>
[else]
		<h2>Edit Rule</h2>
[/if]
		<table>
			<tr>
				<th width="40%">Name</th>
				<td><input type="text" name="rewrite_name" value="[encode_html: $rewrite_ruledetail->(find: 'name')]" class="medium" /></td>
			</tr>
			<tr>
				<th>Status</th>
				<td>
					<select name="rewrite_status" class="std_pop_small">
						<option value="Y"[if: $rewrite_ruledetail->(find: 'status') >> 'Y'] selected="selected"[/if]>Enabled</option>
						<option value="N"[if: $rewrite_ruledetail->(find: 'status') !>> 'Y'] selected="selected"[/if]>Disabled</option>
					</select>
				</td>
			</tr>
			<tr>
				<th>Perform Action If</th>
				<td>
					<select name="rewrite_bool" class="std_pop_medium">
						<option value="and"[if: $rewrite_ruledetail->(find: 'bool') >> 'and'] selected="selected"[/if]>All Triggers Match</option>
						<option value="or"[if: $rewrite_ruledetail->(find: 'bool') !>> 'and'] selected="selected"[/if]>Any Trigger Matches</option>
					</select>
				</td>
			</tr>
			<tr>
				<td colspan="2">&nbsp;</td>
			</tr>
[if: ((var: 'rewrite_ruleid') >> 'new')]
			<tr>
				<th>Trigger<br />Action</th>
				<td>Specify initial trigger and action at right. Additional triggers and actions can be added after the rule is created.</td>
			</tr>
[else]
	[iterate: $rewrite_ruletriggers, (var: 'temp_ruletrigger')]
			<tr>
				<th>[if: (loop_count == 1)]Trigger[else]&nbsp;[/if]</th>
				<td><a href="[var: 'admin_link']&rewrite_ruleid=[var: 'rewrite_ruleid']&rewrite_triggerid=[integer: $temp_ruletrigger->(find: 'id')]&rewrite_action=detail">[trigger_summary: $temp_ruletrigger->(find: 'type'), $temp_ruletrigger->(find: 'name'), $temp_ruletrigger->(find: 'comp'), $temp_ruletrigger->(find: 'value')]</a></td>
			</tr>
	[/iterate]
	[if: ((var: 'rewrite_ruleid') !>> 'new')]
			<tr>
				<th>[if: ($rewrite_ruletriggers->size == 0)]Trigger[else]&nbsp;[/if]</th>
				<td><a href="[var: 'admin_link']&rewrite_ruleid=[var: 'rewrite_ruleid']&rewrite_triggerid=new&rewrite_action=add+trigger">Add Trigger...</td>
			</tr>
	[/if]
			<tr>
				<td colspan="2">&nbsp;</td>
			</tr>
	[iterate: $rewrite_ruleactions, (var: 'temp_ruleaction')]
			<tr>
				<th>[if: (loop_count == 1)]Action[else]&nbsp;[/if]</th>
				<td><a href="[var: 'admin_link']&rewrite_ruleid=[var: 'rewrite_ruleid']&rewrite_actionid=[integer: $temp_ruleaction->(find: 'id')]&rewrite_action=detail">[action_summary: $temp_ruleaction->(find: 'type'), $temp_ruleaction->(find: 'name'), $temp_ruleaction->(find: 'value')]</a></td>
			</tr>
	[/iterate]
	[if: ((var: 'rewrite_ruleid') !>> 'new')]
			<tr>
				<th>[if: ($rewrite_ruleactions->size == 0)]Action[else]&nbsp;[/if]</th>
				<td><a href="[var: 'admin_link']&rewrite_ruleid=[var: 'rewrite_ruleid']&rewrite_actionid=new&rewrite_action=add+action">Add Action...</td>
			</tr>
	[/if]
[/if]
			<tr>
				<td colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<th>If Triggered</th>
				<td>
					<select name="rewrite_option" class="std_pop_medium">
						<option value=""[if: $rewrite_ruledetail->(find: 'option') !>> 'stop'] selected="selected"[/if]>Continue After Actions</option>
						<option value="stop"[if: $rewrite_ruledetail->(find: 'option') >> 'stop'] selected="selected"[/if]>Stop After Actions</option>
					</select>
				</td>
			</tr>
			<tr>
				<th>Priority</th>
				<td>
					[if: $rewrite_ruledetail->(find: 'sort') == 32768][$rewrite_ruledetail->(insert: 'sort' = $rewrite_rulemap->size + 1)][/if]
					<select name="rewrite_sort" class="std_pop_small">[loop: $rewrite_rulemap->size + 1]
						<option value="[loop_count]"[if: $rewrite_ruledetail->(find: 'sort') == loop_count] selected="selected"[/if]>[Loop_Count]</option>[/loop]
					</select>
				</td>
			</tr>
		</table>

	[if: (var_defined: 'rewrite_error')]
			<p class="error">[var: 'rewrite_error']</p>
	[/if]
	
[if: ((var: 'rewrite_ruleid') >> 'new')]
		<p align="right">
			<input type="submit" value="Cancel" name="create_action" class="small" />
			<input type="submit" value="Add" name="create_action" class="small" />
		</p>
[else]
		<p align="right">
			<input type="submit" value="Delete" name="rewrite_action" class="small" onclick="return confirm('Are you sure you want to delete this rule?');" />
			<input type="submit" value="Update" name="rewrite_action" class="small" />
		</p>
		<p align="right">
[if: $rewrite_enabled && $rewrite_started]
			<input type="submit" value="Reload Active Rules" name="rewrite_action" class="large" />
[else: $rewrite_started == false]
			<input type="submit" value="Start URL Rewrite" name="rewrite_action" class="large" />
[else: $rewrite_enabled == false]
			<input type="submit" value="Enable URL Rewrite" name="rewrite_action" class="large" />
[/if]
		</p>
[/if]
	</div>

[if: ((var: 'rewrite_ruleid') >> 'new') || ((var: 'rewrite_actiondetail') != null) || ((var: 'rewrite_triggerdetail') != null)]
	<div class="content_right" style="min-height: 288px">

[if: ((var: 'rewrite_ruleid') == 'new') || ((var: 'rewrite_triggerid') == 'new')]
		<h2>Add Trigger</h2>
[else: ((var: 'rewrite_triggerdetail') != null)]
		<h2>Edit Trigger</h2>
[/if]

[if: ((var: 'rewrite_triggerdetail') != null)]
		<table>
			<tr>
				<th width="40%">Type</th>
				<td><select name="trigger_type" class="std_pop_medium">
					<option value=""[if: '' == $rewrite_triggerdetail->(find: 'type')] selected="selected"[/if]>Choose a Type...</option>[iterate: $trigger_types, (var: 'temp_trigger')]
					<option value="[encode_html: $temp_trigger->first]"[if: $temp_trigger->first == $rewrite_triggerdetail->(find: 'type')] selected="selected"[/if]>[encode_html: $temp_trigger->second]</option>[/iterate]
				</select></td>
			</tr>
			<tr>
				<th>Name</th>
				<td><textarea name="trigger_name" class="small">[encode_html: $rewrite_triggerdetail->(find: 'name')]</textarea></td>
			</tr>
			<tr>
				<th>Comparator</th>
				<td><select name="trigger_comp" class="std_pop_medium">
					<option value=""[if: '' == $rewrite_triggerdetail->(find: 'comp')] selected="selected"[/if]>Choose a Comparator...</option>[iterate: $trigger_comps, (var: 'temp_comp')]
					<option value="[encode_html: $temp_comp->first]"[if: $temp_comp->first == $rewrite_triggerdetail->(find: 'comp')] selected="selected"[/if]>[encode_html: $temp_comp->second]</option>[/iterate]
				</select></td>
			</tr>
			<tr>
				<th>Value</th>
				<td><textarea name="trigger_value" class="small">[encode_html: $rewrite_triggerdetail->(find: 'value')]</textarea></td>
			</tr>
			<tr>
				<th>Priority</th>
				<td>
					[if: $rewrite_triggerdetail->(find: 'sort') == 32768][$rewrite_triggerdetail->(insert: 'sort' = $rewrite_ruletriggers->size + 1)][/if]
					<select name="trigger_sort" class="std_pop_small">[loop: $rewrite_ruletriggers->size + 1]
						<option value="[loop_count]"[if: $rewrite_triggerdetail->(find: 'sort') == loop_count] selected="selected"[/if]>[Loop_Count]</option>[/loop]
					</select>
				</td>
			</tr>
		</table>
[/if]

[if: ((var: 'rewrite_ruleid') == 'new') || ((var: 'rewrite_actionid') == 'new')]
		<h2>Add Action</h2>
[else: ((var: 'rewrite_actiondetail') != null)]
		<h2>Edit Action</h2>
[/if]

[if: ((var: 'rewrite_actiondetail') != null)]
		<table>
			<tr>
				<th width="40%">Type</th>
				<td><select name="action_type" class="std_pop_medium">
						<option value=""[if: '' == $rewrite_actiondetail->(find: 'type')] selected="selected"[/if]>Choose a Type...</option>[iterate: $action_types, (var: 'temp_action')]
						<option value="[encode_html: $temp_action->first]"[if: $temp_action->first == $rewrite_actiondetail->(find: 'type')] selected="selected"[/if]>[encode_html: $temp_action->second]</option>[/iterate]
					</select></td>
			</tr>
			<tr>
				<th>Name/URL/<br />Path/Message</th>
				<td><textarea name="action_name" class="small">[encode_html: $rewrite_actiondetail->(find: 'name')]</textarea></td>
			</tr>
			<tr>
				<th>Value/Code</th>
				<td><textarea name="action_value" class="small">[encode_html: $rewrite_actiondetail->(find: 'value')]</textarea></td>
			</tr>
			<tr>
				<th>Priority</th>
				<td>
					[if: $rewrite_actiondetail->(find: 'sort') == 32768][$rewrite_actiondetail->(insert: 'sort' = $rewrite_actiondetail->size + 1)][/if]
					<select name="action_sort" class="std_pop_small">[loop: $rewrite_ruleactions->size + 1]
						<option value="[loop_count]"[if: $rewrite_actiondetail->(find: 'sort') == loop_count] selected="selected"[/if]>[Loop_Count]</option>[/loop]
					</select>
				</td>
			</tr>
			<tr>
				<th>Tokens</th>
				<td>[encode_html: $action_tokens->(join: ', ')].
			</tr>
		</table>
[/if]

		<p align="right">
[if: ((var: 'rewrite_ruleid') >> 'new')]
		<!-- None -->
[else: ((var: 'rewrite_actionid') == 'new')]
			<input type="submit" value="Cancel" name="action_action" class="small" />
			<input type="submit" value="Add" name="action_action" class="small" />
[else: ((var: 'rewrite_actiondetail') != null)]
			<input type="submit" value="Delete" name="action_action" class="small" onclick="return confirm('Are you sure you want to delete this action?');" />
			<input type="submit" value="Update" name="action_action" class="small" />
[else: ((var: 'rewrite_triggerid') == 'new')]
			<input type="submit" value="Cancel" name="trigger_action" class="small" />
			<input type="submit" value="Add" name="trigger_action" class="small" />
[else: ((var: 'rewrite_triggerdetail') != null)]
			<input type="submit" value="Delete" name="trigger_action" class="small" onclick="return confirm('Are you sure you want to delete this trigger?');" />
			<input type="submit" value="Update" name="trigger_action" class="small" />
[/if]
		</p>

	</div>
[/if]

<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1000" width="1" border="0"></div>

</div>


</form>