<?LassoScript

//
// Variables
//

_admin_addvar: 'rewrite_action', -default='None', -override=(action_param: 'rewrite_action', (action_param: 'rewrite_action', -count));
_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');
_admin_addvar: 'create_action', -default='None', -override=(action_param: 'create_action');
_admin_addvar: 'action_action', -default='None', -override=(action_param: 'action_action');
_admin_addvar: 'trigger_action', -default='None', -override=(action_param: 'trigger_action');

_admin_addvar: 'rewrite_ruleid', -override=(action_param: 'rewrite_ruleid');
_admin_addvar: 'rewrite_triggerid', -override=(action_param: 'rewrite_triggerid');
_admin_addvar: 'rewrite_actionid', -override=(action_param: 'rewrite_actionid');

var: 'update_description' = false;
var: 'rewrite_ruledetail' = null;
var: 'rewrite_actiondetail' = null;
var: 'rewrite_triggerdetail' = null;
var: 'rewrite_ruletriggers' = null;
var: 'rewrite_ruleactions' = null;

if: ($rewrite_action == 'none') && ($dialog_action == 'none') && ($create_action == 'none');
	loop: (action_param: 'trigger_id', -count);
		var: 'trigger_id' = (action_param: 'trigger_id', loop_count);
		if: ((action_param: 'trigger_' + $trigger_id + '_minus.x') != '');
			var: 'rewrite_action' = 'update';
		/if;
	/loop;
/if;
if: ($rewrite_action == 'none') && ($dialog_action == 'none') && ($create_action == 'none');
	loop: (action_param: 'action_id', -count);
		var: 'action_id' = (action_param: 'action_id', loop_count);
		if: ((action_param: 'action_' + $action_id + '_minus.x') != '');
			var: 'rewrite_action' = 'update';
		/if;
	/loop;
/if;
if: ($rewrite_action == 'None');
	if: ($rewrite_ruleid == '');
		var: 'rewrite_action' = 'Add';
	else;
		var: 'rewrite_action' = 'Detail';
	/if;
/if;


//
// Process Action
//

if: ($rewrite_action >> 'Reload') || ($rewrite_action >> 'Enable') || ($rewrite_action >> 'Disable') || ($rewrite_action >> 'Start') || ($rewrite_action >> 'Stop');

	loop: -from=site_atbegin->size, -to=1, -by=-1;
		if: site_atbegin->(get: loop_count) == 'rewrite';
		  site_atbegin->(remove: loop_count);
		/if;
	/loop;
	if: ($rewrite_action >> 'Reload') || ($rewrite_action >> 'Enable') || ($rewrite_action >> 'Start');
		define_atbegin: url_rewrite;
	/if;
	if: ($rewrite_action >> 'Enable');
		admin_setpref: 'lasso_urlrewrite', 'Y';
	else: ($rewrite_action >> 'Disable');
		admin_setpref: 'lasso_urlrewrite', 'N';
	/if;
	redirect_url: $admin_link + '&tab3=list';
	
else: ($create_action >> 'Cancel');
	redirect_url: $admin_link + '&tab3=list';
else: ($create_action >> 'Add');
	inline: -log=$__startup_loglevel__,
			-add,
			-database='site',
			-table='rewrite_rule',
			-keyfield='id',
			'name' = (action_param: 'rewrite_name'),
			'description' = '',
			'status' = (((action_param: 'rewrite_status') >> 'Y') ? 'Y' | 'N'),
			'option' = (action_param: 'rewrite_option'),
			'bool' = (action_param: 'rewrite_bool'),
			'sort' = (action_param: 'rewrite_sort'),
			'modified' = date->(format: '%Q %D');
		var: 'rewrite_ruleid' = (field: 'id');
		var: 'update_description' = true;
	/inline;
	if: (action_param: 'trigger_type') != '';
			inline: -log=$__startup_loglevel__,
					-add,
					-database='site',
					-table='rewrite_trigger',
					-keyfield='id',
					'id_rule' = $rewrite_ruleid,
					'type' = (action_param: 'trigger_type'),
					'name' = (action_param: 'trigger_name'),
					'comp' = (action_param: 'trigger_comp'),
					'value' = (action_param: 'trigger_value'),
					'sort' = (action_param: 'trigger_sort'),
					'modified' = date->(format: '%Q %D');
				var: 'update_description' = true;
			/inline;
	/if;
	if: (action_param: 'action_type') != '';
		inline: -log=$__startup_loglevel__,
				-add,
				-database='site',
				-table='rewrite_action',
				-keyfield='id',
				'id_rule' = $rewrite_ruleid,
				'type' = (action_param: 'action_type'),
				'name' = (action_param: 'action_name'),
				'value' = (action_param: 'action_value'),
				'sort' = (action_param: 'action_sort'),
				'modified' = date->(format: '%Q %D');
			var: 'update_description' = true;
		/inline;
	/if;
	var: 'rewrite_error' = 'Changes will not take effect until you Reload Active Rules.';
else: ($trigger_action >> 'add') && ($rewrite_ruleid != '');
	if: (action_param: 'trigger_type') != '';
		inline: -log=$__startup_loglevel__,
				-add,
				-database='site',
				-table='rewrite_trigger',
				-keyfield='id',
				'id_rule' = $rewrite_ruleid,
				'type' = (action_param: 'trigger_type'),
				'name' = (action_param: 'trigger_name'),
				'comp' = (action_param: 'trigger_comp'),
				'value' = (action_param: 'trigger_value'),
				'sort' = (action_param: 'trigger_sort'),
				'modified' = date->(format: '%Q %D');
			var: 'rewrite_triggerid' = (keyfield_value);
			var: 'rewrite_action' = 'detail';
			var: 'update_description' = true;
			var: 'rewrite_error' = 'Changes will not take effect until Reload Active Rules is selected.';
		/inline;
	/if;
else: ($trigger_action >> 'update') && ($rewrite_triggerid != '');
	inline: -log=$__startup_loglevel__,
			-update,
			-database='site',
			-table='rewrite_trigger',
			-keyfield='id',
			-keyvalue=$rewrite_triggerid,
			'type' = (action_param: 'trigger_type'),
			'name' = (action_param: 'trigger_name'),
			'comp' = (action_param: 'trigger_comp'),
			'value' = (action_param: 'trigger_value'),
			'sort' = (action_param: 'trigger_sort'),
			'modified' = date->(format: '%Q %D');
		var: 'rewrite_action' = 'detail';
		var: 'update_description' = true;
		var: 'rewrite_error' = 'Changes will not take effect until Reload Active Rules is selected.';
	/inline;
else: ($trigger_action >> 'delete') && ($rewrite_triggerid != '');
	inline: -log=$__startup_loglevel__,
			-delete,
			-database='site',
			-table='rewrite_trigger',
			-keyfield='id',
			-keyvalue=$rewrite_triggerid;
		var: 'update_description' = true;
		var: 'rewrite_error' = 'Changes will not take effect until Reload Active Rules is selected.';
	/inline;
else: ($action_action >> 'add') && ($rewrite_ruleid != '');
	if: (action_param: 'action_type') != '';
		inline: -log=$__startup_loglevel__,
				-add,
				-database='site',
				-table='rewrite_action',
				-keyfield='id',
				'id_rule' = $rewrite_ruleid,
				'type' = (action_param: 'action_type'),
				'name' = (action_param: 'action_name'),
				'value' = (action_param: 'action_value'),
				'sort' = (action_param: 'action_sort'),
				'modified' = date->(format: '%Q %D');
			var: 'rewrite_actionid' = (keyfield_value);
			var: 'rewrite_action' = 'detail';
			var: 'update_description' = true;
			var: 'rewrite_error' = 'Changes will not take effect until Reload Active Rules is selected.';
		/inline;
	/if;
else: ($action_action >> 'update') && ($rewrite_actionid != '');
	inline: -log=$__startup_loglevel__,
			-update,
			-database='site',
			-table='rewrite_action',
			-keyfield='id',
			-keyvalue = $rewrite_actionid,
			'type' = (action_param: 'action_type'),
			'name' = (action_param: 'action_name'),
			'value' = (action_param: 'action_value'),
			'sort' = (action_param: 'action_sort'),
			'modified' = date->(format: '%Q %D');
		var: 'rewrite_action' = 'detail';
		var: 'update_description' = true;
		var: 'rewrite_error' = 'Changes will not take effect until Reload Active Rules is selected.';
	/inline;
else: ($action_action >> 'delete') && ($rewrite_actionid != '');
	inline: -log=$__startup_loglevel__,
			-delete,
			-database='site',
			-table='rewrite_action',
			-keyfield='id',
			-keyvalue=$rewrite_actionid;
		var: 'update_description' = true;
		var: 'rewrite_error' = 'Changes will not take effect until Reload Active Rules is selected.';
	/inline;
else: ($rewrite_action >> 'Update') && ($rewrite_ruleid != '');
	inline: -log=$__startup_loglevel__,
			-update,
			-database='site',
			-table='rewrite_rule',
			-keyfield='id',
			-keyvalue=$rewrite_ruleid,
			'name' = (action_param: 'rewrite_name'),
			'description' = '',
			'status' = (((action_param: 'rewrite_status') >> 'Y') ? 'Y' | 'N'),
			'option' = (action_param: 'rewrite_option'),
			'bool' = (action_param: 'rewrite_bool'),
			'sort' = (action_param: 'rewrite_sort'),
			'modified' = date->(format: '%Q %D');
		var: 'update_description' = true;
		var: 'rewrite_error' = 'Changes will not take effect until Reload Active Rules is selected.';
	/inline;
else: ($rewrite_action >> 'Delete') && ($rewrite_ruleid != '');
	inline: -log=$__startup_loglevel__,
			-delete,
			-database='site',
			-table='rewrite_rule',
			-keyfield='id',
			-keyvalue=$rewrite_ruleid;
	/inline;
	inline: -log=$__startup_loglevel__,
			-delete,
			-database='site',
			-table='rewrite_action',
			-keyfield='id_rule',
			-keyvalue=$rewrite_ruleid;
	/inline;
	inline: -log=$__startup_loglevel__,
			-delete,
			-database='site',
			-table='rewrite_trigger',
			-keyfield='id_rule',
			-keyvalue=$rewrite_ruleid;
	/inline;
	redirect_url: $admin_link + '&tab3=list';
else: ($rewrite_action >> 'Add Trigger');
	var: 'rewrite_triggerid' = 'new';
	var: 'rewrite_triggerdetail' = (map:
			'id' = 'new',
			'type' = '',
			'name' = '',
			'comp' = '',
			'value' = '',
		);
	var: 'rewrite_action' = 'Detail';
else: ($rewrite_action >> 'Add Action');
	var: 'rewrite_actionid' = 'new';
	var: 'rewrite_actiondetail' = (map:
			'id' = 'new',
			'type' = '',
			'name' = '',
			'comp' = '',
			'value' = '',
		);
	var: 'rewrite_action' = 'Detail';
else: ($rewrite_action >> 'Add');
	var: 'rewrite_ruleid' = 'new';
	var: 'rewrite_actionid' = 'new';
	var: 'rewrite_triggerid' = 'new';
	var: 'rewrite_ruledetail' = (map:
			'id' = 'new',
			'name' = 'New Rule',
			'description' = 'This is a new rule',
			'status' = 'Y',
			'sort' = 32768,
		);
	var: 'rewrite_actiondetail' = (map:
			'id' = 'new',
			'type' = '',
			'name' = '',
			'comp' = '',
			'value' = '',
			'sort' = 32768,
		);
	var: 'rewrite_triggerdetail' = (map:
			'id' = 'new',
			'type' = '',
			'name' = '',
			'comp' = '',
			'value' = '',
			'sort' = 32768,
		);

/if;


if: ($update_description == true) && ($rewrite_ruleid != 'new');

	inline: -log=$__startup_loglevel__,
			-search,
			-database='site',
			-table='rewrite_rule',
			-keyfield='id',
			-keyvalue=$rewrite_ruleid,
			-maxrecords=1;
		records;
			var: 'description' = '';
			inline: -log=$__startup_loglevel__,
					-search,
					-database='site',
					-table='rewrite_trigger',
					-op='eq', 'id_rule'=$rewrite_ruleid,
					-maxrecords='all',
					-sortfield='sort';
				if: found_count > 0;
					$description += '<b>Triggers:</b> ';
				/if;
				records;
					$description += (trigger_summary: (field: 'type'), (field: 'name'), (field: 'comp'), (field: 'value'));
					$description += '<br />';
				/records;
			/inline;
			inline: -log=$__startup_loglevel__,
					-search,
					-database='site',
					-table='rewrite_action',
					-op='eq', 'id_rule'=$rewrite_ruleid,
					-maxrecords='all',
					-sortfield='sort';
				if: found_count > 0;
					$description += '<b>Actions:</b> ';
				/if;
				records;
					$description += (action_summary: (field: 'type'), (field: 'name'), (field: 'value'));
					$description += '<br />';
				/records;
			/inline;
			$description->(removetrailing: '<br />');
			inline: -log=$__startup_loglevel__,
					-update,
					-database='site',
					-table='rewrite_rule',
					-keyfield='id',
					-keyvalue=$rewrite_ruleid,
					'description' = $description;
			/inline;
		/records;
	/inline;

/if;


var: 'rewrite_rulemap' = (array);

inline: -log=$__startup_loglevel__,
		-search,
		-database='site',
		-table='rewrite_rule',
		-sortfield='sort',
		-maxrecords='all';
	var: 'field_names' = field_names;
	records;
		var: 'temp_rulemap' = map;
		iterate: $field_names, (var: 'field_name');
			$temp_rulemap->(insert: $field_name = (field: $field_name));
		/iterate;
		if: ((field: 'id') == $rewrite_ruleid);
			var: 'rewrite_ruledetail' = $temp_rulemap;
		/if;
		$rewrite_rulemap->(insert: $temp_rulemap);
	/records;
/inline;

var: 'found_count' = $rewrite_rulemap->size;

if: ($rewrite_ruledetail != null) && ($rewrite_ruleid != 'new');
	var: 'rewrite_ruletriggers' = array;
	var: 'rewrite_ruleactions' = array;
	if: $rewrite_ruleid != 'new';
		inline: -log=$__startup_loglevel__,
				-search,
				-database='site',
				-table='rewrite_trigger',
				-op='eq', 'id_rule'=$rewrite_ruleid,
				-maxrecords='all',
				-sortfield='sort';
			var: 'field_names' = field_names;
			records;
				var: 'temp_ruletrigger' = map;
				iterate: $field_names, (var: 'field_name');
					$temp_ruletrigger->(insert: $field_name = (field: $field_name));
				/iterate;
				if: $rewrite_triggerid == (field: 'id');
					var: 'rewrite_triggerdetail' = $temp_ruletrigger;
				/if;
				$rewrite_ruletriggers->(insert: $temp_ruletrigger);
			/records;
		/inline;
		inline: -log=$__startup_loglevel__,
				-search,
				-database='site',
				-table='rewrite_action',
				-op='eq', 'id_rule'=$rewrite_ruleid,
				-maxrecords='all',
				-sortfield='sort';
			var: 'field_names' = field_names;
			records;
				var: 'temp_ruleaction' = map;
				iterate: $field_names, (var: 'field_name');
					$temp_ruleaction->(insert: $field_name = (field: $field_name));
				/iterate;
				if: $rewrite_actionid == (field: 'id');
					var: 'rewrite_actiondetail' = $temp_ruleaction;
				/if;
				$rewrite_ruleactions->(insert: $temp_ruleaction);
			/records;
		/inline;
	/if;
/if;

if: ((var: 'rewrite_ruleid') != 'new');
	iterate: $admin_tab_array3, (var: 'temp1');
		if: $temp1->first == ($admin_tab1 + ':' + $admin_tab2);
			iterate: $temp1->second, (var: 'temp2');
				if: $temp2->first == 'edit';
					$temp2->second = 'Edit Rule';
				/if;
			/iterate;
		/if;
	/iterate;
/if;

//
// Started/Enabled?
// 

var: 'rewrite_started' = false;
loop: -from=site_atbegin->size, -to=1, -by=-1;
	if: site_atbegin->(get: loop_count) == 'rewrite';
		var: 'rewrite_started' = true;
		loop_abort;
	/if;
/loop;

var: 'rewrite_enabled' = (admin_getpref: 'lasso_urlrewrite') !>> 'N';

if: ($rewrite_enabled == false) && ((var: 'rewrite_error') >> 'reload');
	var: 'rewrite_error' = 'The URL Rewrite system is disabled. Changes will not take effect until it is enabled.';
else: ($rewrite_started == false) && ((var: 'rewrite_error') >> 'reload');
	var: 'rewrite_error' = 'The URL Rewrite system is temporarily stopped. Changes will not take effect until it is started.';
/if;


?>
