<?LassoScript

//
// Variables
//

_admin_addvar: 'rewrite_action', -default='None', -override=(action_param: 'rewrite_action', (action_param: 'rewrite_action', -count));
_admin_addvar: 'rewrite_ruleid', -override=(action_param: 'rewrite_ruleid');

//
// Process Action
//

if: ($rewrite_action >> 'Reload') || ($rewrite_action >> 'Enable') || ($rewrite_action >> 'Disable') || ($rewrite_action >> 'Start') || ($rewrite_action >> 'Stop');

	loop: -from=site_atbegin->size, -to=1, -by=-1;
		if: site_atbegin->(get: loop_count) == 'rewrite';
		  site_atbegin->(remove: loop_count);
		/if;
	/loop;
	if: ($rewrite_action >> 'Reload') || ($rewrite_action >> 'Enable') || ($rewrite_action >> 'Start');
		define_atbegin: url_rewrite;
	/if;
	if: ($rewrite_action >> 'Enable');
		admin_setpref: 'lasso_urlrewrite', 'Y';
	else: ($rewrite_action >> 'Disable');
		admin_setpref: 'lasso_urlrewrite', 'N';
	/if;
	redirect_url: $admin_link + '&tab3=list';
	
else: ($rewrite_action >> 'Add');

	redirect_url: $admin_link + '&tab3=edit';

/if;


var: 'rewrite_rulemap' = (array);

inline: -log=$__startup_loglevel__,
		-search,
		-database='site',
		-table='rewrite_rule',
		-sortfield='sort',
		-maxrecords='all';
	var: 'field_names' = field_names;
	records;
		var: 'temp_rulemap' = map;
		iterate: $field_names, (var: 'field_name');
			$temp_rulemap->(insert: $field_name = (field: $field_name));
		/iterate;
		if: ((field: 'id') == $rewrite_ruleid);
			var: 'rewrite_ruledetail' = $temp_rulemap;
		/if;
		$rewrite_rulemap->(insert: $temp_rulemap);
	/records;
/inline;

var: 'found_count' = $rewrite_rulemap->size;

//
// Started/Enabled?
// 

var: 'rewrite_started' = false;
loop: -from=site_atbegin->size, -to=1, -by=-1;
	if: site_atbegin->(get: loop_count) == 'rewrite';
		var: 'rewrite_started' = true;
		loop_abort;
	/if;
/loop;

var: 'rewrite_enabled' = (admin_getpref: 'lasso_urlrewrite') !>> 'N';


?>
