<?LassoScript

//
// Variables
//

_admin_addvar: -session='_siteadmin', 'groups_connectorid', -default=1, -override=(action_param: 'groups_connectorid');
_admin_addvar: -session='_siteadmin', 'groups_hostid', -default=1, -override=(action_param: 'groups_hostid');
_admin_addvar: -session='_siteadmin', 'groups_databaseid', -override=(action_param: 'groups_databaseid');
_admin_addvar: -session='_siteadmin', 'groups_tableid', -override=(action_param: 'groups_tableid');

_admin_addvar: -session='_siteadmin', 'groups_groupid', -default=1, -override=(action_param: 'groups_groupid');

_admin_addvar: 'groups_action', -default='None', -override=(action_param: 'groups_action');

var: 'admin_listingsize' = (integer: (admin_getpref: 'lasso_admin_listingsize', -default='10'));

if: ($groups_connectorid < 1);
	$groups_connectorid = 1;
/if;

if: ((action_param: 'header') >> 'Select') && ((action_param: 'group_header') != null);
	$groups_groupid = (action_param: 'group_header');
/if;


//
// Build Menus
//
var: 'groups_connectormap' = (array);
var: 'groups_hostmap' = (array);
var: 'groups_databasemap' = (array);
var: 'groups_tablemap' = (array);
var: 'groups_groupmap' = (array);

if: ($admin_tab3 >> 'host') || ($admin_tab3 >> 'database') || ($admin_tab3 >> 'table') || ($admin_tab3 == '');

	var: 'groups_connectormap' = (_admin_listconnectors);
	var: 'temp' = (_admin_defaultconnector: -id=$groups_connectorid);
	if: ($temp != null);
		var: 'groups_connectorid' = $temp->first;
		var: 'groups_connectordetail' = $temp->second;
		var: 'groups_connectoralias' = $groups_connectordetail->(find: 'alias');
	else;
		var: 'groups_connectorid' = 0;
	/if;

	if: ($groups_action >> 'Refresh') && ($groups_connectorid != 0);
		_admin_refreshsecurity;
		_admin_refreshconnector: $groups_connectorid;
	/if;

	if: ($groups_connectorid > 0);
		var: 'groups_hostmap' = (_admin_listhosts: $groups_connectorid);
		var: 'temp' = (_admin_defaulthost: $groups_hostid);
		if: ($temp != null);
			var: 'groups_hostid' = $temp->first;
			var: 'groups_hostdetail' = $temp->second;
		else;
			var: 'groups_hostid' = 0;
		/if;
	else;
		var: 'groups_hostid' = 0;
	/if;

	if: ($groups_hostid > 0);
		var: 'groups_databasemap' = (_admin_listdatabases: $groups_hostid);
		var: 'temp' = (_admin_defaultdatabase: $groups_databaseid, $groups_databasemap);
		if: ($temp != null);
			var: 'groups_databaseid' = $temp->first;
			var: 'groups_databasedetail' = $temp->second;
			var: 'groups_databasename' = $groups_databasedetail->(find: 'name');
			var: 'groups_databasealias' = $groups_databasedetail->(find: 'alias');
		else;
			var: 'groups_databaseid' = 0;
		/if;
	else;
		var: 'groups_databaseid' = 0;
	/if;

/if;

if: ($admin_tab3 >> 'database') || ($admin_tab3 >> 'table') || ($admin_tab3 == '');

	if: ($groups_databaseid > 0);
		var: 'groups_tablemap' = (_admin_listtables: $groups_databaseid);
		var: 'temp' = (_admin_defaulttable: $groups_tableid, $groups_tablemap);
		if: ($temp != null);
			var: 'groups_tableid' = $temp->first;
			var: 'groups_tabledetail' = $temp->second;
			var: 'groups_tablename' = $groups_tabledetail->(find: 'name');
			var: 'groups_tablealias' = $groups_tabledetail->(find: 'alias');
		else;
			var: 'groups_tableid' = 0;
		/if;
	else;
		var: 'groups_tableid' = 0;
	/if;

/if;

var: 'groups_groupmap' = (_admin_listgroups);
// We don't allow the Administrators group to be modified
if: $groups_groupid == 2;
	$groups_groupid = 1;
/if;
var: 'temp' = (_admin_defaultgroup: $groups_groupid, $groups_groupmap);
if: ($temp != null);
	var: 'groups_groupid' = $temp->first;
	var: 'groups_groupdetail' = $temp->second;
	var: 'groups_groupname' = $groups_groupdetail->(find: 'name');
else;
	var: 'groups_groupid' = 0;
/if;

?>