<?LassoScript

//
// Variables
//

_admin_addvar: -session='_siteadmin', 'users_groupid', -override=(action_param: 'users_groupid');
_admin_addvar: -session='_siteadmin', 'users_userid', -override=(action_param: 'users_userid');

_admin_addvar: 'users_action', -default='None', -override=(action_param: 'users_action');

//
// Build Menus
//
var: 'users_groupmap' = (array);
var: 'users_usermap' = (array);

var: 'users_groupmap' = (_admin_listgroups);
var: 'temp' = (_admin_defaultgroup: $users_groupid, $users_groupmap);
if: ($temp != null);
	var: 'users_groupid' = $temp->first;
	var: 'users_groupdetail' = $temp->second;
	var: 'users_groupname' = $users_groupdetail->(find: 'name');
else;
	var: 'users_groupid' = 0;
/if;


var: 'users_usermap' = (_admin_listusers);
var: 'temp' = (_admin_defaultuser: $users_userid, $users_usermap);
if: ($temp != null);
	var: 'users_userid' = $temp->first;
	var: 'users_userdetail' = $temp->second;
	var: 'users_username' = $users_userdetail->(find: 'name');
else;
	var: 'users_userid' = 0;
/if;

var: 'users_listing' = (array);
iterate: $users_usermap, (var: 'tuser');
	$users_listing->(insert: $tuser->second->(find: 'name'));
/iterate;

//
// Variables
//

_admin_addvar: 'users_action', -default='None', -override=(action_param: 'users_action', (action_param: 'users_action', -count));
_admin_addvar: 'users_addaction', -default='None', -override=(action_param: 'users_addaction', (action_param: 'users_addaction', -count));
_admin_addvar: 'users_groupfilter', -default='AnyUser', -session='_siteadmin', -override=(action_param: 'users_groupfilter');

_admin_addvar: 'user_name', -default='None', -override=(action_param: 'user_name');
_admin_addvar: 'user_password', -default='None', -override=(action_param: 'user_password');
_admin_addvar: 'user_enabled', -default='None', -override=(action_param: 'user_enabled');
//_admin_addvar: 'user_groups', -default='None', -override=(action_param: 'user_groups');
//_admin_addvar: 'user_admins', -default='None', -override=(action_param: 'user_admins');
_admin_addvar: 'user_currentgroups', -default='None', -override=(action_param: 'user_currentgroups');
_admin_addvar: 'user_currentadmins', -default='None', -override=(action_param: 'user_currentadmins');

_admin_addvar: 'users_actionraw', -default='None', -override=(action_param: 'users_action');
_admin_addvar: 'users_user_skip', -default=1, -session='_siteadmin', -override=(action_param: 'users_user_skip');
_admin_addvar: 'users_navigation', -override=(action_param: 'users_navigation');
_admin_addvar: 'users_jump', -override=(action_param: 'users_jump');

_admin_addvar: 'dialog_action', -override=(action_param: 'dialog_action');

//
// Process Action
//

if: $users_addaction >> 'Add';

	var: 'users_action' = 'Add User';

	if: $users_listing >> $user_name;
		var: 'users_error' = 'The user ' + $user_name + ' already exists.';
	else: (admin_userexists: $user_name);
		var: 'users_error' = 'The user ' + $user_name + ' is reserved.';
	else;
		_admin_adduser: 'enabled'=$user_enabled, 'name'=$user_name, 'password'=(encrypt_md5: $user_password), 'password_plain'=$user_password;
		if: $_code != (error_noerror);
			var: 'users_error' = $_error + ' (' + $_code + ')';
		else;
			var: 'users_message' = 'The user was added successfully.';
		/if;
	/if;

	if: !(var_defined: 'users_error');
		_admin_refreshsecurity;
		var: 'users_usermap' = (_admin_listusers);
		var: 'users_userid' = 0;

		iterate: $users_usermap, (var: 'temp_user');
			var: 'temp'=@($temp_user->second);

			if: $temp->(find: 'name') == $user_name;
				var: 'users_userid' = $temp->(find: 'id');
				var: 'users_userdetail' = $temp;
			/if;
		/iterate;

		var: 'temp_groups' = (array);
		loop: (action_param: 'user_groups', -count);
			var: 'temp' = (action_param: 'user_groups', loop_count);
			if: $temp != '';
				$temp_groups->(insert: $temp);
			/if;
		/loop;
		var: 'temp_admins' = (array);
		loop: (action_param: 'user_admins', -count);
			var: 'temp' = (action_param: 'user_admins', loop_count);
			if: $temp != '';
				$temp_admins->(insert: $temp);
			/if;
		/loop;

		iterate: $temp_groups, (var: 'temp');
			if: $temp_admins >> $temp;
				var: 'admin'='Y';
			else;
				var: 'admin'='N';
			/if;

			if: ($temp != '') && ($temp == (string: integer: $temp));
				inline: -log=$__startup_loglevel__, -add,
					-database='lasso_internal',
					-table='security_ug_map',
					'id_user'=$users_userid,
					'id_group'=$temp,
					'admin'=$admin,
					'precedence'=1,
					'modified' = date->(format: '%Q %T');
				/inline;
			/if;
		/iterate;

		_security_flushcaches;

		var: 'users_action' = 'Refresh Detail';

	/if;

/if;

if: $users_action >> 'Update';

	if: ($users_listing >> $user_name) && ($users_username != $user_name);
		var: 'users_error' = 'The user ' + $user_name + ' already exists.';
	else: $users_userid > 2;
		if: $user_password != $users_userdetail->(find: 'password');
			_admin_updateuser: $users_userid, 'enabled'=$user_enabled, 'name'=$user_name, 'password'=(encrypt_md5: $user_password), 'password_plain'=$user_password, 'modified'=date->(format: '%Q %T');
		else;
			_admin_updateuser: $users_userid, 'enabled'=$user_enabled, 'name'=$user_name, 'modified'=date->(format: '%Q %T');
		/if;

		if: $_code != (error_noerror);
			var: 'users_error' = $_error + ' (' + $_code + ')';
		else;
			var: 'users_message' = 'The user was updated successfully.';
		/if;

	/if;

	if: !(var_defined: 'users_error');
		if: ($user_currentgroups != '') && ($user_currentgroups != 'None');
			var: 'sql' = 'DELETE FROM security_ug_map WHERE id_user = ' + $users_userid + ' AND id_group IN (' + $user_currentgroups + ')';
			inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords='all'; /inline;
		/if;

		var: 'temp_groups' = (array);
		loop: (action_param: 'user_groups', -count);
			var: 'temp' = (action_param: 'user_groups', loop_count);
			if: $temp != '';
				$temp_groups->(insert: $temp);
			/if;
		/loop;
		var: 'temp_admins' = (array);
		loop: (action_param: 'user_admins', -count);
			var: 'temp' = (action_param: 'user_admins', loop_count);
			if: $temp != '';
				$temp_admins->(insert: $temp);
			/if;
		/loop;

		iterate: $temp_groups, (var: 'temp');
			if: $temp_admins >> $temp;
				var: 'admin'='Y';
			else;
				var: 'admin'='N';
			/if;

			if: ($temp != '') && ($temp == (string: integer: $temp));
				inline: -log=$__startup_loglevel__, -add,
					-database='lasso_internal',
					-table='security_ug_map',
					'id_user'=$users_userid,
					'id_group'=$temp,
					'admin'=$admin,
					'precedence'=1;
				/inline;
			/if;
		/iterate;

		_security_flushcaches;
	/if;

	var: 'users_action' = 'Detail Refresh';

/if;

if: $users_action >> 'Add User';

	// Create the template for a new user

	var: 'users_userdetail' = (map: 'name'='New User', 'password'='', 'enabled'='Y', 'status'='enabled', 'id'=(-1));
	var: 'users_userid' = -1;

/if;

if: $users_action >> 'Enable All';

	inline: -log=$__startup_loglevel__, -database='lasso_internal',
			-sql='UPDATE security_users SET enabled="Y" WHERE id > 2';
	/inline;

	var: 'users_action' = 'Refresh';
	_security_flushcaches;

/if;

if: $users_action >> 'Disable All';

	inline: -log=$__startup_loglevel__, -database='lasso_internal',
			-sql='UPDATE security_users SET enabled="N" WHERE id > 2';
	/inline;

	var: 'users_action' = 'Refresh';
	_security_flushcaches;

/if;

if: $dialog_action >> 'Delete';

	if: $users_userid > 2;
		_admin_deleteuser: $users_userid;
		if: $_code != (error_noerror);
			var: 'users_error' = $_error + ' (' + $_code + ')';
		else;
			var: 'users_message' = 'The user was deleted successfully.';
		/if;

		if: (var: 'users_error') == '';
			_admin_refreshsecurity;

			var: 'users_usermap' = (_admin_listusers);
			var: 'users_userid' = 0;

			_security_flushcaches;

			var: 'users_action' = 'None';
		/if;
	/if;

/if;

if: $users_action >> 'Refresh';

	_admin_refreshsecurity;
	var: 'users_usermap' = (_admin_listusers);
	var: 'temp' = (_admin_defaultuser: $users_userid, $users_usermap);
	if: ($temp != null);
		var: 'users_userid' = $temp->first;
		var: 'users_userdetail' = $temp->second;
		var: 'users_username' = $users_userdetail->(find: 'name');
	else;
		var: 'users_userid' = 0;
	/if;

/if;

//
// Add/Remove special groups from user and group map
//

if: $users_usermap->size >= 2;
	$users_usermap->(removeall:2);
/if;

if: $users_groupmap->size >= 2;
	$users_groupmap->(removeall:1);
	$users_groupmap->(removeall:2);
/if;


//
// Group Membership
//

var: 'users_ids' = (array);
var: 'users_groups' = (map);
var: 'users_admins' = (map);

iterate: $users_usermap, (var: 'item');
	$users_ids->(insert: $item->first);
	$users_groups->(insert: $item->first = (array));
	$users_admins->(insert: $item->first = (array));
/iterate;

if: ($users_groupfilter >> 'AnyUser') || ($users_groupfilter >> 'None');
	var: 'sql' = 'SELECT * FROM security_ug_map WHERE id_user IN (' + $users_ids->(join:',') + ') AND id_group != \'1\' ORDER BY id_user';
else: ($users_groupfilter >> 'Admins');
	var: 'sql' = 'SELECT * FROM security_ug_map WHERE id_user IN (' + $users_ids->(join:',') + ') AND admin = \'Y\' AND id_group != \'1\' ORDER BY id_user';
else: ($users_groupfilter >> 'search');
	var: 'sql' = 'SELECT * FROM security_users LEFT JOIN security_ug_map ON security_users.id = security_ug_map.id_user WHERE security_ug_map.id_user != \'\' && security_ug_map.id_group != \'\' && security_users.id IN (' + $users_ids->(join:',') + ') ' + $users_search_sql + ' ORDER BY id_user';
else;
	var: 'sql' = 'SELECT * FROM security_ug_map WHERE id_user IN (' + $users_ids->(join:',') + ') AND id_group = \'' + $users_groupfilter + '\' ORDER BY id_user';
/if;

inline: -log=$__startup_loglevel__, -database='lasso_internal', -sql=$sql, -maxrecords='all';
	records;

		if: ((field: 'id_user') != '') && ((field: 'id_group') != '');
			var: 'temp' = $users_groups->(find: (field: 'id_user'));
			$temp->(insert: (field: 'id_group'));
			$users_groups->(insert: (field: 'id_user') = $temp);
			if: (field: 'admin') == 'Y';
				var: 'temp' = $users_admins->(find: (field: 'id_user'));
				$temp->(insert: (field: 'id_group'));
				$users_admins->(insert: (field: 'id_user') = $temp);
			/if;
		/if;
	/records;
/inline;


if: ($users_groupfilter >> 'AnyUser');

	// Do Nothing

else: ($users_groupfilter >> 'None');

	// Keep any users that are not in the group
	var: 'temp_array' = $users_usermap;
	var: 'users_usermap' = (array);
	var: 'users_ids' = (array);

	iterate: $users_groups, (var: 'temp');
		var: 'id' = $temp->first;
		var: 'groups' = $temp->second;
		if: $groups == (array);
			$users_ids->(insert: $id);
			$users_usermap->(insert: $temp_array->(find: $id)->(get:1));
		/if;
	/iterate;

else: ($users_groupfilter >> 'Admins');

	// Remove any users that are not admins
	var: 'temp_array' = $users_usermap;
	var: 'users_usermap' = (array);
	var: 'users_ids' = (array);

	iterate: $users_admins, (var: 'temp');
		var: 'id' = $temp->first;
		var: 'admins' = $temp->second;
		if: $admins != (array);
			$users_ids->(insert: $id);
			$users_usermap->(insert: $temp_array->(find: $id)->(get:1));
		/if;
	/iterate;

else;

	// Remove any users that are not in the group
	var: 'temp_array' = $users_usermap;
	var: 'users_usermap' = (array);
	var: 'users_ids' = (array);

	iterate: $users_groups, (var: 'temp');
		var: 'id' = $temp->first;
		var: 'groups' = $temp->second;
		if: $groups != (array);
			$users_ids->(insert: $id);
			$users_usermap->(insert: $temp_array->(find: $id)->(get:1));
		/if;
	/iterate;

/if;


//
// Process Navigation
//

if: $users_navigation >> 'Prev';
	$users_user_skip -= $admin_listingsize;
else: $users_navigation >> 'Next';
	$users_user_skip += $admin_listingsize;
else: $users_navigation >> 'First';
	$users_user_skip = 1;
else: $users_navigation >> 'Last';
	$users_user_skip = $users_usermap->size - (($users_usermap->size - 1) % $admin_listingsize);
else: $users_navigation >> 'Jump';
	$users_user_skip = integer: $users_jump;
/if;

var: 'found_count' = $users_usermap->size;
var: 'users_user_skip' = integer: (math_max: 1, (math_min: $users_user_skip, $found_count));
var: 'shown_first' = $users_user_skip;
var: 'shown_last' = integer: (math_min: $found_count, $users_user_skip + ($admin_listingsize - 1));
var: 'shown_count' = ($shown_last - $shown_first + 1);

?>
