<?LassoScript

var: 'admin_refresh' = (integer: (admin_getpref: 'lasso_admin_queuerefresh', -default='1')) * 60;

_admin_addvar: 'event_status', -session='_siteadmin', -default='schedule', -override=(action_param: 'event_status');
_admin_addvar: 'event_action', -default='None', -override=(action_param: 'event_action');
_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');

_admin_addvar: 'event_id', -override=(action_param: 'event_id');

_admin_addvar: 'event_skip', -default=0, -session='_siteadmin', -override=(action_param: 'event_skip');
_admin_addvar: 'event_max', -default=10;
_admin_addvar: 'event_navigation', -override=(action_param: 'event_navigation');
_admin_addvar: 'event_jump', -override=(action_param: 'event_jump');
_admin_addvar: 'event_found', -override=(action_param: 'event_found');

_admin_addvar: 'event_sortfield', -default='id', -session='_siteadmin', -override=(action_param: 'event_sortfield');
_admin_addvar: 'event_sortorder', -default='ascending', -session='_siteadmin', -override=(action_param: 'event_sortorder');

_admin_addvar: 'event_oldstatus', -override=(action_param: 'event_oldstatus');
if: ($event_oldstatus == '') || ($event_oldstatus != $event_status);
	var: 'event_skip' = 0;
/if;

var: 'event_skip' = (integer: $event_skip);
var: 'event_max' = (integer: $event_max);
var: 'event_found' = (integer: $event_found);

if: ($event_navigation >> 'Next');
	$event_skip = (integer: ($event_skip + $event_max));
else: ($event_navigation >> 'Prev');
	$event_skip = (integer: (math_max: $event_skip - $event_max, 0));
else: ($event_navigation >> 'Last');
	$event_skip = $event_found->size - (($event_found->size - 1) % $event_max);
else: ($event_navigation >> 'First') || ($event_navigation >> 'Sort');
	$event_skip = 0;
else: ($event_navigation >> 'Jump') || ((action_param: 'event_navigation_skip') != '');
	$event_skip = (math_max: (integer: (action_param: 'event_navigation_skip')) - 1, 0);
/if;

if: ($event_skip > 0) && ($event_found > 0);
	$event_skip = (math_max: (math_min: $event_found - 1, $event_skip), 0);
/if;


var: 'event_inline' = (array);

$event_inline->(insert: -findall='');

$event_inline->(insert: -database='site');
$event_inline->(insert: -table='schedule');

$event_inline->(insert: -maxrecords=10);
$event_inline->(insert: -skiprecords=$event_skip);

$event_inline->(insert: -sortfield=$event_sortfield);
$event_inline->(insert: -sortorder=$event_sortorder);


if: $dialog_action >> 'Delete All';

	inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM schedule';
	/inline;

else: ($event_action >> 'Delete') && ($event_id != '');

	inline: -log=$__startup_loglevel__, -database='site', -table='schedule', -keyfield='id', -keyvalue=$event_id, -delete;
	/inline;

else: ($event_action >> 'Event Queue');

	if: ($event_action >> 'Stop');
		global: '__Schedule_Status__' = 'Pause';
		var: 'pref' = 'Y';
		log_warning: 'Schedule: Pausing Event Queue';
	else;
		global: '__Schedule_Status__' = 'Active';
		var: 'pref' = 'N';
		log_warning: 'Schedule: Restarting Event Queue';
	/if;

	inline: -log=$__startup_loglevel__, -database='lasso_internal', -table='global_prefs', -delete, -keyfield='store_key', -keyvalue='lasso_schedule_pause';
	/inline;

	inline: -log=$__startup_loglevel__, -database='lasso_internal', -table='global_prefs', -add, 'store_key'='lasso_schedule_pause', 'data'=$pref;
	/inline;

/if;

?>
