<?LassoScript

var: 'admin_refresh' = (integer: (admin_getpref: 'lasso_admin_errorrefresh', -default='1')) * 60;

_admin_addvar: 'event_filter', -default='', -force=(action_param: 'event_filter');
_admin_addvar: 'event_action', -default='None', -override=(action_param: 'event_action');
_admin_addvar: 'event_date', -default='', -override=(action_param: 'event_date');
_admin_addvar: 'event_id', -default='', -override=(action_param: 'event_id');

_admin_addvar: 'event_skip', -default=0, -session='_siteadmin', -override=(action_param: 'event_skip');
_admin_addvar: 'event_max', -default=(integer: (admin_getpref: 'lasso_admin_queuesize', -default=25));
_admin_addvar: 'event_navigation', -override=(action_param: 'event_navigation');
_admin_addvar: 'event_jump', -override=(action_param: 'event_jump');
_admin_addvar: 'event_found', -default=0, -session='_siteadmin';

_admin_addvar: 'event_sortfield', -default='next_execute', -session='_siteadmin', -override=(action_param: 'event_sortfield');
_admin_addvar: 'event_sortorder', -default='descending', -session='_siteadmin', -override=(action_param: 'event_sortorder');

_admin_addvar: 'event_oldfilter', -session='_siteadmin', -override=(action_param: 'event_oldfilter');
if: ($event_oldfilter == '') || ($event_oldfilter != $event_filter);
	var: 'event_skip' = 0;
/if;

var: 'event_skip' = (integer: $event_skip);
var: 'event_max' = (integer: $event_max);
var: 'event_found' = (integer: $event_found);

if: ($event_navigation >> 'Next');
	$event_skip = (integer: ($event_skip + $event_max));
else: ($event_navigation >> 'Prev');
	$event_skip = (integer: (math_max: $event_skip - $event_max, 0));
else: ($event_navigation >> 'Last');
	$event_skip = $event_found - $event_max;
else: ($event_navigation >> 'First') || ($event_navigation >> 'Sort');
	$event_skip = 0;
else: ($event_navigation >> 'Jump') || ((action_param: 'event_navigation_skip') != '');
	$event_skip = (math_max: (integer: (action_param: 'event_navigation_skip')) - 1, 0);
/if;

if: ($event_skip > 0) && ($event_found > 0);
	$event_skip = (math_max: (math_min: $event_found - 1, $event_skip), 0);
/if;


var: 'event_inline' = (array);

$event_inline->(insert: -search='');
$event_inline->(insert: -database='site');
$event_inline->(insert: -table='schedule');

$event_inline->(insert: -maxrecords=$event_max);
$event_inline->(insert: -skiprecords=$event_skip);

$event_inline->(insert: -sortfield=$event_sortfield);
$event_inline->(insert: -sortorder=$event_sortorder);

if: $event_filter != '';

	$event_inline->(insert: -op='cn');
	$event_inline->(insert: 'executeAction'=$event_filter);

/if;

if: ($event_action >> 'Events') && ($event_action >> 'Pause');

	global: '__Schedule_Status__' = 'Pause';
	admin_setpref: -name='lasso_schedule_pause', -value='Y';
	log_warning: 'Schedule: Pausing Event Queue';

else: ($event_action >> 'Events') && ($event_action >> 'Resume');

	global: '__Schedule_Status__' = 'Active';
	admin_setpref: -name='lasso_schedule_pause', -value='N';
	log_warning: 'Schedule: Restarting Event Queue';
	
	admin_setpref: -name='lasso_schedule_pause', -value='N';

else: ($event_action >> 'Pause') && ($event_id != '');

	inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE schedule SET date_time_start = "3001-01-01 00:00:00" WHERE id = "' + (integer: $event_id) + '"';
	/inline;

else: ($event_action >> 'Resume') && ($event_id != '');

	inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE schedule SET date_time_start = "' + date->(format: '%Q %T') + '" WHERE id = "' + (integer: $event_id) + '"';
	/inline;

else: ($event_action >> 'Edit') && ($event_id != '');

	inline: -log=$__startup_loglevel__, -database='site', -sql='UPDATE schedule SET date_time_start = "3001-01-01 00:00:00" WHERE id = "' + (integer: $event_id) + '"';
	/inline;
	redirect_url: $admin_link + '&tab3=addevent&event_action=edit&event_id=' + $event_id;

else: ($event_action >> 'Error') && ($event_id != '');

	redirect_url: $admin_link + '&tab3=errors&event_action=show&event_id=' + $event_id;

else: ($event_action >> 'Delete') && ($event_id != '');

	inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM schedule_error WHERE id_schedule = "' + (integer: $event_id) + '"';
	/inline;
	inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM schedule WHERE id = "' + (integer: $event_id) + '"';
	/inline;

else: ($event_action >> 'Clear') && ($event_id != '');

	inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM schedule_error WHERE id_schedule = "' + (integer: $event_id) + '"';
	/inline;

else: $event_action >> 'Delete All';

	var: 'event_found' = 0;
	var: 'event_skip' = 0;

	inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM schedule';
	/inline;

/if;

?>
