<div class="sidebar">

<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">

	<h2 onclick="toggleDisplayBlock('srch')">Lasso Threads</h2>
	<div id="srch">
		<p>
			<b>Priority</b>
			<br />
			<select name="priority" onchange="this.form.submit();">
				<option value="all" [if: (var: 'thread_priority') >> 'all']selected="selected"[/if]>All</option>
				<option value="high" [if: (var: 'thread_priority') >> 'high']selected="selected"[/if]>High</option>
				<option value="default" [if: (var: 'thread_priority') >> 'default']selected="selected"[/if]>Default</option>
				<option value="low" [if: (var: 'thread_priority') >> 'low']selected="selected"[/if]>Low</option>
			</select>
		</p>
		<p style="margin-bottom: 3px; align: right;">
			<input type="submit" name="mysql_action" value="Select" class="half" />
		</p>
	</div>

	<h2 onclick="toggleDisplayBlock('sum')">Summary</h2>
	<div id="sum">
		<p>
			Showing [integer: $thread_array->size] Threads
		</p>
	</div>
</form>

</div>

<div class="content_full2">

[var: 'year' = (integer: date->year)]
[iterate: $thread_array, (var: 'thread_detail')]
	<div class="content_panel"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b><div class="content_inner">
		<span>
[var: 'startyear' = 0][protect][var: 'startyear' = (integer: $thread_detail->(find: 'starttime')->year)][/protect]
[if: $year - $startyear > 100]
			<span class="onethird">
				<b>Thread Priority: </b> [encode_html: $thread_detail->(find: 'priority')]
			</span>
			<b>Thread Name:</b> [encode_html: $thread_detail->(find: 'name')]
			<br />
			<b>Thread ID:</b> [encode_html: $thread_detail->(find: 'id')]
[else]
			<span class="onethird">
				<b>Thread Priority: </b> [encode_html: $thread_detail->(find: 'priority')]<br />
				[if: $thread_detail->(find: 'priority') != 'high']<a href="[var: 'admin_link']&id=[$thread_detail->(find: 'id')]&action=high">Set High Priority</a><br />[/if]
				[if: $thread_detail->(find: 'priority') != 'default']<a href="[var: 'admin_link']&id=[$thread_detail->(find: 'id')]&action=default">Set Default Priority</a><br />[/if]
				[if: $thread_detail->(find: 'priority') != 'low']<a href="[var: 'admin_link']&id=[$thread_detail->(find: 'id')]&action=low">Set Low Priority</a><br />[/if]
				<a href="[var: 'admin_link']&id=[$thread_detail->(find: 'id')]&action=abort" onclick="return confirm('Are you sure you want to abort this thread?');">Abort Thread</a>
			</span>
			<b>Thread Name:</b> [encode_html: $thread_detail->(find: 'name')]
			<br />
			<b>Thread ID:</b> [encode_html: $thread_detail->(find: 'id')]
			<br />
			<b>Thread Start:</b> [encode_html: $thread_detail->(find: 'starttime')]
			<br />
			<b>Thread Age:</b>[protect][var: 'seconds' = date - $thread_detail->(find: 'starttime')]
			[if: $seconds >= 86400][integer: $temp := $seconds / 86400] Day[if: $temp > 1]s[/if]
				[if: ($seconds := ($seconds % 86400)) >= 3600][integer: $temp := $seconds / 3600] Hour[if: $temp != 1]s[/if][/if]
			[else: ($seconds := ($seconds % 86400)) >= 3600][integer: $temp := $seconds / 3600] Hour[if: $temp != 1]s[/if]
			[else: ($seconds := ($seconds % 3600)) >= 60][integer: $temp := $seconds / 60] Minute[if: $temp != 1]s[/if]
			[else: ($seconds := ($seconds % 60)) >= 0][integer: $temp := $seconds] Second[if: $temp != 1]s[/if][/if][/protect]
[/if]
		</span>
	</div><b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b></div>
[/iterate]
[if: $thread_array->size == 0]
	<div class="content_panel"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b><div class="content_inner">
		<p class="red">No Threads Found</p>
	</div><b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b></div>
[/if]

</div>

