﻿<?LassoScript
	
define_tag('read', -namespace='_global_file_', 	-required='path', 
										-optional='filestartpos', -copy,
										-optional='fileendpos', -copy);
	local('f' = file(#path), 'toread' = 0);
	if (local_defined('filestartpos'));
		#filestartpos += 1; // this is done to mimic the strange behavior of the old file_read tag
					// where -filestartpos was always 1 less than it should be
		#f->setPosition(#filestartpos);
	else;
		local('filestartpos' = 1);
	/if;
	#filestartpos -= 1; // so we can get the proper 'toread'
	if (!local_defined('fileendpos'));
		local('fileendpos' = #f->size);
	/if;
	#toread = #fileendpos - #filestartpos;
	
	local('ret' = #f->read(#toread));
	#toread -= #ret->size;
	// this block is unlikely to execute, but I have seen FILE* not return all 
	// that was asked for on Windows - and so more reads were required to fulfill the request
	while(#toread > 0);
		local('thisRead' = #f->read(#toread));
		if (#thisRead->isa('null'));
			loop_abort;
		/if;
		#toread -= #thisRead->size;
		#ret += #thisRead;
	/while;
	return: #ret;	
/define_tag;

define_tag('write', -namespace='_global_file_',	-required='path', 
										-required='data', 
										-optional='fileoverwrite');
	if (local_defined('fileoverwrite'));
		file(#path, FILE_OPENWRITETRUNCATE)->write(#data);
	else;
		file(#path, FILE_OPENWRITEAPPEND)->write(#data);
	/if;
/define_tag;

?>