<?LassoScript

	// SOAP.Lasso
	//
	// Implements:
	// [SOAP_LastRequest]
	// [SOAP_LastRequest]
	//
	// Copyright  2007 LassoSoft, LLC

	// [SOAP_LastRequest] returns the value of the last SOAP request if defined.
	// Returns an error if no SOAP request has been made.
	// [SOAP_LastRequest]

	Define_Tag: 'LastRequest', -Namespace='SOAP_';
		Fail_If: !(Var_Defined: '_last_soap_request'), -9956, 'No SOAP request was found.';
		Return: $_last_soap_request;
	/Define_Tag;

	// [SOAP_LastRequest] returns the value of the last SOAP request if defined.
	// Returns an error if no SOAP request has been made.
	// [SOAP_LastRequest]

	Define_Tag: 'LastResponse', -Namespace='SOAP_';
		Fail_If: !(Var_Defined: '_last_soap_response'), -9956, 'No SOAP response was found.';
		Return: $_last_soap_response;
	/Define_Tag;

?>