[if: !((var: 'security_token') >> 'migration')][redirect_url: 'http://' + (server_name) + '/'][abort][/if]
body 
	{ 
		background: white; 
		font-family: Verdana, Arial, Helvetica, sans-serif;
		font-size: 10px;
		color: #000000;
	}

h1,
h2
	{
		font-family: Verdana, Arial, Helvetica, sans-serif;
		font-size: 13px;
		margin: 2px 1px 8px 1px;
		color: #000000;
	}

div.frame_main p
	{
		font-family: Verdana, Arial, Helvetica, sans-serif;
		font-size: 10px;
		margin: 0px;
		color: #000000;
	}

div.content_left p,
div.content_right p,
div.content_top p,
div.content_bottom p
	{
		font-family: Verdana, Arial, Helvetica, sans-serif;
		font-size: 10px;
		margin: 6px 0px;
		color: #000000;
	}

table
	{
		margin: 0px 0px 12px 0px;
		width: 100%;
	}

tr.light
	{
		background: #dddddd;
	}

td
	{
		font-family: Verdana, Arial, Helvetica, sans-serif;
		font-size: 10px;
		margin: 0px;
		padding: 1px 0px 1px 3px;
		color: #000000;
	}

th
	{
		font-family: Verdana, Arial, Helvetica, sans-serif;
		font-size: 10px;
		margin: 0px;
		padding: 1px 0px 1px 3px;
		color: #000000;
		font-weight: bold;
		text-align: left;
		vertical-align: top;
		white-space: nowrap;
	}

select,
input
	{ 
		font-family: Verdana, Arial, Helvetica, sans-serif;
		font-size: 9px;
	}
	
textarea
	{ 
		font-family: Monaco, Verdana, Arial, Helvetica, sans-serif;
		font-size: 9px;
	}
	
select.tiny,
input.tiny
	{
		width: 36px;
	}

select.short,
input.short
	{
		width: 72px;
	}

select.medium,
input.medium
	{
		width: 108px;
	}

select.long,
input.long
	{
		width: 180px;
	}

textarea.small
	{
		width: 144px;
		height: 36px;
	}

textarea.medium
	{
		width: 288px;
		height: 108px;
	}

textarea.large
	{
		width: 360px;
		height: 144px;
	}

img.graphic_left 
	{ 
		float: left;
		width: 144px;
		height: 36px;
	}
	
img.graphic_right
	{ 
		float: right;
		width: 144px;
		height: 36px;
	}

div.content_top,
div#content_top 
	{ 
		background: #cccccc;
		padding: 6px;
		margin: 12px;
		width: 764px;
		clear: both;
	}
	
div.content_bottom,
div#content_bottom
	{ 
		background: #cccccc;
		padding: 6px;
		margin: 12px;
		width: 764px;
		clear: both;
	}
	
div.content_full,
div#content_full
	{ 
		background: #cccccc;
		padding: 6px;
		margin: 12px;
		width: 764px;
		clear: both;
	}
	
div.content_dialog,
div#content_dialog
	{ 
		background: #cccccc;
		padding: 6px;
		margin: 12px;
		width: 364px;
		clear: both;
	}
	
div.content_split,
div#content_split
	{ 
		margin: 12px;
		padding: 0px;
		width: 776px;
		background: #eeeeee url(images/split_background.gif) 
		repeat-y 0 0;
		valign: top;
	}
	
div.content_split_left,
div#content_split_left,
div.content_split_solo,
div#content_split_solo
	{ 
		margin: 12px;
		padding: 0px;
		width: 776px;
		background: #eeeeee
		repeat-y 0 0;
		valign: top;
	}
	
div.content_left,
div#content_left 
	{ 
		background: #cccccc;
		margin: 0px;
		padding: 6px;
		border-width: 0px 12px 0px 0px;
		border-style: solid;
		border-color: #eeeeee;
		width: 376px;
		float: left;
		min-height: 288px;
	}

div.content_right,
div#content_right
	{ 
		background: #cccccc;
		padding: 6px;
		margin: 0px;
		width: 364px;
		float: right;
		min-height: 288px;
	}

div.content_right_empty,
div#content_right_empty,
div.content_right_solo,
div#content_right_solo
	{ 
		background: #eeeeee;
		padding: 6px;
		margin: 0px;
		width: 364px;
		float: right;
		min-height: 288px;
	}

div.frame_main,
div#frame_main
	{ 
		background: #eeeeee;
		margin: 6px;
		width: 800px;
	}

div.frame_dialog,
div#frame_dialog
	{ 
		background: #eeeeee;
		margin: 6px;
		width: 400px;
	}

div.frame_header,
div#frame_header
	{ 
		background: #999999;
		padding: 3px;
		width: 794px;
		clear: both;
	}

div.frame_footer,
div#frame_footer
	{ 
		background: #999999;
		padding: 3px;
		width: 794px;
		clear: both;
		text-align: center;
	}
	
div.content_clear,
div#content_clear
	{ 
		clear: both;
		margin: 0px;
		width: 100%;
		height: 1px;
		background: #eeeeee;
	}


a,
a:link,
a:visited 
	{
		text-decoration: none;
		color: #0000ff;
	}

a.new,
a.new:link,
a.new:visited 
	{
		text-decoration: none;
		color: #990000;
	}

a.fav,
a.fav:link,
a.fav:visited 
	{
		text-decoration: none;
		color: #006600;
	}

a:hover,
a.new:hover,
a.fav:hover
	{
		text-decoration: none;
		color: #000000;
	}


div.header_tab1,
div#header_tab1 
	{
		width: 800px;
		background: white;
		height: 36px;
		font-weight: bold;
		font-size: 14px;
	}

a.tab1,
a.tab1:link,
a.tab1:visited 
	{
		background: #cccccc;
		padding: 0px 0px 5px 0px;
		margin: 3px 1px 0px 1px;
		position: relative;
		top: 14px;
		text-decoration: none;
		color: #333333;
	}

a.tab1:hover
	{
		background: #bbbbbb;
	}

a.tab1.active1, 
a.tab1.active1:link,
a.tab1.active1:hover,
a.tab1.active1:visited 
	{
		background: #999999;
	}

span.tab1
{
		position: relative;
		padding: 0px 12px 0px 12px;
		top: 4px;
}

[if: (client_type >> 'MSIE') && (client_type >> 'Mac_PowerPC')]

img.corner_left1,
img.corner_right1
	{ 
		position: relative;
		width: 1px;
		height: 1px;
		top: -13px;
		background: white;
	}

[else]

img.corner_left1,
img.corner_right1
	{ 
		position: relative;
		width: 2px;
		height: 2px;
		top: -12px;
	}

[/if]
	
div.header_tab2,
div#header_tab2 
	{
		width: 788px;
 		background: #999999;
 		height: 24px;
 		padding: 0px 6px 0px 6px;
		font-size: 10px;
	}

a.tab2,
a.tab2:link,
a.tab2:visited 
	{
		background: #999999;
		padding: 0px 0px 5px 0px;
		margin: 6px 6px 0px 6px;
		position: relative;
		top: 7px;
		text-decoration: none;
		color: #000000;
	}

a.tab2:hover
	{
		background: #aaaaaa;
	}

a.tab2.active2, 
a.tab2.active2:link,
a.tab2.active2:hover,
a.tab2.active2:visited 
	{
		background: #eeeeee;
		font-weight: bold;
	}

span.tab2
{
		position: relative;
		padding: 0px 12px 0px 12px;
		top: 2px;
}

[if: (client_type >> 'MSIE') && (client_type >> 'Mac_PowerPC')]

img.corner_left2,
img.corner_right2
	{ 
		position: relative;
		width: 1px;
		height: 1px;
		top: -9px;
		background: #999999;
	}

[else]

img.corner_left2,
img.corner_right2
	{ 
		position: relative;
		width: 2px;
		height: 2px;
		top: -8px;
	}

[/if]

div.form
	{
		display: inline-table;
		width: 100%;
		margin: 6px 0px;
	}

div.form span.label
	{
		display: table-cell;
		width: 25%;
		font-weight: bold;
	}

div.form span.input
	{
		display: table-cell;
		width: 75%;
	}

p.error,
p#error
	{
		color: #ff0000;
		font-weight: bold;
		text-align: center;
	}

p.message,
p#message
	{
		font-weight: bold;
		text-align: center;
	}
	
span.disabled,
span#disabled
	{
		color: #666666;
	}	