<?LassoScript

	if: !((var: 'security_token') >> 'migration');
		redirect_url: 'http://' + server_name + '/';
		abort;
	/if;

	_migration_addvar: -name="action", -override=(action_param: 'action'), -default='none';

	if: $action >> 'export';
		
		if: $action >> 'lp7';
		
			content_type: 'text/plain';
	
			var: '__html_reply__' = (include: (lassoapp_link: 'export/export7.lasso'));
	
			var: '__http_header__' = 'HTTP/1.0 200 OK\r\n';
			$__http_header__ += 'Server: Lasso/' + (lasso_version: -lassoversion) + '\r\n';
			$__http_header__ += 'MIME-Version: 1.0\r\n';
			$__http_header__ += 'Content-Type: application/force-download\r\n';
	
			if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
				$__http_header__ += 'Content-Disposition: attachment; filename="Export_LP7_' + (date_format: date_getcurrentdate, -dateformat='%Y%m%d%H%M%S') + '.txt"\r\n';
			else;
				$__http_header__ += 'Content-Disposition: attachment; filename="Export_LP7_' + (date_format: date_getcurrentdate, -format='%Y%m%d%H%M%S') + '.txt"\r\n';
			/if;
	
			$__http_header__ += 'Content-Length: ' + $__html_reply__->size + '\r\n';
	
			var: 'abort' = true;

		else;

			content_type: 'text/plain';
	
			var: '__html_reply__' = (include: (lassoapp_link: 'export/export.lasso'));
	
			var: '__http_header__' = 'HTTP/1.0 200 OK\r\n';
			$__http_header__ += 'Server: Lasso/' + (lasso_version: -lassoversion) + '\r\n';
			$__http_header__ += 'MIME-Version: 1.0\r\n';
			$__http_header__ += 'Content-Type: application/force-download\r\n';
	
			if: ((decimal: (lasso_version: -lassoversion)) < 6.0);
				$__http_header__ += 'Content-Disposition: attachment; filename="Export_LP8_' + (date_format: date_getcurrentdate, -dateformat='%Y%m%d%H%M%S') + '.txt"\r\n';
			else;
				$__http_header__ += 'Content-Disposition: attachment; filename="Export_LP8_' + (date_format: date_getcurrentdate, -format='%Y%m%d%H%M%S') + '.txt"\r\n';
			/if;
	
			$__http_header__ += 'Content-Length: ' + $__html_reply__->size + '\r\n';
	
			var: 'abort' = true;

		/if;
		
	/if;

?>