#ifndef _MOD_LASSO_WS_
#define _MOD_LASSO_WS_

#include "WSAPI.h"
#include <Lasso/LassoProto.h>
#include <Lasso/RequestParams.h>
#include "../../LassoService.8/POSTReader.h"

#if __cplusplus
extern "C"
{
#endif

/*
	Prototypes:
*/

char *icstrstr(const char *str, const char *substring);
int open_connection(WSAPI_CommandPBPtr pb);
void release_connection(int sock, bool justCloseIt);
int get_post(int sock, WSAPI_CommandPBPtr pb, LP8POSTReader * reader, int byteLen);
char *get_auth(WSAPI_CommandPBPtr pb, char ** dst);

WSAPI_ErrorCode 
get_param( WSAPI_CommandPBPtr pb, RequestParamKeyword word, const char * param, void ** data, size_t * outLen );


static WSAPI_ErrorCode HandleRegister(WSAPI_CommandPBPtr pb) ;
static WSAPI_ErrorCode HandleInit(WSAPI_CommandPBPtr pb) ;
static WSAPI_ErrorCode HandleRun(WSAPI_CommandPBPtr pb) ;
static WSAPI_ErrorCode HandleShutdown(WSAPI_CommandPBPtr pb) ;


#if __cplusplus
}
#endif

#endif
