[var: 'pObj'=(PDF_Doc: -file='PDFTagsTest.pdf',
-format='pdf',
-size='a4',
-margins=(Array:20,20,20,20),
-usedate='true',
-nocompress='false',
-header='Welcome to Lasso Professional 5. (This is an example of header) ' 
)
]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '================================\n')]
[$pObj->(AddText: 'Lasso Professional 5\n')]
[$pObj->(AddText: 'Standard Edition and Developer Edition\n')]
[$pObj->(AddText: 'Release Notes\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: 'Version: 5.0\n')]
[$pObj->(AddText: 'Release: Feburary 26, 2002\n')]
[$pObj->(AddText: '================================\n')]
[$pObj->(AddText: '\n')]

[$pObj->(AddText: '-Welcome\n')]
[$pObj->(AddText: '-Package Contents\n')]
[$pObj->(AddText: '-Documentation\n')]
[$pObj->(AddText: '-Developer Edition\n')]
[$pObj->(AddText: '-Installation Notes\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '--------------------------------\n')]
[$pObj->(AddText: 'Welcome\n')]
[$pObj->(AddText: '--------------------------------\n')]
[$pObj->(AddText: '\n')]

[var: 'fObj'=(PDF_Font: -face='Helvetica',-color='#00ff00', -size=16,-encoding='Cp1252')]
[$fObj->(SetStyle:-italic=true,-bold=false,-underscore=false)]

[$pObj->(AddText: 'Welcome to Lasso Professional 5.  \n',-font=$fObj)]
[$pObj->(AddText: '\n')]
[$pObj->(AddParagraph: 'This document contains important information about installing and using Lasso Professional 5.  You should read this document and the relevant installation chapter in the Lasso Professional 5 Setup Guide PDF file before you install Lasso Professional 5. (AddParagraph) \n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '--------------------------------\n')]
[$pObj->(AddText: 'Package Contents\n')]
[$pObj->(AddText: '--------------------------------\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: 'The installation package includes the following components.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '- Release Notes - This document. (This is done using AddText)\n')]
[$pObj->(AddText: '- HERE WE ARE ADDING A NEW PAGE THROUGH  AddPage() Tag\n')]
[$pObj->(NewPage:1)  ]

[$pObj->(AddParagraph: '- Setup Guide - The complete Lasso Professional 5 Setup Guide is included in the file Lasso_Pro_5_Setup_Guide.pdf.  You should read the appropriate installation chapter in this guide before installing Lasso Professional 5. (This is done using AddParagraph) \n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddPhrase: '- Installer - This is either LassoPro5.0_Installer_MacoSX or LassoPro5_Installer_Win2000.exe depending on platform.  Double click this application to install Lasso Professional 5. (This is done using Addphrase with Leading =10) \n',-leading=12)]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '--------------------------------\n')]
[$pObj->(AddText: 'Documentation\n')]
[$pObj->(AddText: '--------------------------------\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddParagraph: 'The Lasso Professional 5 Setup Guide includes installation instructions for Mac OS X and Windows 2000.  Please consult the chapter appropriate to your target operating system before installing Lasso Professional 5.  The Lasso Professional 5 Setup Guide is provided as PDF file for separate download, as a printed manual with boxed versions of Lasso Professional 5, and in the Documentation folder of Lasso Professional 5 installations. \n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddParagraph: 'The Lasso Professional 5 Setup Guide also includes a documentation roadmap which describes all of the documentation resources for Lasso Professional 5.  Please consult this document for a full list of printed manuals, PDF-based manuals, and online resources.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddParagraph: 'Documentation of the full tag set of Lasso Dynamic Markup Language can be found in the online LDML 5 Reference which includes comments from other users.  The LDML 5 Reference can be found at the following URL or accessed from Lasso Administration.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '<http://ldml.blueworld.com/>\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '--------------------------------\n')]
[$pObj->(AddText: 'Developer Edition\n')]
[$pObj->(AddText: '--------------------------------\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddParagraph: 'Lasso Professional 5 is available in two editions: Standard Edition and Developer Edition.  The Developer Edition is a lower cost product which includes all the functionality of Lasso Professional 5 for single-user development and testing of Lasso-based solutions.  The Developer Edition allows users whose site is hosted at an ISP to test their solutions locally and allows consultants to test Lasso-based solutions without purchasing the Standard Edition of Lasso Professional 5.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddParagraph: 'Serial numbers for the Developer Edition start with LP5-DE-MAC- or LP5-DE-WIN-. Serial numbers for the Standard Edition start with LP5-SE-MAC- or LP5-SE-WIN-. The Evaluation Edition of Lasso Professional 5 unlocks the Developer Edition functionality and includes the same limitations.\n')]
[$pObj->(AddText: '- HERE WE ARE ADDING A NEW PAGE THROUGH  AddPage() Tag\n')]
[$pObj->(NewPage:1)]
[$pObj->(AddText: 'The Developer Edition contains all the same components and documentation as the Standard Edition, but is limited in the following ways:\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '- Only 1 IP address can connect to the server at a time.\n')]
[$pObj->(AddText: '- There is a limit on the number of connections per minute (100) which Lasso Service will process.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: 'If either of these limitations is met an error message will be displayed.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: 'The full Standard Edition of Lasso Professional 5 does not contain any of these limitations.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '--------------------------------\n')]
[$pObj->(AddText: 'Installation Notes\n')]
[$pObj->(AddText: '--------------------------------\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: 'Windows 2000 - IIS\n')]
[$pObj->(AddText: '--------------------------------\n')]
[$pObj->(AddParagraph: '- The installer stops IIS and other services which depend on it.  If you are using the built-in mail server or FTP server you will need to restart your server or start these services manually after the Lasso installer completes.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddParagraph: '- Lasso Professional 5 should be installed in the default location on the default hard drive suggested by the installer.  Do not move the Lasso Professional 5 folder after it has been installed.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: 'Mac OS X - WebSTAR V\n')]
[$pObj->(AddText: '--------------------------------\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddParagraph: '- Installing Lasso Professional 5 with WebSTAR V requires some manual steps. These steps are documented in the Lasso Professional 5 Setup Guide.  Please consult the Mac OS X Installation chapter for details.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddParagraph: '- Lasso Professional 5 should be installed in the default location on the default hard drive suggested by the installer.  Do not move the Lasso Professional 5 folder after it has been installed.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '- HERE WE ARE ADDING A NEW PAGE THROUGH  AddPage() Tag\n')]
[$pObj->(NewPage:1)]
[var: 'f1Obj'=(PDF_Font: -face='Helvetica',-color='#ff0000', -size=12,-encoding='Cp1252')]

[$pObj->(AddText: 'Known Issues\n',-font=$f1Obj)]
[$pObj->(AddText: '----------------\n')]
[$pObj->(AddParagraph: 'There are several known issues with WebSTAR V 5.0.2.  These issues will require an update from 4D.  Visit the 4D Web site <http://www.webstar.com/> for more information and to download the latest version of WebSTAR V.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '- Adding default.lasso, index.lasso, or another .lasso file name to the list of default files results in the page being served in plain text without being processed by Lasso Service.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '- HTTP request headers containing underscore characters are not recognized. This primarily affects serving WML pages to WAP browsers.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '- Only a single cookie can be set on a page. Pages which set multiple cookies will result in only the first cookie specified being set.\n')]
[$pObj->(AddText: '\n')]

[var: 'f2Obj'=(PDF_Font: -face='Helvetica',-color='#ff0000', -size=14,-encoding='Cp1252')]

[$pObj->(AddText: '- Only a single cookie can be set on a page. Pages which set multiple cookies will result in only the first cookie specified being set.(this is done by setting a font to font size 14, font color = #ff0000, fontname=Helvetica)This is the demonstration of the PDF_Font tag capabilities.\n',-font=$f2Obj)]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: 'Mac OS X - Apache\n')]
[$pObj->(AddText: '----------------\n')]
[$pObj->(AddParagraph: '- The "Lasso" folder is placed in the default Web server root.  If you have configured an alternate root for your Web sites you will need to manually move the "Lasso" folder before you can configure Lasso Professional 5.  The default location is /Library/WebServer/Documents/.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '- Lasso Professional 5 should be installed in the default location on the default hard drive suggested by the installer.  Do not move the Lasso Professional 5 folder after it has been installed.\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '\n')]
[$pObj->(AddText: '================================\n')]
[$pObj->(AddText: 'Copyright (C) 2002 OmniPilot Software, Inc.  All Rights Reserved.\n')]
[$pObj->(Close)]

