<script language="JavaScript">
	function showalert(action) {
		window.open('[var:'dialog_file',-encodenone]?dialog_pane=[var:'admin_dialogpath', -encodenone]&action='+escape(action),
					'help','status=yes,menubar=no,scrollbars=yes,resizable=yes,width=460,height=336');
		return false;
	}
</script>

[if: ($build_action >> 'Detail')]
<div class="content_split">
[else: ($build_action >> 'Create') || ($build_action >> 'Duplicate')]
<div class="content_split">
[else]
<div class="content_split_solo">
[/if]

<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">
<input type="hidden" value="" name="dialog_action" />

	<div class="content_left">
		<h2>Database Listing</h2>
		[admin_datasourcecascade: -prefix='build_', -suffix='id', -datasource=$build_datasourceid, -host=$build_hostid, -nodatabase, -notable, -nofield, -buildonly, -nodatabaserefresh]
[var: 'build_databasemap' = (admin_host: -id=$build_hostid)->databases]
[if: $build_databasemap->size > 0]
		<table>
			<tr>
				<td>&nbsp;</td>
				<th width="50%">Name</th>
				<th width="25%">Status</th>
				<th width="25%">Links</th>
			</tr>
[iterate: $build_databasemap, $temp]
[var: 'link' = $admin_link + '&build_datasourceid=' + $build_datasourceid + '&build_hostid=' + $build_hostid + '&build_databaseid=' + $temp->(find: 'id')]
			<tr>
				<th>[loop_count]</th>
				<td><a href="[$link]&build_action=detail">[_admin_short_cleanup: $temp->(find: 'label'), 48]</a></td>
				<td>[encode_html: $temp->(find: 'status')]</td>
				<td>
[if: ($temp->(find: 'status') == 'Enabled')]
            <a href="[$link]&build_action=list+tables">List&nbsp;Tables</a>
[/if]
				</td>
			</tr>
[/iterate]
		</table>
[else]
		<p class="error">No Databases Found</p><p>&nbsp;</p>
[/if]
		<p align="right">
              <input type="submit" value="Create Database..." name="build_action" class="large" />
              <input type="submit" value="Duplicate Database..." name="build_action" class="large" />
              <input type="submit" value="Refresh" name="build_action" class="small" />
		</p>
	</div>
</form>

[if: ($build_action >> 'Detail')]

<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">
<input type="hidden" value="" name="dialog_action" />

	<div class="content_right">

		<input type="hidden" name="build_databaseid" value="[encode_html: $build_databaseid]" />

		<h2>Database Detail</h2>
		<table>
			<tr>
				<th width="40%">Name</th>
				<td>[encode_html: $build_databasedetail->(find: 'name')]</td>
			</tr>
			<tr>
				<th>Alias</th>
				<td><input type="text" name="build_alias" value="[encode_html: $build_databasedetail->(find: 'alias')]" class="large" /></td>
			</tr>
			<tr>
				<th>Status</th>
				<td>
					<select name="build_enabled" class="std_pop_small">
						<option value="Y" [if: $build_databasedetail->(find: 'status') == 'Enabled']selected[/if]>Enabled</option>
						<option value="N" [if: $build_databasedetail->(find: 'status') == 'Disabled']selected[/if]>Disabled</option>
			[if: $build_databasedetail->(find: 'status') == 'New']
						<option value="N" selected>New</option>
			[else: $build_databasedetail->(find: 'status') == 'Not Available']
						<option value="[encode_html: $build_databasedetail->(find: 'enabled')]" selected>Not Available</option>
			[/if]
					</select>
				</td>
			</tr>
		</table>
	[if: (var_defined: 'build_error')]
		<p class="error">[var: 'build_error']</p>
	[else: (var_defined: 'build_message')]
		<p class="message">[var: 'build_message']</p>
	[/if]

		<p align="right">
            <input type="submit" value="Update" name="build_action" class="small" />
		[if: ($build_databasedetail->(find: 'status') == 'Enabled')]
            <input type="submit" value="Delete" name="build_action" onClick="return showalert(this.value);" class="small" />
		[/if]
		</p>
	[if: ($build_databasedetail->(find: 'status') == 'Enabled') || ($build_databasedetail->(find: 'status') == 'Disabled')]
		<p align="right">
			<input type="submit" value="Create Table..." name="build_action" class="medium" />
			<input type="submit" value="List Tables..." name="build_action" class="medium" />
		</p>
	[/if]
	</div>
</form>

[else: ($build_action >> 'Duplicate')]

<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">
<input type="hidden" value="" name="dialog_action" />

	<div class="content_right">
		<input type="hidden" name="build_action" value="Duplicate" />
		<h2>Duplicate Database</h2>
		<table>
			<tr>
				<td width="40%">&nbsp;</td>
				<td>Select the database to duplicate.</td>
			</tr>
		[admin_datasourcecascade: -prefix='create_', -suffix='id', -datasource=$create_datasourceid, -host=$create_hostid, -database=$create_databaseid, -notable, -nofield, -notabletag, -datasourceonly]

[if: (error_code == 0)]
			<tr>
				<th>Copy Data</th>
				<td>
					<select name="create_data" class="std_pop_small">[var: 'yesno' = $create_data]
						<option value="Yes" [if: $yesno == 'Yes']selected[/if]>Yes</option>
						<option value="No" [if: $yesno == 'No']selected[/if]>No</option>
					</select>
				</td>
			</tr>
			<tr>
				<th>Name</th>
				<td><input type="text" name="create_name" value="[var: 'create_name']" class="large" /></td>
			</tr>
			<tr>
				<th>Status</th>
				<td>
					<select name="create_enabled" class="std_pop_small">
						<option value="Y" [if: (var: 'create_enabled') == 'Enabled']selected[/if]>Enabled</option>
						<option value="N" [if: (var: 'create_enabled') == 'Disabled']selected[/if]>Disabled</option>
					</select>
				</td>
			</tr>
		</table>
	[if: (var_defined: 'build_error')]
		<p class="error">[var: 'build_error']</p>
	[else: (var_defined: 'build_message')]
		<p class="message">[var: 'build_message']</p>
	[/if]
		<p align="right">
            <input type="submit" value="Duplicate Database" name="create_action" class="large" />
		</p>
[/if]
	</div>
</form>

[else: ($build_action >> 'Create')]

<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">
<input type="hidden" value="" name="dialog_action" />

	<div class="content_right">
		<input type="hidden" name="build_action" value="Create" />
		<h2>Create Database</h2>
		<table>
			<tr>
				<th>Name</th>
				<td><input type="text" name="create_name" value="[var: 'create_name']" class="large" /></td>
			</tr>
			<tr>
				<th>Status</th>
				<td>
					<select name="create_enabled" class="std_pop_small">
						<option value="Y" [if: (var: 'create_enabled') == 'Enabled']selected[/if]>Enabled</option>
						<option value="N" [if: (var: 'create_enabled') == 'Disabled']selected[/if]>Disabled</option>
					</select>
				</td>
			</tr>
		</table>
	[if: (var_defined: 'build_error')]
		<p class="error">[var: 'build_error']</p>
	[else: (var_defined: 'build_message')]
		<p class="message">[var: 'build_message']</p>
	[/if]
		<p align="right">
            <input type="submit" value="Create New Database" name="create_action" class="large" />
		</p>
	</div>
</form>

[/if]
	<div class="content_clear"><img src="[lassoapp_link: 'images/blank.gif']" height="1" width="1" border="0"></div>

</div>
