<?LassoScript
	
	_admin_addvar: -name='groupadmin_group', -session='_groupadmin', -default='All Users', -override=(action_param: 'groupadmin_group');
	_admin_addvar: -name='groupadmin_user', -session='_groupadmin', -default='', -override=(action_param: 'groupadmin_user');
	_admin_addvar: -name='groupadmin_action', -default='None', -override=(action_param: 'groupadmin_action');
	_admin_addvar: -name='groupadmin_first', -session='_groupadmin', -default=1;
	
	// Perform Action
	
	if: ((var: 'groupadmin_user') != '');
		if: ((var: 'groupadmin_action') >> 'Update') || ((var: 'groupadmin_action') >> 'Delete');
	
			if: ((var: 'groupadmin_action') >> 'Update');
				var: 'temp_groupsnew' = (array);
				loop: (action_param: 'user_groups', -count);
					var: 'temp' = (action_param: 'user_groups', loop_count);
					if: $temp != '';
						$temp_groupsnew->(insert: $temp);
					/if;
				/loop;
			else;
				var: 'temp_groupsnew'=(array);
			/if;
			var: 'temp_groupsold' = (admin_userlistgroups: (var: 'groupadmin_user'));
	
	
			if: ($temp_groupsnew->type == 'array') && ($temp_groupsold->type == 'array');
				iterate: $temp_groupsnew, (var: 'temp_new');
					if: $temp_groupsold !>> $temp_new;
						var: 'result' = (admin_groupassignuser: $temp_new, (var: 'groupadmin_user'));
					/if;
				/iterate;
				iterate: $temp_groupsold, (var: 'temp_old');
					if: $temp_groupsnew !>> $temp_old;
						var: 'result' = (admin_groupremoveuser: $temp_old, (var: 'groupadmin_user'));
					/if;
				/iterate;
			/if;
		/if;
	
		if: ((var: 'groupadmin_action') >> 'Delete');
			var: 'groupadmin_user'='';
		/if;
	
		_security_flushcaches;
	
	/if;
	
	//
	// Refresh Groups and User lists
	//
	
	if: (var: 'groupadmin_action') >> 'Refresh' || !(var_defined: 'groupadmin_groups') || ((var: 'groupadmin_groups')->type != 'array') || !((var: 'groupadmin_groups')->size > 0);
	
		var: 'groupadmin_groups' = (admin_listgroups);
		
		if: $groupadmin_groups == false;
			var: 'groupadmin_groups' = array;
		/if;
		
		$groupadmin_groups->(removeall: 'ANYUSER');
		$groupadmin_groups->(removeall: 'ADMINISTRATORS');
		
	/if;
	
	if: (var: 'groupadmin_action') >> 'Refresh' || !(var_defined: 'groupadmin_users') || ((var: 'groupadmin_users')->type != 'array') || !((var: 'groupadmin_users')->size > 0);
	
		if: ($groupadmin_group >> 'All Users');
			var: 'groupadmin_users' = (array);
			iterate: $groupadmin_groups, (var: 'temp_group');
				var: 'temp_users' = (admin_grouplistusers: $temp_group);
				iterate: $temp_users, (var: 'temp');
					if: $groupadmin_users !>> $temp;
						$groupadmin_users->(insert: $temp);
					/if;
				/iterate;
			/iterate;
		else;
			var: 'groupadmin_users' = (admin_grouplistusers: $groupadmin_group);
		/if;
		
	/if;
	
	//
	// Navigation
	//
	
	if: ($groupadmin_action >> 'Switch Group') || ($groupadmin_action >> 'Refresh');
		var: 'groupadmin_first'=1;
	else: ($groupadmin_action >> 'Next');
		var: 'groupadmin_first'=$groupadmin_first + 10;
	else: ($groupadmin_action >> 'Prev');
		var: 'groupadmin_first'=$groupadmin_first - 10;
	/if;
	
	var: 'groupadmin_total'=$groupadmin_users->size;
	if: $groupadmin_first < 1;
		$groupadmin_first = 1;
	else: ($groupadmin_first > $groupadmin_total);
		$groupadmin_first = ($groupadmin_total - ($groupadmin_total % 10));
	/if;
	var: 'groupadmin_last'=(math_min: $groupadmin_first + 9, $groupadmin_total);
	

?>