<?LassoScript

	define_tag: '_debug', -priority='replace';
		local: 'output' = '<p style="text-align: center; font-size: 1; color: red; font-family: Verdana;">';
		#output += 'An error has occurred processing GroupAdmin.LassoApp:<br />';
		#output += '<b>' + params->(join: ' ') + '</b><br />';
		#output += 'Details: ' + lasso_version + ', ' + date + ', ' + (var: 'admin_tab1') + ' ' + (var: 'admin_tab2') +  ' ' + (var: 'admin_tab3') + '<br />';
		#output += 'Please report this complete error to <a href="mailto:bugs@lassosoft.com">bugs@lassosoft.com</a>.';
		#output += '</p>';
		return: @#output;
	/define_tag;
	
	define_tag: '_admin_nocache', -priority='replace';
		$__http_header__ += 'Expires: Mon, 26 Jul 1997 05:00:00 GMT\r\n';
		$__http_header__ += 'Last-Modified: ' + (Date_LocaltoGMT: date )->(format:'%a, %d %m %Y %H:%M:%S') + ' GMT\r\n';
		$__http_header__ += 'Cache-Control: no-store, no-cache, must-revalidate\r\n';
		$__http_header__ += 'Cache-Control: post-check=0, pre-check=0\r\n';
		$__http_header__ += 'Pragma: no-cache\r\n';
	/define_tag;
	
	define_tag: '_admin_addvar', -required='name', -optional='default', -optional='session', -optional='override', -optional='force', -priority='replace';
		if: ((var_defined: #name) == false) || ((var: #name) == null);
			var: #name = '';
		/if;
		if: (local_defined: 'force');
			var: #name = #force;
		else: (local_defined: 'override') && (#override != '');
			var: #name = #override;
		else: (local_defined: 'default') && ((var: #name) == '') && (#default != '');
			var: #name = #default;
		/if;
		if: (local_defined: 'session') && (#session != '');
			session_addvar: -name=#session, #name;
		/if;
	/define_tag;
	
	define_tag: '_admin_nocache';
		$__http_header__ += 'Expires: Mon, 26 Jul 1997 05:00:00 GMT\r\n';
		$__http_header__ += 'Last-Modified: ' + (Date_LocaltoGMT: date )->(format:'%a, %d %m %Y %H:%M:%S') + ' GMT\r\n';
		$__http_header__ += 'Cache-Control: no-store, no-cache, must-revalidate\r\n';
		$__http_header__ += 'Cache-Control: post-check=0, pre-check=0\r\n';
		$__http_header__ += 'Pragma: no-cache\r\n';
	/define_tag;
	
	define_tag: '_admin_array_find', -required='array', -required='pattern', -priority='replace';
		if: !(#array->(isa: 'array'));
			return: 'None';
		/if;
		protect;
			return: #array->(find: #pattern)->(get:1)->second;
	/protect;
		if: (#pattern == 0);
			return: 'None';
		/if;
		return: (string: #pattern);
	/define_tag;

?>