<?xml version="1.0" ?>
[content_type:'text/xml']
<definitions name="LassoService" 
	xmlns:tns="http://www.omnipilot.com/services/LassoService.wsdl" 
	targetNamespace="http://www.omnipilot.com/services/LassoService.wsdl" 
	xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
	xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" 
	xmlns="http://schemas.xmlsoap.org/wsdl/"
	xmlns:lp7tns="http://www.omnipilot.com/schemas/lp7types">
<types>
[string:$lp7_types.xsd, -encodenone]
</types>
<?LassoScript

// messages go here
iterate:$__SOAP__, local:'scratch';
	if:#scratch->second->type == 'tag';
		local:'paramInfo' = (#scratch->second->paramInfo);
		if:#paramInfo->size;
			'\t<message name="' #scratch->first 'Request">\r\n';
			// iterate over the input parameters
			iterate:(#paramInfo), local:'i';
				'\t\t<part name="' #i->paramName '" type="lp7tns:' (xsd_getSchemaType:#i->paramType) '"/>\r\n';
			/iterate;
			'\t</message>\r\n';
		/if;
		if:#scratch->second->returnType != 'null';
			'\t<message name="' #scratch->first 'Response">\r\n'
			'\t\t<part name="return" type="lp7tns:' (xsd_getSchemaType:#scratch->second->returnType) '"/>\r\n'				
			'\t</message>\r\n';
		/if;
	/if;
/iterate;

?>	
	<portType name="LassoPortType">
<?LassoScript

iterate:$__SOAP__, #scratch;
	if:#scratch->second->type == 'tag';
		'\t\t<operation name="' #scratch->first '">\r\n';
		if:#scratch->second->paramInfo->size;
			'\t\t\t<input message="tns:' #scratch->first 'Request" />\r\n';
		/if;
		if:#scratch->second->returnType != 'null';
			'\t\t\t<output message="tns:' #scratch->first 'Response" />\r\n';				
		/if;
		'\t\t</operation>';
	/if;
/iterate;
?>
	</portType>
	<binding name="LassoBinding" type="tns:LassoPortType">
		<soap:binding style="rpc" transport="http://schemas.xmlsoap.org/soap/http"/>
<?LassoScript

iterate:$__SOAP__, #scratch;
	if:#scratch->second->type == 'tag';
		'\t\t<operation name="' #scratch->first '">\r\n';
		'\t\t\t<soap:operation soapAction="' #scratch->first '" />\r\n';
		if:#scratch->second->paramInfo->size;	
			'\t\t\t<input>\r\n';
			'\t\t\t\t<soap:body use="literal" namespace="http://www.omnipilot.com/services/LassoService.wsdl" />'; //encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" use="encoded"/>\r\n';
			'\t\t\t</input>\r\n';
		/if;
		if:#scratch->second->returnType != 'null';
			'\t\t\t<output>\r\n';
			'\t\t\t\t<soap:body use="literal" namespace="http://www.omnipilot.com/services/LassoService.wsdl" />'; //encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>\r\n';
			'\t\t\t</output>\r\n';
		/if; 
		'\t\t</operation>';
	/if;
/iterate;
	
	// need to fabricate a valid host name and port string
	local('hostName'= $__lassoservice_host__);
	local('portString' = '');
	if (server_port != 80);
		#portString = ':' + string(server_port);
	/if;
	
	local('hostInfo' = string_findregexp(client_headers, -find='(?i)Host:\\s?([^:]*):?(\\d*)?[\\r|\\n]'));
	if (#hostInfo->size > 1);
		#hostName = #hostInfo->get(2)->trim &;
		if (#hostInfo->size > 2 && #hostInfo->get(3)->trim & length > 0); // port was included
			#portString = ':' + #hostInfo->get(3);
		/if;
	/if;
?>
	</binding>
	<service name="LassoService">
		<documentation>All SOAP operations hosted on this server.</documentation>
		<port name="LassoPort" binding="tns:LassoBinding">
			<soap:address location="http://[#hostName + #portString][response_filepath]"/>
		</port>
	</service>
</definitions>
