<?LassoScript

	//
	// Navigation Parameters
	//

	if: $ls_foundcount < $ls_maxrecords;
		var: 'ls_skiprecords' = 0;
	else: ($ls_action >> 'Prev');
		var: 'ls_skiprecords' = (integer: $ls_skiprecords) - (integer: $ls_maxrecords) - 1;
	else: ($ls_action >> 'Next');
		var: 'ls_skiprecords' = (integer: $ls_skiprecords) + (integer: $ls_maxrecords) - 1;
	else: ($ls_action >> 'First');
		var: 'ls_skiprecords' = 0;
	else: ($ls_action >> 'Last');
		var: 'ls_skiprecords' = (integer: $ls_foundcount) - (integer: $ls_maxrecords);
	else: ($ls_action >> 'Jump');
		var: 'ls_skiprecords' = (integer: $ls_skiprecords) - 1;
	/if;
	var: 'ls_skiprecords' = (math_range: (integer: $ls_skiprecords), -min=0, -max=$ls_foundcount - 1);
	$ls_inline->(insert: -SkipRecords=$ls_skiprecords);

	
	//
	// Perform the Search
	//
	
	inline: -log=$__startup_loglevel__, $ls_inline, -inlinename='search';
		var: 'ls_skiprecords' = skiprecords_value;
		var: 'ls_foundcount' = found_count;
		var: 'ls_showncount' = shown_count;
		var: 'ls_shownfirst' = shown_first;
		var: 'ls_shownlast' = shown_last;
	/inline;

	var: 'admin_meta' = '<meta name="robots" content="ALL, FOLLOW" />\r<meta name="GOOGLEBOT" content="FOLLOW" />';

?>
