[include: (lassoapp_link: 'lassoscript/sidebar.lasso')]

<div class="content_full2">
	[records: -inlinename='detail']
	[variable: 'detail_tag' = (field:'tag_name')]
	<div class="content_panel"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b><div class="content_inner">

<?LassoScript
	define_tag: 'toggle', -required='id', -required='label', -optional='criteria', -container;
		local: 'output' = '';
		#output += '<h2 onclick="toggleDisplayBlock(\'' + #id + '\',\'' + #id + 'arrow\')">';
		#output += '<span id="' + #id + 'arrow">';
		if: ((var: 'ls_toggle') >> #id) || ((local_defined: 'critera') && ((local: 'criteria') == false));
			#output += '&#x25ba;';
		else;
			#output += '&#x25bc;';
		/if;
		#output += '</span> ' + (encode_html: #label) + '</h2>';
		#output += '<div id="' + #id + '"';
		if: ((var: 'ls_toggle') >> #id) || ((local_defined: 'critera') && ((local: 'criteria') == false));
			#output += ' style="display: none;"';
		/if;
		#output += '>';
		#output += run_children;
		#output += '</div>';
		return: @#output;
	/define_tag;
?>

	[toggle: 'detail_summary', (field: 'tag_name')]
      <table>
        <tr><td colspan=2 height="3"></td></tr>
        <tr valign="top">
          <th width="20%">Tag&nbsp;Link</th>
          <td width="30%" nowrap><a href="http://[server_name]/[var: 'admin_file']?[encode_taglink: (field: 'tag_name'), (field: 'tag_id')]">[list_cleanup: field: 'tag_name']</a></td>
          <th width="20%">Category</th>
          <td width="30%">[field: 'tag_category']</td>
        </tr>
        <tr valign="top">
          <th>Type</th>
          <td>[field: 'tag_type']</td>
          <th>Source&nbsp;Available</th>
          <td>[if: (field: 'tag_sourceavailable') == 'Y']Yes[else]No[/if]</td>
        </tr>
        <tr valign="top">
          <th>Support</th>
          <td>[field: 'tag_support']</td>
          <th>Version</th>
          <td>[field: 'tag_version']</td>
        </tr>
        <tr valign="top">
          <th>Change</th>
          <td>[field: 'tag_history']</td>
          <th>Data&nbsp;Source</th>
          <td>[status_cleanup: (field: 'tag_datasource'), -encodenone]</td>
        </tr>
        <tr valign="top">
          <th>Output Type</th>
          <td>[field: 'tag_output']</td>
          <th>Security</th>
          <td>[status_cleanup: (field: 'tag_security'), -encodenone]</td>
        </tr>
        <tr valign="top">
          <th>Implementation</th>
          <td>[status_cleanup: (field: 'tag_implementation'), -encodenone]</td>
          <th>Sets</th>
          <td>[status_cleanup: (field: 'tag_language'), -encodenone]</td>
        </tr>
[if: (field: 'rel_name') == 'java']
        <tr valign="top">
          <th>Required Technologies</th>
          <td>Java</td>
        </tr>
[/if]
[if: (field: 'tag_equiv') != '']
	[var: 'equiv_index'='']
        <tr valign="top">
	[if: (field: 'tag_basic') == 'Y']
			<th>Lasso 3 Equivalent</th>
	[else]
			<th>Lasso 8.6 Equivalent</th>
	[/if]
	[inline: -log=$__startup_loglevel__, 
			$ref_tag_inline,
			-search,
			-op='eq', 'tag_name'=(field: 'tag_equiv'),
			-returnfield='tag_name',
			-returnfield='tag_id',
			-maxrecords='1']
		[if: (found_count) > 0]
			[var:'detail_url'= $admin_file + '?' + (encode_taglink: (field: 'tag_name'), (field: 'tag_id'))]
			<td><a href="[var: 'detail_url', -encodenone]">[list_cleanup: (field: 'tag_name')]</a></td>
		[else]
			<td>[action_param: 'tag_name']</td>
		[/if]
	[/inline]
        </tr>
[/if]
     </table>
	[/toggle]
	</div><b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b></div>

[if:(field:'tag_description')!='']
	<div class="content_panel"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b><div class="content_inner">
	[toggle: 'detail_description', 'Description']
        <p>[code_highlight: (field:'tag_description'), (var:'detail_tag'), -encodenone]</p>
	[/toggle]
	</div><b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b></div>
[/if]


[if:(field:'tag_syntax')!='']
	<div class="content_panel"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b><div class="content_inner">
	[toggle: 'detail_syntax', 'Syntax']
        <p class="code">[code_highlight: (field:'tag_syntax'), (var:'detail_tag'), -encodenone]</p>
	[/toggle]
	</div><b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b></div>
[/if]

	<div class="content_panel"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b><div class="content_inner">
	[toggle: 'detail_parameters', 'Parameters']
[var: 'no_parameters'=true]
[inline: -log=$__startup_loglevel__, $ref_param_inline, -op='eq', 'tag_id'=(field: 'tag_id'), -maxrecords='all', 'param_required'='Y', -op='neq', 'param_type'='Member', -search]
[if:(found_count)>0]
	[var: 'no_parameters'=false]
      <p><table>
        <tr>
          <th colspan="2">Required Parameters</th>
        </tr>
	[records]
        <tr>
          <td valign="top" nowrap>[if:!((field: 'param_name')>>'-')]<i>[/if][field: 'param_name'][if:!((field:'param_name')>>'-')]</i>[/if]</td>
          <td valign="top">[code_highlight: (field:'param_description'), (var:'detail_tag'), -encodenone]</td>
        </tr>
	[/records]
[/if]
[/inline]
[inline: -log=$__startup_loglevel__, $ref_param_inline, -op='eq', 'tag_id'=(field:'tag_id'), -maxrecords='all', 'param_optional'='Y', -op='neq', 'param_type'='Member', -search]
[if:(found_count)>0]
	[if: $no_parameters == true]
      <p><table>
	[/if]
	[var: 'no_parameters'=false]
        <tr>
          <th colspan="2">Optional Parameters</th>
        </tr>
	[records]
        <tr>
          <td valign="top" nowrap>[if:!((field: 'param_name')>>'-')]<i>[/if][field: 'param_name'][if:!((field: 'param_name')>>'-')]</i>[/if]</td>
          <td valign="top">[code_highlight: (field:'param_description'), (var:'detail_tag'), -encodenone]</td>
        </tr>
	[/records]
[/if]
[/inline]
[if: (var:'no_parameters') && ((field: 'tag_basic') == 'Y')]
        <p>No Parameters Required.</p>
[else: (var:'no_parameters') && ((field: 'tag_basic') == 'N')]
        <p>See the Upgrading Your Solutions chapter of the Lasso 8 Language Guide for more details.</p>
[else]
	  </table></p>
[/if]
	[/toggle]
	</div><b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b></div>

[if:(field:'tag_changenotes')!='']
	<div class="content_panel"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b><div class="content_inner">
	[toggle: 'detail_changenotes', 'Change Notes']
		<p>[code_highlight: (field:'tag_changenotes'), (var:'detail_tag'), -encodenone]</p>
	[/toggle]
	</div><b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b></div>
[/if]

	<div class="content_panel"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b><div class="content_inner">
	[toggle: 'detail_examples', 'Examples']
[inline: -log=$__startup_loglevel__, $ref_example_inline, -op='eq', 'tag_id'=(field:'tag_id'), -maxrecords='all', -search]
[if:(found_count)>0]
[records]
		<p class="indent"><b>[Field: 'ex_title']</b></p>
		<p class="indent">[code_highlight:(field:'ex_description'), (var:'detail_tag'), -encodenone]</p>
[if: (field:'ex_example')!='']
        <p class="code">[code_highlight: (field:'ex_example'), (var:'detail_tag'), -encodenone]</p>
[/if]
[if: (field:'ex_result')!='']
        <p class="code" style="padding-left:19px;text-indent:-19px;"><img src="[var: 'arrow_graphic']" width="12" height="10" /> [code_highlight: (field:'ex_result'), (var:'detail_tag'), -encodenone]</p>
[/if]
[/records]
[else]
	[if: (field: 'tag_category') >> 'XML']
		<p class="indent">See the XML chapter in the Lasso 8 Language Guide for examples of how to use this tag.  Many of the XML examples require lengthy descriptions and the use of several related tags and are better suited to presentation in the Language Guide. [if: (field: 'tag_pagenumber') != 0]This tag is documented on page [field: 'tag_pagenumber'].[/if]</p>
	[else: (field: 'tag_category') >> 'PDF']
		<p class="indent">See the PDF chapter in the Lasso 8 Language Guide for examples of how to use this tag.  Many of the PDF examples require lengthy descriptions and the use of several related tags and are better suited to presentation in the Language Guide. [if: (field: 'tag_pagenumber') != 0]This tag is documented on page [field: 'tag_pagenumber'].[/if]</p>
	[else]
		<p class="indent">See the Lasso 8 Language Guide for examples of how to use this tag. [if: (field: 'tag_pagenumber') != 0]This tag is documented on page [field: 'tag_pagenumber'].[/if]</p>
	[/if]
[/if]
[/inline]
	[/toggle]
	</div><b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b></div>
	<div class="content_panel"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b><div class="content_inner">


<?LassoScript
	var: 'tag_root' = (field: 'tag_name');
	if: !($tag_root->(beginswith: '-'));
		if: $tag_root >> '->';
			var: 'tag_root' = (string_replaceregexp: (field:'tag_name'), -find='->.*', -replace='');
		else;
			var: 'tag_root' = (string_replaceregexp: (field:'tag_name'), -find='[_\\]].*', -replace='');
		/if;
	/if;
	
	var: 'all_tags' = (array);
	var: 'related_tags' = (map);
	var: 'category_tags' = (map);
	
	inline: -log=$__startup_loglevel__, $ref_tag_inline,
			-op='eq', 'tag_display'='Y',
			-op='eq', 'tag_basic'='Y',
			-op='bw', 'tag_name'=$tag_root,
			-op='neq', 'tag_id'=(field:'tag_id'),
			-maxrecords='all',
			-sortfield='tag_sort',
			-returnfield='tag_id',
			-returnfield='tag_type',
			-returnfield='tag_name',
			-search;
		records;
			if: $all_tags !>> (field: 'tag_id');
				$related_tags !>> (field: 'tag_type') ? $related_tags->(insert: (field: 'tag_type') = (array));
				$related_tags->(find: (field: 'tag_type'))->(insert: (field: 'tag_id') = (field: 'tag_name'));
				$all_tags->(insert: (field: 'tag_id'));
			/if;
		/records;
	/inline;

	inline: -log=$__startup_loglevel__, $ref_tag_inline,
			-op='eq', 'tag_display'='Y',
			-op='eq', 'tag_basic'='Y',
			-op='eq', 'tag_category'=(field: 'tag_category'),
			-op='neq', 'tag_id'=(field:'tag_id'),
			-maxrecords='all',
			-sortfield='tag_sort',
			-returnfield='tag_id',
			-returnfield='tag_type',
			-returnfield='tag_name',
			-search;
		records;
			if: $all_tags !>> (field: 'tag_id');
				$category_tags !>> (field: 'tag_type') ? $category_tags->(insert: (field: 'tag_type') = (array));
				$category_tags->(find: (field: 'tag_type'))->(insert: (field: 'tag_id') = (field: 'tag_name'));
				$all_tags->(insert: (field: 'tag_id'));
			/if;
		/records;
	/inline;
	
?>

[if: $related_tags->size > 0]
	[toggle: 'detail_related', 'Related Tags']
	<table>
	[iterate: (array: 'Substitution', 'Container', 'Process', 'Member', 'Command', 'Symbol', 'Delimiter'), (var: 'type')]
		[var: 'tags' = $related_tags->(find: $type)]
		[if: $tags->size > 0]
			<tr>
				<th>[$type]</th>
			</tr>
			<tr>
				<td>
				[var: 'split' = (math_ceil: $tags->size / 3.0)]
				[iterate: $tags, (var: 'tag')]
					[var:'detail_url'= $admin_file + '?' + (encode_taglink: $tag->second, $tag->first)]
					<nobr><a href="[var: 'detail_url']">[list_cleanup: $tag->second]</a></nobr><br />
					[if: (loop_count == $split) || (loop_count == $split * 2)]</td><td>[/if]
				[/iterate]
				</td>
			</tr>
		[/if]
	[/iterate]
	</table>
	[/toggle]
[/if]

[if: $category_tags->size > 0]
	[toggle: 'detail_category', 'Category Tags']
	<table>
	[iterate: (array: 'Substitution', 'Container', 'Process', 'Member', 'Command', 'Symbol', 'Delimiter'), (var: 'type')]
		[var: 'tags' = $category_tags->(find: $type)]
		[if: $tags->size > 0]
			<tr>
				<th>[$type]</th>
			</tr>
			<tr>
				<td>
				[var: 'split' = (math_ceil: $tags->size / 3.0)]
				[iterate: $tags, (var: 'tag')]
					[var:'detail_url'= $admin_file + '?' + (encode_taglink: $tag->second, $tag->first)]
					<nobr><a href="[var: 'detail_url']">[list_cleanup: $tag->second]</a></nobr><br />
					[if: (loop_count == $split) || (loop_count == $split * 2)]</td><td>[/if]
				[/iterate]
				</td>
			</tr>
		[/if]
	[/iterate]
	</table>
	[/toggle]
[/if]

	</div><b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b></div>
	[/records]
[if: $ls_foundcount == 0]
	<p class="error">No Tag Found</p>
[/if]

</div>
