<form action="[var: 'admin_file']?tab1=[var: 'admin_tab1']&tab2=codetable" method="post">
<div class="content_top">
	<h2 style="float: right">Code Table <select name="unicode_codetable" onChange="this.form.submit()">[iterate: $unicode_codetable_array, (var: 'table_temp')]
		<option value="[string: $table_temp->first]" [if: $unicode_codetable == $table_temp->first] selected="selected"[/if]>[string: $table_temp->first]</option>[/iterate]
	</select> 
	<input type="submit" name="unicode_action" size="16" value="Refresh" class="small" /></h2>
	<h2>Unicode Character </h2>
</div>
</form>

<div class="content_full">

	<h2 style="font-size: 108px; float: right;">[var: 'show_character']</h2>

	<table>
		<tr>
			<th>Character</th>
			<td>[var: 'show_character']</td>
		</tr>
		<tr>
			<th>Character Name</th>
			<td>[encode_html: $show_character->charname]</td>
		</tr>
		<tr>
			<th>Character Type</th>
			<td>[encode_html: $show_character->chartype]</td>
		</tr>
	[if: $show_character->isulowercase]
		<tr>
			<th>Uppercase</th>
			<td>[string_uppercase: $show_character]</td>
		</tr>
	[/if]
	[if: $show_character->isuuppercase]
		<tr>
			<th>Lowercase</th>
			<td>[string_lowercase: $show_character]</td>
		</tr>
	[/if]
		<tr>
			<th>Entity</th>
			<td>&amp;#x[encode_html: $unicode_character];</td>
		</tr>
	[if: $show_character != (encode_html: $show_character)]
		<tr>
			<th>HTML Entity</th>
			<td>[encode_html: encode_html: $show_character]</td>
		</tr>
	[/if]
	[if: $show_character != (encode_stricturl: $show_character)]
		<tr>
			<th>URL Entity</th>
			<td>[encode_stricturl: $show_character]</td>
		</tr>
	[/if]
	[protect]
		<tr>
			<th>Bit Format</th>
			<td>
				<?LassoScript
					var: 'temp' = (example_bitformat: $show_character)->(split: '|');
					$temp->(get:1)->trim & + ' (' + $temp->(get:2)->trim & + ')';
				?>
			</td>
		</tr>
	[/protect]
		<tr>
			<th>Attributes</th>
			<td>
				<?LassoScript
					var: 'attributes' = (array);
					$show_character->isalpha ? $attributes->(insert: 'Alphabetic');
					$show_character->isbase ? $attributes->(insert: 'Base');
					$show_character->iscntrl ? $attributes->(insert: 'Control Character');
					$show_character->isdigit ? $attributes->(insert: 'Digit');
					(string_ishexdigit: $show_character) ? $attributes->(insert: 'Hex Digit');
					$show_character->islower ? $attributes->(insert: 'Lowercase');
					$show_character->isprint ? $attributes->(insert: 'Printable');
					(string_ispunctuation: $show_character) ? $attributes->(insert: 'Punctuation');
					$show_character->istitle ? $attributes->(insert: 'Titlecase');
					$show_character->isupper ? $attributes->(insert: 'Uppercase');
					$show_character->isspace ? $attributes->(insert: 'Whitespace');
					$show_character->isalnum ? $attributes->(insert: 'Alpha-Numeric');
					if: $attributes->size > 0;
						$attributes->(join: ', ');
					else;
						'None';
					/if;
				?>
			</td>
		</tr>
		<tr>
			<th>Unicode Attributes</th>
			<td>
				<?LassoScript
					var: 'attributes' = (array);
					$show_character->isulowercase ? $attributes->(insert: 'Lowercase');
					$show_character->isuuppercase ? $attributes->(insert: 'Uppercase');
					$show_character->isuwhitespace ? $attributes->(insert: 'Whitespace');
					if: $attributes->size > 0;
						$attributes->(join: ', ');
					else;
						'None';
					/if;
				?>
			</td>
		</tr>
		<tr>
			<th>Unicode Version</th>
			<td>[string_getunicodeversion]</td>
		</tr>
		
		
	</table>

</div>