<div class="content_split">
	<div class="content_left">
	
		<h2>XML XPath Utility</h2>
		
		<form action="[var: 'admin_link']" method="post">
		
		<table>
			<tr valign="top">
				<th>XML</th>
				<td>
					<textarea name="text" rows="12" cols="80" class="std_area_large">[var: 'text']</textarea>
				</td>
				</td>
			</tr>
			<tr valign="top">
				<th>XPath</th>
				<td>
					<input type="text" name="xpath" value="[var: 'xpath']" size="32" />
				</td>
			</tr>
			<tr valign="top">
				<th>&nbsp;</th>
				<td>
					<input type="submit" name="action" value="[noprocess][XML->Extract][/noprocess]" />
				</td>
			</tr>		
		</table>
		
		</form>
		
		<hr />
		
		[protect]
			[var: 'xml' = (xml: $text)]
			[handle_error]
				<p>Error: [string_replaceregexp: error_msg, -find=' at:[\\s\\S]*', -replace=''] ([error_code])</p>
			[/handle_error]
		[/protect]
		
		[if: $xml->(isa: 'xml')]
			[protect]
				[var: 'result' = $xml->(extract: $xpath)]
				[handle_error]
					<p>Error: [string_replaceregexp: error_msg, -find=' at:[\\s\\S]*', -replace=''] ([error_code])</p>
				[/handle_error]
			[/protect]
		[/if]
		
		[if: $result->(isa: 'array')]
			<p>Result [$result->size] elements.</p>
			[iterate: $result, (var: 'temp')]
				<p>[loop_count] [$temp->nodetype] <pre>[Encode_HTML: $temp]</pre></p>
			[/iterate]
		[else]
			<p>No Results!</p>
		[/if]
	
	</div>

	<div class="content_right">
	
[noprocess]

<h2>XPath Reference</h2>

<p><b>Quick Reference</b></p>

/ - XML Root<br />
/tagname - Top-Level Tag&lt;tagname /><br />
/tagname/tagname2 - Path to a tag &lt;tagname>&lt;tagname2 />&lt;/tagname><br />
//tagname - Select All Tags &lt;tagname /><br />
tagname/text() - Select text content of &lt;tagname /><br />
tagname/@name - Select parameter name=""<br />
//@name - Select all parameters name=""<br />
//tagname[1] - Select first tag &lt;tagname /><br />
//tagname[last()] - Select last tag &lt;tagname /><br />
//tagname[name="John"] - Select &lt;tagname /> with parameter name="John"

<p><b>Web Reference</b></p>

<p><a href="http://www.w3.org/TR/xpath">XML Path Language (XPath)</a> at World Wide Web Consortium (W3C)</p>

[/noprocess]

	</div>
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0"></div>	
</div>
