<?LassoScript

	// XPath XPlorer
	//  2007 LassoSoft, LLC
	// By Fletcher Sandbeck

	var: 'admin_title' = 'XML XPath Utility';
	
	// Serve Source Code
	// If the URL contains source=true then the source code of this page will be served!
	if: (action_param: 'source') == 'true';
		content_type: 'text/plain';
		$__html_reply__ = (include_raw: response_filepath);
		abort;
	/if;

	var: 'action' = (action_param: 'action');
	var: 'text' = (action_param: 'text');
	var: 'xpath' = (action_param: 'xpath');
	var: 'result' = null;
	
	if: ($text == '') && ($xpath == '');
		var: 'text' = '<xml_root>
			<xml_parent name="John Doe">
				<xml_child name="Billy Doe" sex="male">Slugs and Snails</xml_child>
				<xml_child name="Dosey Doe" sex="female">Sugar and Spice</xml_child>
				<xml_child name="John Doe Jr." sex="male">Puppy Dog Tails</xml_child>
			</xml_parent>
		</xml_root>';
		var: 'xpath' = '//*';
	/if;

	$text->(replace:'', ' '); // Non-Breaking Spaces
	var: 'text' = (string_replaceregexp: $text, -find='[\r\n]+\\s+', -replace='\r')

	var: 'xml' = null;
	var: 'result' = array;
	
?>