<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" >
	<head>
		<title>Initialize Server</title>
		<style>[include: (lassoapp_link: 'default_css.lasso')]</style>
[if: ($admin_splash == 'true')]
	[var: 'splash_link' = (lassoapp_link: 'default.lasso') + '?initialize=initialize&admin_splash=false']
	<meta http-equiv="refresh" content="5;URL=[var: 'splash_link']">
[/if]
	</head>
	<body>
[if: ($admin_splash == 'true')]
		<div align="center">
			<table width="400" border="0" cellspacing="0" cellpadding="0">
				<tr>
					<td align="center" valign="middle">&nbsp;</td>
				</tr>
				<tr>
					<td align="center" valign="middle">
						<a href="[var: 'splash_link']">
							<img src="[lassoapp_link:'images/logo_splash.jpg']" border="0" />
						</a>
					</td>
				</tr>
				<tr>
					<td align="center" valign="middle">&nbsp;</td>
				</tr>
				<tr>
					<td align="center" valign="middle">
						Welcome to Lasso Professional 8.6.<br />
						Click on the splash screen to initialize your server.
					</td>
				</tr>
				<tr>
					<td align="center" valign="middle">&nbsp;</td>
				</tr>
			</table>
		</div>
[else]

		<div class="header">
			<div class="header_tab1" align="center">
				<img class="graphic_left" src="[lassoapp_link:'images/logo_left.jpg']" alt="" width="144" height="36" />
				<a href="http://www.lassosoft.com" target="_new"><img class="graphic_right" src="[lassoapp_link:'images/logo_right.jpg']" alt="" width="144" height="36" border=0 /></a>[loop: $admin_tab_array1->size][var: 'temp' = $admin_tab_array1->(get: loop_count)]
				<a href="[Response_FilePath]?tab1=[encode_url: $temp->First]" class="tab1[If: $temp->First == $admin_tab1] active1[/If]"><img class="corner_left1" src="[lassoapp_link:'images/corner_ffffff_left.gif']" border="0" alt="" width="2" height="2" /><span class="tab1">[encode_html: $temp->Second]</span><img class="corner_right1" src="[lassoapp_link:'images/corner_ffffff_right.gif']" border="0" alt="" width="2" height="2" /></a>[/loop]
			</div>
			<div class="header_tab2"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b>
				&nbsp;
			</div>
		</div>

		<div class="body">

<form autocomplete="off" action="[response_filepath]" method="post" enctype="multipart/form-data">
	<input type="hidden" name="admin_splash" value="false" />
	<input type="hidden" name="initialize" value="initialize" />

[if: $admin_needs !>> 'admin']

<div class="content_split_solo">
	<div class="content_left">
		
		<h2>Initialization Complete</h2>
		
		<p>Lasso Professional 8.6 has been successfully initialized.</p>
		
		<p>Please proceed to the server administration interface to continue with
		setup and configuration of Lasso Professional 8.6. Consult the Lasso
		Professional 8 Setup Guide for full documentation.</p>

	[if: (var_defined: 'import_error') && ($import_error != '')]
		<p class="error">[var: 'import_error', -encodenone]</p>
	[/if]
	[if: (var_defined: 'import_success') && ($import_success != '')]
		<p class="message">[var: 'import_success']</p>
	[/if]

		<p align="right">
			<input type="Submit" name="action" value="Open Server Administration" />
		</p>
		
	</div>
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0" /></div>
</div>

[else]

	<input type="hidden" name="admin_needs" value="[var: 'admin_needs']" />

<div class="content_split">
	<div class="content_left">
		
		<h2>Welcome to Lasso Professional 8.6</h2>
		
		<p>Before operating Lasso Professional 8.6, it needs to be initialized
		by completing the following steps:</p>
		
		<ol>
			<li>Enter your serial number.</li>
			<li>Create a server administrator username and password.</li>
			<li>Set email server and DNS preferences.</li>
			<li>Import a migration file from an earlier version of Lasso.</li>
		</ol>
		
		<p>After these steps are completed, you can access the administration
		interface to complete the setup and configuration and begin using Lasso
		Professional 8.6.</p>
		
		<h2>Where to Find Your Serial Number</h2>
		
		<p>A serial number is required to deploy solutions using Lasso Professional 8.6. 
		Your serial number can be found in the order confirmation email for Lasso Professional 8.6.</p>

		<p>Lasso can be used without a serial number to develop and demonstrate solutions.  When used
		in this mode Lasso has a 5 IP address limit and a limit on the number of connections per minute
		which it will process.</p>
		
		<p>Note - Lasso Studio no longer requires a serial number for the server component.</p>
		
		<p>Lasso Professional 8.6 can be purchased at the LassoSoft store through the following button.
		A free 30-day evaluation version of Lasso Professional 8.6 is also available so the full
		functionality of Lasso can be experienced prior to buying.</p>
		
		<table width="100%">
			<tr>
				<td width="50%" align="center">
					<a href="http://www.lassosoft.com/Lasso-Professional-86" target="_new">
						<img src="[lassoapp_link: 'images/lasso_order.gif']" width="110" height="31" border="0" ALT="Order Now" />
					</a>
				</td>
				<td width="50%" align="center">
					<a href="http://www.lassosoft.com/downloads" target="_new">
						<img src="[lassoapp_link: 'images/lasso_trial.gif']" width="110" height="31" border="0" ALT="Free Trial" />
					</a>
				</td>
			</tr>
		</table>
		
	</div>
	
	<div class="content_right">

		<input type="hidden" name="admin_submit" value="serial" />

		<h2>Enter Your Serial Number</h2>
		
		<table>
			<tr>
				<td><input type="radio" name="admin_edition" value="pro" checked="checked" /></td>
				<th width="35%">Lasso Professional 8.6</th>
				<td width="60%"><input type="text" name="admin_serial" value="[var:'admin_serial']" class="large" /></td>
			</tr>
			<tr>
				<td><input type="radio" name="admin_edition" value="dev" /></td>
				<th width="35%">Lasso Developer 8.6</th>
				<td width="60%"><em>No Serial Number Required</em></td>
			</tr>
			<tr>
				<td><input type="radio" name="admin_edition" value="dev" /></td>
				<th width="35%">Lasso Studio 8.6</th>
				<td width="60%"><em>No Serial Number Required</em></td>
			</tr>
			<tr>
				<td colspan="2">
				</td>
			</tr>
		</table>
		
	[if: (var_defined:'admin_serial_error') && ((var: 'admin_serial_error') != '')]
		<p class="error">[var:'admin_serial_error']</p>
	[/if]

		<p>If you have a serial number for Lasso Professional 8.6, please enter the entire serial number including the prefix. For example: 
		<nobr>&quot;Lasso-8.6-abcd0123456789&quot;</nobr>.</p>

		<input type="hidden" name="admin_submit" value="admin" />

		<h2>Create a Server Administrator Username and Password</h2>
		
		<table>
			<tr>
				<th width="35%">Administrator Username</th>
				<td><input type="text" name="admin_username" value="[var:'admin_username']" /></td>
			</tr>
			<tr>
				<th width="35%">Administrator Password</th>
				<td><input type="password" name="admin_password" value="[var:'admin_password']" /></td>
			</tr>
			<tr>
				<th width="35%">Confirm Password</th>
				<td><input type="password" name="admin_confirm" value="[var:'admin_confirm']" /></td>
			</tr>
		</table>
		
	[if: (var_defined:'admin_username_error') && ((var: 'admin_username_error') != '')]
		<p class="error">[var:'admin_username_error']</p>
	[/if]
	[if: (var_defined:'admin_password_error') && ((var: 'admin_password_error') != '')]
		<p class="error">[var:'admin_password_error']</p>
	[/if]

		<p>This username and password will be required to access the server and
		site administration interfaces for Lasso Professional 8.6. Be sure to
		keep a copy of the values you enter.</p> 

		<input type="hidden" name="admin_submit" value="prefs" />

		<h2>Email Preferences</h2>
		
		<table>
			<tr>
				<td><input type="radio" name="lasso_smtp_sendmode" value="direct"[if: $prefs->(find:'lasso_smtp_sendmode') >> 'direct'] checked="checked"[/if] /></td>
				<th width="35%">Send Directly to SMTP Servers</th>
				<td width="60%"><em>No Configuration Required</em></td>
			</tr>
			<tr>
				<td><input type="radio" name="lasso_smtp_sendmode" value="local"[if: $prefs->(find:'lasso_smtp_host') != ''] checked="checked"[/if] /></td>
				<th width="35%">Use Local SMTP Host</th>
				<td width="60%"><input type="text" name="lasso_smtp_host" value="[encode_html: $prefs->(find:'lasso_smtp_host')]" class="large" /></td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<th width="35%">SMTP Username</th>
				<td width="60%"><input type="text" name="lasso_smtp_username" value="[encode_html: $prefs->(find:'lasso_smtp_username')]" class="large" /></td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<th width="35%">SMTP Password</th>
				<td width="60%"><input type="text" name="lasso_smtp_password" value="[encode_html: $prefs->(find:'lasso_smtp_password')]" class="large" /></td>
			</tr>
			<tr>
				<td colspan="2">
				</td>
			</tr>
		</table>
		
	[if: (var_defined:'admin_prefs_error')]
		<p class="error">[var:'admin_prefs_error']</p>
	[/if]

		<p>These settings will be used as the default for all created sites.</p> 

		<input type="hidden" name="admin_submit" value="import" />

		<h2>Import a Migration File (optional)</h2>
		
		<table>
			<tr>
				<th width="35%">Select File</th>
				<td><input type="file" name="admin_migration" value="[var:'admin_migration']" /></td>
			</tr>
		</table>
		
	[if: (var_defined: 'import_error') && ($import_error != '')]
		<p class="error">[var: 'import_error', -encodenone]</p>
	[/if]
	[if: (var_defined: 'import_success') && ($import_success != '')]
		<p class="message">[var: 'import_success']</p>
	[/if]

		<p>If you have exported settings from a previous installation of Lasso 7 or earlier,
		select your settings file here.  These settings will be imported into the default site
		of your Lasso 8.6 installation.</p> 

		<p align="right">
			<input type="Submit" name="action" value="Submit Information">
		</p>

	</div>
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0" /></div>
</div>

[/if]

</form>

			<div style="height: 54px;">&nbsp;</div>
		</div>

		<div class="footer">
			<div class="frame_footer">
				<div class="frame_inner">
					Initialize Lasso Professional 8.6 &#149; [date->format('%-m/%-d/%y %-T')]
				</div>
				<b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b>
			</div>
			&copy; 1996[if: date->year > 1996]-[date->year][/if] LassoSoft Inc.
		</div>
	</body>
</html>
[/if]