<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post" enctype="multipart/form-data">
<input type="hidden" name="dialog_action" value="" />

<div class="content_split">
	<div class="content_left">
		<h2>Import Server Settings</h2>
		<p>
			Important - This interface should only be used to import an export of Lasso Professional 8 
			server settings.  Lasso Settings Migrator files should be imported into an individual site
			using the <a href="[Response_FilePath]?tab1=sites&tab2=sites&tab3=importexport">Sites &gt; Import/Export</a> section.
		</p>
		<table>
			<tr>
				<th>File</th>
				<td width="65%">
					<input type="file" name="import_file" value="[action_param: 'import_file']" />
				</td>
			</tr>
		</table>
[if: (var_defined: 'import_error') && ($import_error != '')]
		<p class="error">[var: 'import_error', -encodenone]</p>
[/if]
[if: (var_defined: 'import_success') && ($import_success != '')]
		<p class="message">[var: 'import_success']</p>
[/if]
[if: ($action >> 'Import') && ($import_cancel == false)]
		<p>
              Your site will be stopped in a couple seconds.  
              Wait a few seconds and follow this link to re-enter Server Administration.  The first click on the link will re-start your site.  
              If you receive an error from your browser, wait 10-15 seconds and click on the link again.
		</p>
		<p class="message">
              <a href="[var: 'admin_link', -encodenone]&tab1=setup&tab2=global&tab3=login">Server Administration</a>
		</p>
[/if]
		<p>&nbsp</p>
		<p align="right">
			<input type="submit" value="Import" name="action" class="medium" onclick="return confirm('Warning - Importing a setup file will overwrite all settings in Lasso Administration.  Are you sure you want to do this?');" />
		</p>
	</div>
	<div class="content_right">
		<h2>Export Server Settings</h2>
		<p>
			Select the "Export..." button to download a text file with all
			the Server Administration settings for this server.  The file will be named Lasso_Server_YYYYMMDDHHMMSS.txt.
		</p>
		<p>
              <em>Note:</em> The exported settings will include the site definitions, but will not include the
              Site Administration settings for any of the defined sites.
		</p>
		<p>&nbsp</p>
		<p align="right">
			<input type="submit" name="action" value="Export..." class="medium" />
		</p>
	</div>
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0"></div>
</div>

</form>
