<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">
<input type="hidden" name="dialog_action" value="" />

<div class="content_top">
	<p>
		Note - This is the Server Administration interface.  Settings for the
		default site (including data sources, security, email queue, etc.) can
		be found at the Site Administration interface accessible from the quick
		links below. Consult the Lasso 8.6 Setup Guide for additional details
		about the new multi-site architecture of Lasso.
	</p>
</div>

[if: ($login_action >> 'Restart')]

<div class="content_split_solo">
	<div class="content_left">
		<h2>Stopping Site</h2>
		<p>
              Your site will be stopped in a couple seconds.  
              Wait a few seconds and follow this link to re-enter Site Administration.  The first click on the link will re-start your site.  
              If you receive an error from your browser, wait 10-15 seconds and click on the link again.
		</p>
		<p class="message">
              <a href="[var: 'admin_link', -encodenone]&tab1=setup&tab2=global&tab3=login">Site Administration</a>
		</p>
	</div>
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0"></div>
</div>

[else]

<div class="content_split">
	<div class="content_left">
[if: ($admin_serial == true)]
		<h2>Lasso Professional 8.6</h2>
[else]
		<h2>Lasso Developer 8.6</h2>
[/if]
		<table>
[if: ($admin_expires != '')]
			<tr>
				<th>Binary Expiration</th>
				<td style="color:red">Build Expires [var: 'admin_expires']</td>
			</tr>
[/if]
			<tr>
				<th>Product</th>
[if: ($admin_serial == true)]
				<td>Lasso Professional 8.6</td>
[else]
				<td>Lasso Developer 8.6</td>
[/if]
			</tr>
			<tr>
				<th>Version</th>
				<td>[lasso_version: -lassoversion]</td>
			</tr>
			<tr>
				<th>Platform</th>
				<td>[lasso_version: -lassoplatform]</td>
			</tr>
			<tr>
				<th>Authentication</th>
				<td>[client_authorization->(find: 'type')]</td>
			</tr>			
		[protect]
			[var: 'seconds' = (integer: lasso_uptime)][var: 'temp' = 0]
			<tr>
				<th>Uptime</th>
				<td>
          	[if: $seconds >= 86400][integer: $temp := $seconds / 86400] Day[if: $temp > 1]s[/if]
				[if: ($seconds := ($seconds % 86400)) >= 3600][integer: $temp := $seconds / 3600] Hour[if: $temp > 1]s[/if][/if]
			[else: ($seconds := ($seconds % 86400)) >= 3600][integer: $temp := $seconds / 3600] Hour[if: $temp > 1]s[/if]
			[else: ($seconds := ($seconds % 3600)) >= 60][integer: $temp := $seconds / 60] Minute[if: $temp > 1]s[/if]
			[else: ($seconds := ($seconds % 60)) > 0][integer: $temp := $seconds] Second[if: $temp > 1]s[/if][/if]
				</td>
			</tr>
		[/protect]
		[if: (global: '__startup_version__') != 'Unknown' && (global: '__startup_version__') != '']
			<tr>
				<th>Startup Build Date</th>
				<td>[date_format: (global: '__startup_version__'), -format='%Q']</td>
			</tr>
		[/if]
			<tr>
				<th colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<th>Site</th>
				<td>[Site_Name] ([Site_ID])</td>
			</tr>
		</table>
		<p align="right">
			<input type="Submit" name="action" value="Update Server Admin Login" class="large" />
			<input type="Submit" name="action" value="Update Serial Numbers" class="large" />
		</p>

	</div>
	<div class="content_right">

		<h2>Sites</h2>
<?lassoscript
	var: 'sites_map' = (array);
	
	inline: -log=$__startup_loglevel__, -search,
			-database='lasso_internal',
			-table='sites',
			-keyfield='id',
			-maxrecords='all';
		records;
			var: 'temp' = (map);
			iterate: field_names, (var: 'field');
				$temp->(insert: $field = (field: $field));
			/iterate;		
			$sites_map->(insert: $temp);
		/records;
	/inline;
?>
		<table>
[iterate: $sites_map, (var: 'sites_temp')]
	[var: 'running' = (server_siteisrunning: $sites_temp->(find: 'id'))]
			<tr>
				<th>Site [encode_html: $sites_temp->(find: 'id')]</th>
				<td>[encode_html: $sites_temp->(find: 'name')][if: $sites_temp->(find: 'enabled') >> 'n'] (Disabled[if: $running == true], Running[/if])[else: $running == false] (Stopped)[/if]</td>
			</tr>
			<tr>
				<th>Quick Links</th>
				<td>
					<a href="[var: 'admin_link']&tab1=sites&tab2=sites&tab3=sites&action=detail&site_id=[encode_html: $sites_temp->(find: 'id')]">Site Detail</a>, 
					<a href="[var: 'admin_link']&tab1=sites&tab2=sites&tab3=prefs&action=detail&site_id=[encode_html: $sites_temp->(find: 'id')]">Preferences</a>, 
					<a href="[var: 'admin_link']&tab1=sites&tab2=sites&tab3=paths&action=detail&site_id=[encode_html: $sites_temp->(find: 'id')]">File Paths</a> 
				</td>
			</tr>
[if: $running == true]
	[var: 'link' = (admin_getpref: 'lasso_site_admin_url', -site=$sites_temp->(find: 'id'))]
	[if: ($link == '') && ($sites_temp->(find: 'url') != '')]
		[var: 'link' = $sites_temp->(find: 'url')]
	[else: ($link == '') && ($sites_temp->(find: 'id') == 1)]
		[var: 'link' = 'http' + ((server_port == 443)?'s'|'') + '://' + server_name + ':' + server_port + '/SiteAdmin.LassoApp']
	[/if]
	[if: $link != '']
			<tr>
				<th>&nbsp;</th>
				<td>
					<a href="[var: 'link']" target="_blank">Site Administration</a>, 
					[var: 'link' = (string_replaceregexp: $link, -find='siteadmin.*lassoapp', -Replace='', -ignorecase)]
					<a href="[encode_html: $link + 'DatabaseBrowser.LassoApp']" target="_blank">Database Browser</a>
					</td>
			</tr>
	[/if]
[/if]
			<tr>
				<td colspan="2">&nbsp;</td>
			</tr>
[/iterate]
	[if: found_count > 5]
			<tr>
				<th>&nbsp;</th>
				<td><a href="[var: 'admin_link']&tab2=security&tab3=groups">([integer: found_count - 5] More)</a></td>
				<td>&nbsp;</td>
			</tr>
	[/if]
		</table>

	</div>
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0"></div>
</div>
[/if]

</form>
