<?LassoScript

	_admin_addvar: 'thread_id', -default=0, -override=(action_param: 'id');
	_admin_addvar: 'thread_action', -default='none', -override=(action_param: 'action');
	_admin_addvar: 'thread_priority', -default='all', -session='_siteadmin', -override=(action_param: 'priority');
	
	protect;
		if: $thread_action == 'abort';
				thread_abort: $thread_id;
		else: $thread_action == 'high';
			thread_setpriority: $thread_id, thread_priority_high;
		else: $thread_action == 'default';
			thread_setpriority: $thread_id, thread_priority_default;
		else: $thread_action == 'low';
			thread_setpriority: $thread_id, thread_priority_low;
		/if;
	/protect;

	var: 'thread_list' = thread_list;
	var: 'thread_array' = (array);
	var: 'thread_current' = thread_getcurrentid;
	
	iterate: $thread_list, (var: 'thread_id');
	  if: (integer: $thread_id) > 0;
	  		var: 'temp' = (thread_info: $thread_id);
	  		if: $thread_id == $thread_current;
	  			$temp->(insert: 'name' = $temp->(find: 'name') + ' (Current)');
	  		/if;
	  		var: 'priority' = (thread_getpriority: $thread_id);
	  		if: $priority == thread_priority_high;
		  		$temp->(insert: 'priority' = 'High');
		  		var: 'include' = ($thread_priority == 'High') || ($thread_priority == 'All');		  			
	  		else: $priority == thread_priority_low;
		  		$temp->(insert: 'priority' = 'Low');
		  		var: 'include' = ($thread_priority == 'Low') || ($thread_priority == 'All');		  			
		  	else;
		  		$temp->(insert: 'priority' = 'Default');
		  		var: 'include' = ($thread_priority == 'Default') || ($thread_priority == 'All');		  			
		  	/if;
			if: $include;
				$thread_array->(insert: $temp);
			/if;
		/if;
	/iterate;

?>
