<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" >
	<head>
		<title>Initialize Site</title>
		<style>[include: (lassoapp_link: 'default_css.lasso')]</style>
	</head>
	<body>
		<div class="body">

<form autocomplete="off" action="[response_filepath]" method="post">
	<input type="hidden" name="initialize" value="initialize" />

<div class="content_split_solo">
	<div class="content_left">
		
		<h2>Welcome to Lasso Professional 8.6</h2>
		
		<p>Before using your site, it needs to be initialized by creating
		a site administrator username and password.</p>
		
		<table>
			<tr>
				<th width="35%">Administrator Username</th>
				<td><input type="text" name="admin_username" value="[var:'admin_username']" /></td>
			</tr>
			<tr>
				<th width="35%">Administrator Password</th>
				<td><input type="password" name="admin_password" value="[var:'admin_password']" /></td>
			</tr>
			<tr>
				<th width="35%">Confirm Password</th>
				<td><input type="password" name="admin_confirm" value="[var:'admin_confirm']" /></td>
			</tr>
		</table>
		
	[if: (var_defined:'admin_username_error') && ((var: 'admin_username_error') != '')]
		<p class="error">[var:'admin_username_error']</p>
	[/if]
	[if: (var_defined:'admin_password_error') && ((var: 'admin_password_error') != '')]
		<p class="error">[var:'admin_password_error']</p>
	[/if]

		<p>After submitting this form you will need to enter your site administrator username
		and password in order to enter the Site Administration interface.</p>

		<p align="right">
			<input type="Submit" name="action" value="Submit Information">
		</p>

	</div>
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0"></div>
</div>

</form>

		</div>

		<div class="header">
			<div class="header_tab1" align="center">
				<img class="graphic_left" src="[lassoapp_link:'images/logo_left.jpg']" alt="" width="144" height="36" />
				<a href="http://www.lassosoft.com" target="_new"><img class="graphic_right" src="[lassoapp_link:'images/logo_right.jpg']" alt="" width="144" height="36" border=0 /></a>[loop: $admin_tab_array1->size][var: 'temp' = $admin_tab_array1->(get: loop_count)]
				<a href="[Response_FilePath]?tab1=[encode_url: $temp->First]" class="tab1[If: $temp->First == $admin_tab1] active1[/If]"><img class="corner_left1" src="[lassoapp_link:'images/corner_ffffff_left.gif']" border="0" alt="" width="2" height="2" /><span class="tab1">[encode_html: $temp->Second]</span><img class="corner_right1" src="[lassoapp_link:'images/corner_ffffff_right.gif']" border="0" alt="" width="2" height="2" /></a>[/loop]
			</div>
			<div class="header_tab2"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b>
				&nbsp;
			</div>
		</div>

		<div class="footer">
			<div class="frame_footer">
				<div class="frame_inner">
					Initialize Lasso Professional 8.6 &#149; [date->format('%-m/%-d/%y %-T')]
				</div>
				<b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b>
			</div>
			<p>&copy; 1996[if: date->year > 1996]-[date->year][/if] LassoSoft Inc.</p>
		</div>

	</body>
</html>
