<?LassoScript

//
// Variables
//

_admin_addvar: 'datasource_action', -default='None', -override=(action_param: 'datasource_action', (action_param: 'datasource_action', -count));
_admin_addvar: 'datasource_fields_skip', -default=1, -session='_siteadmin', -override=(action_param: 'datasource_fields_skip');
_admin_addvar: 'datasource_navigation', -override=(action_param: 'datasource_navigation');
_admin_addvar: 'datasource_jump', -override=(action_param: 'datasource_jump');

_admin_addvar: 'field_id', -override=(action_param: 'field_id');
_admin_addvar: 'field_enabled', -override=(action_param: 'field_enabled');
_admin_addvar: 'field_allowsearch', -override=(action_param: 'field_allowsearch');
_admin_addvar: 'field_allowmodify', -override=(action_param: 'field_allowmodify');
_admin_addvar: 'field_exactsearch', -override=(action_param: 'field_exactsearch', (action_param: 'field_exactsearch', -count));
_admin_addvar: 'field_exactdelete', -override=(action_param: 'field_exactdelete', (action_param: 'field_exactdelete', -count));
_admin_addvar: 'field_exactupdate', -override=(action_param: 'field_exactupdate', (action_param: 'field_exactupdate', -count));
_admin_addvar: 'field_filtersearch', -force=(action_param: 'field_filtersearch');
_admin_addvar: 'field_filteradd', -force=(action_param: 'field_filteradd');
_admin_addvar: 'field_filterupdate', -force=(action_param: 'field_filterupdate');

_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');

//
// Process Action
//

if: $datasource_action >> 'Update';

	_admin_updatefield: $datasource_fieldid,
		'enabled'=$field_enabled,
		'allow_search'=$field_allowsearch,
		'allow_modify'=$field_allowmodify,
		'exact_search'=$field_exactsearch,
		'exact_delete'=$field_exactdelete,
		'exact_update'=$field_exactupdate,
		'filter_search'=$field_filtersearch,
		'filter_add'=$field_filteradd,
		'filter_update'=$field_filterupdate,
		'allow_response_field'='N';

	if: $_code != (error_noerror);
		var: 'datasource_error' = $_error + ' (' + $_code + ')';
	else;
		var: 'datasource_message' = 'The field was updated successfully.';
	/if;

	var: '__admin_fields_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_fieldmap' = (_admin_listfields: $datasource_tableid);
	var: 'datasource_fielddetail' = $datasource_fieldmap->(find: $datasource_fieldid)->(get:1)->second;
	var: 'datasource_fieldname' = $datasource_fielddetail->(find: 'name');

	var: 'datasource_action' = 'Detail';

else: $datasource_action >> 'Delete Settings';

	_admin_deletefield: $datasource_fieldid;

	var: '__admin_fields_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_fieldmap' = (_admin_listfields: $datasource_tableid);
	var: 'datasource_fieldid' = -1;
	var: 'datasource_fielddetail' = null;

else: $dialog_action >> 'Delete All Settings';

	iterate: $datasource_fieldmap, (var: 'temp_field');
		_admin_deletefield: $temp_field->first;
	/iterate;

	var: '__admin_fields_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_fieldmap' = (_admin_listfields: $datasource_tableid);
	var: 'datasource_fieldid' = -1;
	var: 'datasource_fielddetail' = null;

else: $dialog_action >> 'Enable All';

	iterate: $datasource_fieldmap, (var: 'temp_field');
		var: 'id' = $temp_field->first;
		_admin_updatefield: $id, 'enabled'='Y';
	/iterate;

	var: '__admin_fields_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_fieldmap' = (_admin_listfields: $datasource_tableid);

else: $dialog_action >> 'Disable All';

	iterate: $datasource_fieldmap, (var: 'temp_field');
		var: 'id' = $temp_field->first;
		_admin_updatefield: $id, 'enabled'='N';
	/iterate;

	var: '__admin_fields_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_fieldmap' = (_admin_listfields: $datasource_tableid);

/if;


//
// Process Navigation
//

if: $datasource_navigation >> 'Prev';
	$datasource_fields_skip -= $admin_listingsize;
else: $datasource_navigation >> 'Next';
	$datasource_fields_skip += $admin_listingsize;
else: $datasource_navigation >> 'First';
	$datasource_fields_skip = 1;
else: $datasource_navigation >> 'Last';
	$datasource_fields_skip = $datasource_fieldmap->size - (($datasource_fieldmap->size - 1) % $admin_listingsize);
else: $datasource_navigation >> 'Jump';
	$datasource_fields_skip = integer: $datasource_jump;
/if;

var: 'found_count' = $datasource_fieldmap->size;
var: 'datasource_fields_skip' = integer: (math_max: 1, (math_min: $datasource_fields_skip, $found_count));
var: 'shown_first' = $datasource_fields_skip;
var: 'shown_last' = integer: (math_min: $found_count, $datasource_fields_skip + ($admin_listingsize - 1));
var: 'shown_count' = ($shown_last - $shown_first + 1);

?>
