<?LassoScript

//
// Variables
//

_admin_addvar: -session='_siteadmin', 'datasource_connectorid', -default=1, -override=(action_param: 'datasource_connectorid');
_admin_addvar: -session='_siteadmin', 'datasource_hostid', -default=1, -override=(action_param: 'datasource_hostid');
_admin_addvar: -session='_siteadmin', 'datasource_databaseid', -override=(action_param: 'datasource_databaseid');
_admin_addvar: -session='_siteadmin', 'datasource_tableid', -override=(action_param: 'datasource_tableid');
_admin_addvar: -session='_siteadmin', 'datasource_fieldid', -override=(action_param: 'datasource_fieldid');

_admin_addvar: 'datasource_databasename';
_admin_addvar: 'datasource_databasealias';
_admin_addvar: 'datasource_tablename';
_admin_addvar: 'datasource_tablealias';

_admin_addvar: 'datasource_action', -default='None', -override=(action_param: 'datasource_action');

var: 'admin_listingsize' = (integer: (admin_getpref: 'lasso_admin_listingsize', -default='10'));

if: ($datasource_connectorid < 1);
	$datasource_connectorid = 1;
/if;


//
// Build Menus
//

var: 'datasource_connectormap' = (array);
var: 'datasource_hostmap' = (array);
var: 'datasource_databasemap' = (array);
var: 'datasource_tablemap' = (array);
var: 'datasource_fieldmap' = (array);

if: ($datasource_action >> 'Refresh') && ($datasource_connectorid != 0);
	_admin_refreshsecurity;
/if;

var: 'datasource_connectormap' = (_admin_listconnectors);
var: 'temp' = (_admin_defaultconnector: -id=$datasource_connectorid, $datasource_connectormap);
if: ($temp != null);
	var: 'datasource_connectorid' = $temp->first;
	var: 'datasource_connectordetail' = $temp->second;
	var: 'datasource_connectorname' = $datasource_connectordetail->(find: 'name');
	var: 'datasource_connectoralias' = $datasource_connectordetail->(find: 'alias');
	var: 'datasource_connectortype' = (_admin_connectortype: $datasource_connectordetail->(find: 'name'));
else;
	var: 'datasource_connectorid' = 0;
	var: 'datasource_connectordetail' = null;
/if;

if: ($datasource_action >> 'Refresh') && ($datasource_connectorid != 0);
	_admin_refreshconnector: $datasource_connectorid;
/if;

if: ($datasource_connectorid > 0);
	var: 'datasource_hostmap' = (_admin_listhosts: $datasource_connectorid);
	var: 'temp' = (_admin_defaulthost: $datasource_hostid, $datasource_hostmap);
	if: ($temp != null);
		var: 'datasource_hostid' = $temp->first;
		var: 'datasource_hostdetail' = $temp->second;
	else;
		var: 'datasource_hostid' = 0;
		var: 'datasource_hostdetail' = null;
	/if;
else;
	var: 'datasource_hostid' = 0;
	var: 'datasource_hostdetail' = null;
/if;

if: ($datasource_hostid > 0);
	var: 'datasource_databasemap' = (_admin_listdatabases: $datasource_hostid);
	var: 'temp' = (_admin_defaultdatabase: $datasource_databaseid, $datasource_databasemap);
	if: ($temp != null);
		var: 'datasource_databaseid' = $temp->first;
		var: 'datasource_databasedetail' = $temp->second;
		var: 'datasource_databasename' = $datasource_databasedetail->(find: 'name');
		var: 'datasource_databasealias' = $datasource_databasedetail->(find: 'alias');
	else;
		var: 'datasource_databaseid' = 0;
		var: 'datasource_databasedetail' = null;
	/if;
else;
	var: 'datasource_databaseid' = 0;
	var: 'datasource_databasedetail' = null;
/if;

if: ($datasource_databaseid > 0);
	var: 'datasource_tablemap' = (_admin_listtables: $datasource_databaseid);
	var: 'temp' = (_admin_defaulttable: $datasource_tableid, $datasource_tablemap);
	if: ($temp != null);
		var: 'datasource_tableid' = $temp->first;
		var: 'datasource_tabledetail' = $temp->second;
		var: 'datasource_tablename' = $datasource_tabledetail->(find: 'name');
		var: 'datasource_tablealias' = $datasource_tabledetail->(find: 'alias');
	else;
		var: 'datasource_tableid' = 0;
		var: 'datasource_tabledetail' = null;
	/if;
else;
	var: 'datasource_tableid' = 0;
	var: 'datasource_tabledetail' = null;
/if;

if: ($datasource_tableid > 0);
	var: 'datasource_fieldmap' = (_admin_listfields: $datasource_tableid);
	var: 'temp' = (_admin_defaultfield: $datasource_fieldid, $datasource_fieldmap);
	if: ($temp != null);
		var: 'datasource_fieldid' = $temp->first;
		var: 'datasource_fielddetail' = $temp->second;
		var: 'datasource_fieldname' = $datasource_fielddetail->(find: 'name');
	else;
		var: 'datasource_fieldid' = 0;
		var: 'datasource_fielddetail' = null;
	/if;
else;
	var: 'datasource_fieldid' = 0;
	var: 'datasource_fielddetail' = null;
/if;

if: (var_defined: 'admin_tab3_array');
	var: 'start'=2;
	var: 'end'=$admin_tab3_array->size - 1;
	if: $datasource_hostmap == (array);
		var: 'start'=3;
	else: $datasource_databasemap == (array);
		var: 'start'=3;
	else: $datasource_tablemap == (array);
		var: 'start'=4;
	else: $datasource_fieldmap == (array);
		var: 'start'=5;
	else;
		var: 'start'=$end+1;
	/if;
	loop: -loopfrom=1, -loopto=$admin_tab3_array->size;
		$admin_tab3_array->(get:loop_count)->(insert:'active' = true);
		$admin_tab3_array->(get:loop_count)->(insert:'visible' = true);
	/loop;
	loop: -loopfrom=$start, -loopto=$end;
		$admin_tab3_array->(get:loop_count)->(insert:'active' = false);
	/loop;
/if;
?>