<?LassoScript

//
// Variables
//

_admin_addvar: 'datasource_action', -default='None', -override=(action_param: 'datasource_action', (action_param: 'datasource_action', -count));
_admin_addvar: 'datasource_table_skip', -default=1, -session='_siteadmin', -override=(action_param: 'datasource_table_skip');
_admin_addvar: 'datasource_navigation', -override=(action_param: 'datasource_navigation');
_admin_addvar: 'datasource_jump', -override=(action_param: 'datasource_jump');

_admin_addvar: 'table_name', -override=(action_param: 'table_name');
_admin_addvar: 'table_alias', -override=(action_param: 'table_alias');
_admin_addvar: 'table_enabled', -override=(action_param: 'table_enabled');
_admin_addvar: 'table_encoding', -override=(action_param: 'table_encoding');
if: $table_encoding == '...';
	var: 'table_encoding' = (action_param: 'table_encoding_other');
/if;

_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');


//
// Process Action
//

if: $datasource_action >> 'Update';

	_admin_updatetable: $datasource_tableid, 'alias'=$table_alias, 'enabled'=$table_enabled, 'encoding'=$table_encoding;
	if: $_code != (error_noerror);
		var: 'datasource_error' = $_error + ' (' + $_code + ')';
	else;
		var: 'datasource_message' = 'The table was updated successfully.';
	/if;

	var: '__admin_tables_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_tablemap' = (_admin_listtables: $datasource_databaseid);
	var: 'datasource_tabledetail' = $datasource_tablemap->(find: $datasource_tableid)->(get:1)->second;
	var: 'datasource_tablename' = $datasource_tabledetail->(find: 'name');

	var: 'datasource_action' = 'Detail';

else: $dialog_action >> 'Delete Settings';

	_admin_deletetable: $datasource_tableid;

	var: '__admin_tables_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_tablemap' = (_admin_listtables: $datasource_databaseid);
	var: 'datasource_tableid' = -1;
	var: 'datasource_tabledetail' = null;

else: $dialog_action >> 'Delete All Settings';

	iterate: $datasource_tablemap, (var: 'temp_table');
		_admin_deletetable: $temp_table->first;
	/iterate;

	var: '__admin_tables_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_tablemap' = (_admin_listtables: $datasource_databaseid);
	var: 'datasource_tabledetail' = -1;
	var: 'datasource_tablename' = null;

else: $dialog_action >> 'Enable All';

	iterate: $datasource_tablemap, (var: 'temp_table');
		var: 'id' = $temp_table->first;
		_admin_updatetable: $id, 'enabled'='Y';
	/iterate;

	var: '__admin_tables_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_tablemap' = (_admin_listtables: $datasource_databaseid);

else: $dialog_action >> 'Disable All';

	iterate: $datasource_tablemap, (var: 'temp_table');
		var: 'id' = $temp_table->first;
		_admin_updatetable: $id, 'enabled'='N';
	/iterate;

	var: '__admin_tables_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_tablemap' = (_admin_listtables: $datasource_databaseid);

else: $datasource_action >> 'List Fields';

	// Redirect
	var: 'link' = $admin_link + '&tab3=fields' +
		'&datasource_connectorid=' + $datasource_connectorid +
		'&datasource_hostid=' + $datasource_hostid +
		'&datasource_databaseid=' + $datasource_databaseid +
		'&datasource_tableid=' + $datasource_tableid;
	redirect_url: $link;

/if;


//
// Process Navigation
//

if: $datasource_navigation >> 'Prev';
	$datasource_table_skip -= $admin_listingsize;
else: $datasource_navigation >> 'Next';
	$datasource_table_skip += $admin_listingsize;
else: $datasource_navigation >> 'First';
	$datasource_table_skip = 1;
else: $datasource_navigation >> 'Last';
	$datasource_table_skip = $datasource_tablemap->size - (($datasource_tablemap->size - 1) % $admin_listingsize);
else: $datasource_navigation >> 'Jump';
	$datasource_table_skip = integer: $datasource_jump;
/if;

var: 'found_count' = $datasource_tablemap->size;
var: 'datasource_table_skip' = integer: (math_max: 1, (math_min: $datasource_table_skip, $found_count));
var: 'shown_first' = $datasource_table_skip;
var: 'shown_last' = integer: (math_min: $found_count, $datasource_table_skip + ($admin_listingsize - 1));
var: 'shown_count' = ($shown_last - $shown_first + 1);

?>
