<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post" enctype="multipart/form-data">
<input type="hidden" name="dialog_action" value="" />

<div class="content_split">
	<div class="content_left">
		<h2>Import Site Settings</h2>
		<p>
			Important - This interface should only be used to import a settings file created by the Lasso
			Settings Migrator which shipped with Lasso 8 or an export from a Lasso Professional 8 site.
		</p>
		<table>
			<tr>
				<th>File</th>
				<td width="65%">
					<input type="file" name="import_file" value="[action_param: 'import_file']" />
				</td>
			</tr>
		</table>
[if: (var_defined: 'import_error') && ($import_error != '')]
		<p class="error">[var: 'import_error', -encodenone]</p>
[/if]
[if: (var_defined: 'import_success') && ($import_success != '')]
		<p class="message">[var: 'import_success']</p>
[/if]
[if: ($action >> 'Import') && ($import_cancel == false)]
		<p>
              Your site will be stopped in a couple seconds.  
              Wait a few seconds and follow this link to re-enter Site Administration.  The first click on the link will re-start your site.  
              If you receive an error from your browser, wait 10-15 seconds and click on the link again.
		</p>
		<p class="message">
              <a href="[var: 'admin_link', -encodenone]&tab1=setup&tab2=global&tab3=login">Site Administration</a>
		</p>
[/if]
		<p>&nbsp</p>
		<p align="right">
			<input type="submit" value="Import" name="action" class="medium" onclick="return confirm('Warning - Importing a setup file will overwrite all settings in Lasso Administration.  Are you sure you want to do this?');" />
		</p>
	</div>
	<div class="content_right">
		<h2>Export Site Settings</h2>
		<p>
			Select the "Export..." button to download a text file with all the
			security settings for this site.  The file will be named
			Lasso_Site_[site_id]_YYYYMMDDHHMMSS.txt.
		</p>
		<p>&nbsp</p>
		<p align="right">
			<input type="submit" name="action" value="Export..." class="medium" />
		</p>
	</div>
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0"></div>
</div>

</form>
