<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">

[if: ($cache_name != '') && ($cache_action >> 'detail')]
<div class="content_split">
[else]
<div class="content_split_solo">
[/if]
	<div class="content_left">
		<h2>Cache List</h2>
		<table>
			<tr>
				<th>Name</th>
				<th>Value</th>
				<th>Efficiency</th>
			</tr>
[var: 'count' = 0]
[iterate: globals->keys, (var: 'key')]
<?LassoScript
	!$key->beginswith('_cache_') ? loop_continue;
	!$key->endswith('_content') ? loop_continue;
	$key->removeleading('_cache_')&removetrailing('_content');
	$count+=1;
	var: 'type' = globals->find('_cache_' + $key + '_content')->type;
	if: $type->size > 2;
		var: 'type' = (string_uppercase: $type->(get:1)) + (string_lowercase: $type->(substring:2));
	/if;
	if: ($type == 'string');
		var: 'size' = globals->find('_cache_' + $key + '_content')->size + ' Chars';
	else: ($type == 'bytes');
		var: 'size' = globals->find('_cache_' + $key + '_content')->size + ' Bytes';
	else;
		var: 'size' = serialize(globals->find('_cache_' + $key + '_content'))->size + ' Bytes';
	/if;
	var: 'fetch' = (integer: globals->find('_cache_' + $key + '_fetch'));
	var: 'store' = (integer: globals->find('_cache_' + $key + '_store'));
	if: ($fetch > 0) && ($fetch > $store);
		var: 'efficiency' = ((decimal: $fetch - $store) / (decimal: $fetch));
	else;
		var: 'efficiency' = 0.0;
	/if;
?>
			<tr>
				<td><a href="[var: 'admin_link', -encodenone]&cache_action=detail&cache_name=[encode_stricturl: $key]">[var: 'key'] [var: 'param']</a></td>
				<td>[var: 'type'] [var: 'size']</td>
				<td>[percent: $efficiency]</td>
			</tr>
[/iterate]
		</table>
[if: $count == 0]
		<p class="error">No Cached Content Found</p>
[/if]
		<p align="right">
			<input type="submit" value="Refresh" name="action" class="small" />
		</p>
		<br />
		<p align="right">
			<input type="submit" value="Garbage Collect" name="action" class="large" />
		</p>
	</div>

[if: ($cache_name != '') && ($cache_action >> 'detail')]
	<div class="content_right">
		<input type="hidden" name="cache_name" value="[var: 'cache_name']">
		<h2>Cache Detail</h2>
<?LassoScript
	
	var: 'key' = $cache_name;
	var: 'type' = globals->find('_cache_' + $key + '_content')->type;
	if: $type->size > 2;
		var: 'type' = (string_uppercase: $type->(get:1)) + (string_lowercase: $type->(substring:2));
	/if;
	if: ($type == 'string');
		var: 'size' = globals->find('_cache_' + $key + '_content')->size + ' Chars';
	else: ($type == 'bytes');
		var: 'size' = globals->find('_cache_' + $key + '_content')->size + ' Bytes';
	else;
		var: 'size' = serialize(globals->find('_cache_' + $key + '_content'))->size + ' Bytes';
	/if;
	var: 'fetch' = (integer: globals->find('_cache_' + $key + '_fetch'));
	var: 'store' = (integer: globals->find('_cache_' + $key + '_store'));
	if: ($fetch > 0) && ($fetch > $store);
		var: 'efficiency' = ((decimal: $fetch - $store) / (decimal: $fetch));
	else;
		var: 'efficiency' = 0.0;
	/if;
	var: 'date' = (string: globals->find('_cache_' + $key + '_date'));

	var: 'content' = string(globals->find('_cache_' + $key + '_content'));
	if: ($content->size > 255);
		var: 'content' = $content->(substring: 1,255) + ' ...';
	else: ($content->size == 0);
		var: 'content' = '(None)';
	/if;
?>
		<table>
			<tr width="40%">
				<th>Cache Name</th>
				<td>[var: 'key']</td>
			</tr>
			<tr>
				<th>Value Size</th>
				<td>[var: 'size']</td>
			</tr>
			<tr>
				<th>Value Type</th>
				<td>[var: 'type']</td>
			</tr>
			<tr>
				<th>Store Count</th>
				<td>[var: 'store']</td>
			</tr>
			<tr>
				<th>Fetch Count</th>
				<td>[var: 'fetch']</td>
			</tr>
			<tr>
				<th>Efficiency</th>
				<td>[percent: $efficiency]</td>
			</tr>
			<tr>
				<th>Date/Time</th>
				<td>[var: 'date']</td>
			</tr>
			<tr>
				<th>Contents</th>
				<td>[var: 'content']</td>
			</tr>
		</table>

		<p align="right">
			<input type="submit" name="cache_action" value="Expire Now" class="medium" />
			<input type="submit" name="cache_action" value="Delete" class="medium" />
		</p>
	</div>
[/if]
	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0"></div>

</div>
</form>

