<?LassoScript

	inline: -log=$__startup_loglevel__, $error_inline;
		var: 'error_found' = found_count;
		var: 'found_count' = (found_count);
		var: 'shown_count' = (shown_count);
		var: 'shown_first' = (shown_first);
		var: 'shown_last' = (shown_last);
		
?>
<div class="sidebar">

<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">
<input type="hidden" name="error_oldfilter" value="[var: 'error_filter']">
<input type="hidden" name="error_oldstatus" value="[var: 'error_status']">
<input type="hidden" name="error_skip" value="[var: 'error_skip']">	
<input type="hidden" name="error_found" value="[var: 'error_found']">
<input type="hidden" name="email_id" value="[var: 'email_id']">

	<h2 onclick="toggleDisplayBlock('srch')">SMTP Errors</h2>
	<div id="srch">
		[if: $email_id != '']
			<p>Showing errors for email [var: 'email_id']</p>
			<p style="margin-bottom: 3px; align: right;">
				<input type="submit" name="error_action" value="Show All Errors" />
			</p>
		[else]
			<p>Showing all errors</p>
		[/if]
		<p>
			<b>Severity</b>
			<br />
			<select name="error_status" onchange="this.form.submit();">
				<option value="all" [if: (var: 'error_status') >> 'all']selected="selected"[/if]>Any Errors</option>
				<option value="fatal" [if: (var: 'error_status') >> 'fatal']selected="selected"[/if]>Fatal Errors</option>
				<option value="warning" [if: (var: 'error_status') >> 'warning']selected="selected"[/if]>Warnings</option>
			</select>
		</p>
		<p>
			<b>Filter</b>
			<br />
			<input type="text" name="error_filter" value="[var: 'error_filter']" size="16" />
		</p>
		<p style="margin-bottom: 3px; align: right;">
			<input type="submit" name="error_action" value="Select" class="half" />
			<input type="submit" name="error_action" value="Refresh" class="half" />
		</p>
	</div>

	<div id="none">
		<p>
			<input type="Submit" name="error_action" value="[if: (global: '__SMTP_Stage_Status__') >> 'Pause']Resume[else]Stop[/if] Queue" />
		</p>
	</div>
	<h2 onclick="toggleDisplayBlock('sum')">Summary</h2>
	<div id="sum">
		<p>
			[if: ((var: 'found_count') > 0) && ((var: 'shown_count') > 0)]
				Showing 
				[if: (var: 'shown_count') == 1] record [var: 'shown_first'][else][var: 'shown_count'] records[/if]
				[if: (var: 'found_count') > 1]of [var: 'found_count'] found[/if]
			[else]
				No Records Found
			[/if]
		</p>
		<p>
			Email Queue: [Global: '__SMTP_Queue_Status__'] [if: (Global: '__SMTP_Queue_Status__') >> 'Sleep'] Until [Date_Format: (Global: '__SMTP_Queue_Sleep__'), -Format='%T'][/If]
		</p>
		<p>
			Parts Queue: [Global: '__SMTP_Stage_Status__'] [if: (Global: '__SMTP_Stage_Status__') >> 'Sleep'] Until [Date_Format: (Global: '__SMTP_Stage_Sleep__'), -Format='%T'][/If]
		</p>
	</div>

	<h2 onclick="toggleDisplayBlock('act')">Actions</h2>
	<div id="act"[if: (var: 'found_count') == 0] style="display: none;"[/if]>
	[if: (var: 'error_status') >> 'warning']
		<p>
			<input type="submit" name="error_action" value="Clear All Warnings" />
		</p>
	[else: (var: 'error_status') >> 'fatal']
		<p>
			<input type="submit" name="error_action" value="Clear All Fatal" />
		</p>
	[/if]
		<p>
			<input type="submit" name="error_action" value="Clear All Errors" />
		</p>
	</div>

	<h2 onclick="toggleDisplayBlock('nav')">Navigation</h2>
	<div id="nav"[if: ((var: 'found_count') <= (var: 'shown_count'))] style="display: none;"[/if]>
		<table border="0" cellpadding="0" cellspacing="0">
		[if:((var: 'shown_first') > 1) || ((var: 'shown_last') < (var: 'found_count'))]
			<tr>
			[if:((var: 'shown_first') > 1)]
				<td><input type="submit" value="Prev" name="error_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			[if:((var: 'shown_last') < (var: 'found_count'))]
				<td><input type="submit" value="Next" name="error_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			</tr>
		[/if]
			<tr>
				<td><input type="text" value="[var: 'shown_first']" name="error_navigation_skip" class="half"></td>
				<td><input type="submit" value="Jump" name="error_navigation" class="half" /></td>
			</tr>
		[if:((var: 'shown_first') > 1) || ((var: 'shown_last') < (var: 'found_count'))]
			<tr>
			[if:((var: 'shown_first') > 1)]
				<td><input type="submit" value="First" name="error_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			[if:((var: 'shown_last') < (var: 'found_count'))]
				<td><input type="submit" value="Last" name="error_navigation" class="half" /></td>
			[else]
				<td>&nbsp;</td>
			[/if]
			</tr>
		[/if]
		</table>
	</div>

</form>

</div>

<div class="content_full2">
	[records]
	<div class="content_panel"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b><div class="content_inner">
		<span>
			<span class="twothird">
				[if: (field: 'code') != 0 && (field: 'code') != -1]<b>Code: </b> [field: 'code']<br />[/if]
				<b>Message: </b> [string_replace: (encode_html: (field: 'error')), -find='\r', -replace='<br />', -encodenone]
			</span>
			[protect]<b>Time:</b> [date_format: (field: 'datetime'), -format='%Q %T']<br />[/protect]
			<b>Severity:</b> [if: (field: 'severity') == 'warning']Warning[else: (field: 'severity') == 'fatal']Fatal[else][field: 'severity'][/if]
		</span>
	</div><b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b></div>
	[/records]
[if: (found_count) == 0]
	<p class="error">No Errors Found</p>
[/if]
</div>

[/inline]