<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">

<div class="content_split_solo">

	<div class="content_left">
		<h2>Email Setup</h2>
		<table>
			<tr>
				<th>Ignore ['[Email_Send]'] -Host Param</th>
				<td>[if: $email_prefs->(find:'lasso_smtp_ignorehost') == 'Y']
					<select name="lasso_smtp_ignorehost" class="std_pop_small">
						<option value="Y" selected="selected">Yes</option>
						<option value="N">No</option>
					</select>
              [else]
					<select name="lasso_smtp_ignorehost" class="std_pop_small">
						<option value="Y">Yes</option>
						<option value="N" selected="selected">No</option>
					</select>
              [/if]
				</td>
			</tr>
			<tr>
				<td colspan="2">
					Note - When this setting is Yes then the settings configured
					below will be used for all email messages sent through Lasso.
					When it is set to No then these settings can be overridden
					using the -Host and related parameters in the 
					[Noprocess][Email_Send][/Noprocess] tag.
				</td>
			</tr>
			<tr>
				<td colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<th>Send Directly to SMTP Servers</th>
				<td>[if: $email_prefs->(find:'lasso_smtp_sendmode') == 'local']
					<select name="lasso_smtp_sendmode" class="std_pop_small">
						<option value="direct">Yes</option>
						<option value="local" selected="selected">No</option>
					</select>
              [else]
					<select name="lasso_smtp_sendmode" class="std_pop_small">
						<option value="direct" selected="selected">Yes</option>
						<option value="local">No</option>
					</select>
              [/if]
				</td>
			</tr>
			<tr>
				<td colspan="2">
					Note - When this setting is Yes then Lasso will act
					as a mail server, looking up MX records and
					sending messages directly to each recipient's SMTP
					server. When it is set to No then Lasso will relay
					all messages through the default SMTP host set below.
				</td>
			</tr>
			<tr>
				<th>Default SMTP Host</th>
				<td>
					<input type="text" name="lasso_smtp_host" value="[encode_html: $email_prefs->(find:'lasso_smtp_host')]" class="large" />
				</td>
			</tr>
			<tr>
				<th>Default SMTP Port</th>
				<td>
					<input type="text" name="lasso_smtp_port" value="[encode_html: $email_prefs->(find:'lasso_smtp_port')]" class="small" />
				</td>
			</tr>
			<tr>
				<th>SMTP Host Timeout</th>
				<td>
					<input type="text" name="lasso_smtp_timeout" value="[encode_html: $email_prefs->(find:'lasso_smtp_timeout')]" class="small" /> Seconds
				</td>
			</tr>
			<tr>
				<th>SMTP AUTH Username</th>
				<td>
					<input type="text" name="lasso_smtp_username" value="[encode_html: $email_prefs->(find:'lasso_smtp_username')]" class="large" />
				</td>
			</tr>
			<tr>
				<th>SMTP AUTH Password</th>
				<td>
					<input type="password" name="lasso_smtp_password" value="[encode_html: $email_prefs->(find:'lasso_smtp_password')]" class="large" />
				</td>
			</tr>
			<tr>
				<th>Use SMTP SSL When Available</th>
				<td>[if: $email_prefs->(find:'lasso_smtp_usessl') == 'Y']
					<select name="lasso_smtp_usessl" class="std_pop_small">
						<option value="Y" selected="selected">Yes</option>
						<option value="N">No</option>
					</select>
              [else]
					<select name="lasso_smtp_usessl" class="std_pop_small">
						<option value="Y">Yes</option>
						<option value="N" selected="selected">No</option>
					</select>
              [/if]
				</td>
			</tr>
			<tr>
				<td colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<th>Maximum Retries</th>
				<td>
					<input type="text" name="lasso_smtp_max_retries" value="[encode_html: $email_prefs->(find:'lasso_smtp_max_retries')]" class="small" />
				</td>
			</tr>
			<tr>
				<th>Email Retry Delay</th>
				<td>
					<input type="text" name="lasso_smtp_resend_delay" value="[encode_html: $email_prefs->(find:'lasso_smtp_resend_delay')]" class="small" /> Seconds
				</td>
			</tr>
			<tr>
				<th>Email Sweep Delay</th>
				<td>
					<input type="text" name="lasso_smtp_sweep_delay" value="[encode_html: $email_prefs->(find:'lasso_smtp_sweep_delay')]" class="small" /> Seconds
				</td>
			</tr>
			<tr>
				<th>Retain Successful Messages</th>
				<td> [if: $email_prefs->(find:'lasso_smtp_keep_success') == 'Y']
					<select name="lasso_smtp_keep_success" class="std_pop_small">
						<option value="Y" selected="selected">Yes</option>
						<option value="N">No</option>
					</select>
              [else]
					<select name="lasso_smtp_keep_success" class="std_pop_small">
						<option value="Y">Yes</option>
						<option value="N" selected="selected">No</option>
					</select>
              [/if]
                </td>
			</tr>
			<tr>
				<th>Retain Error Messages</th>
				<td> [if: $email_prefs->(find:'lasso_smtp_keep_error') == 'Y']
					<select name="lasso_smtp_keep_error" class="std_pop_small">
						<option value="Y" selected="selected">Yes</option>
						<option value="N">No</option>
					</select>
              [else]
					<select name="lasso_smtp_keep_error" class="std_pop_small">
						<option value="Y">Yes</option>
						<option value="N" selected="selected">No</option>
					</select>
              [/if]
                </td>
			</tr>
			<tr>
				<th>Retain Encoded Messages in Log</th>
				<td> [if: $email_prefs->(find:'lasso_smtp_keep_mime') == 'Y']
					<select name="lasso_smtp_keep_mime" class="std_pop_small">
						<option value="Y" selected="selected">Yes</option>
						<option value="N">No</option>
					</select>
              [else]
					<select name="lasso_smtp_keep_mime" class="std_pop_small">
						<option value="Y">Yes</option>
						<option value="N" selected="selected">No</option>
					</select>
              [/if]
                </td>
			</tr>
			<tr>
				<th>Maximum # Queues</th>
				<td>
					<input type="text" name="lasso_smtp_queue_count" value="[encode_html: $email_prefs->(find:'lasso_smtp_queue_count')]" class="small" />
				</td>
			</tr>
			<tr>
				<th>Send # Messages Per Connection</th>
				<td>
					<input type="text" name="lasso_smtp_queue_size" value="[encode_html: $email_prefs->(find:'lasso_smtp_queue_size')]" class="small" />
				</td>
			</tr>
			<tr>
				<th>Override Lasso Service IP</th>
				<td>
					<input type="text" name="lasso_smtp_lassoservice_ip" value="[encode_html: $email_prefs->(find:'lasso_smtp_lassoservice_ip')]" class="large" />
				</td>
			</tr>
		</table>
		<p align="right">
			<input type="Submit" name="email_action" value="Update" class="small" />
			<input type="Submit" name="email_action" value="Reset" class="small" />
		</p>
		<p align="right">
			<input type="Submit" name="email_action" value="[if:(global: '__SMTP_Stage_Status__') >> 'Pause']Resume Mail Queue[else]Stop Mail Queue[/if]" class="large">
		</p>
	</div>

	<div class="content_clear"><img src="[lassoapp_link:'images/blank.gif']" height="1" width="1" border="0"></div>

</div>

</form>
