<?LassoScript

// ---------
// variables

_admin_addvar: 'email_action', -override=(action_param: 'email_action');


// ---------
// email_prefs

var: 'email_defaults' = (map: 
		'lasso_smtp_pause' = 'N',
		'lasso_smtp_host' = '',
		'lasso_smtp_port' = 25,
		'lasso_smtp_username' = '',
		'lasso_smtp_password' = '',
		'lasso_smtp_timeout' = 15,
		'lasso_smtp_keep_error' = 'Y',
		'lasso_smtp_keep_success' = 'N',
		'lasso_smtp_keep_mime' = 'N',
		'lasso_smtp_sweep_delay' = 5,
		'lasso_smtp_resend_delay' = 600,
		'lasso_smtp_mxretry_delay' = 600,
		'lasso_smtp_max_retries' = 5,
		'lasso_smtp_queue_count' = 4,
		'lasso_smtp_queue_size' = 100,
		'lasso_smtp_lassoservice_ip' = '',
		'lasso_smtp_sendmode' = 'direct',
		'lasso_smtp_ignorehost' = 'N',
		'lasso_smtp_usessl' = 'N',
	);
var: 'email_prefs' = $email_defaults;
var: 'email_prefs' = (admin_getpref: $email_prefs);


// ---------
// email_action

if: (var:'email_action') >> 'Update';

	iterate: $email_prefs->keys, (var: 'key');
		if: (action_param: $key, -count) > 0;
			if: (action_param: $key) == '';
				$email_prefs->(insert: $key = $email_defaults->(find: $key));
			else;
				$email_prefs->(insert: $key = (action_param: $key));
			/if;
		/if;
	/iterate;
	
	admin_setpref: $email_prefs;
	global: '__SMTP_Queue_Status__' = (global: '__SMTP_Queue_Status__') + ' Refresh';
	global: '__SMTP_Stage_Status__' = (global: '__SMTP_Stage_Status__') + ' Refresh';
	
else: (var:'email_action') >> 'Reset';

	var: 'email_prefs' = $email_defaults;
	admin_setpref: $email_prefs;
	global: '__SMTP_Queue_Status__' = (global: '__SMTP_Queue_Status__') + ' Refresh';
	global: '__SMTP_Stage_Status__' = (global: '__SMTP_Stage_Status__') + ' Refresh';

else: (var:'email_action') >> 'Stop';

	admin_setpref: 'lasso_smtp_pause', 'Y';
	$email_prefs->(insert: 'lasso_smtp_pause' = 'Y');
	global: '__SMTP_Queue_Status__'='Pause Refresh';
	global: '__SMTP_Stage_Status__'='Pause Refresh';

else: (var:'email_action') >> 'Resume';

	admin_setpref: 'lasso_smtp_pause', 'N';
	$email_prefs->(insert: 'lasso_smtp_pause' = 'N');
	global: '__SMTP_Queue_Status__'='Active Refresh';
	global: '__SMTP_Stage_Status__'='Active Refresh';

/if;

?>
