<?LassoScript

var: 'admin_refresh' = (integer: (admin_getpref: 'lasso_admin_errorrefresh', -default='1')) * 60;

_admin_addvar: 'error_filter', -default='', -force=(action_param: 'error_filter');
_admin_addvar: 'error_action', -default='None', -override=(action_param: 'error_action');

_admin_addvar: 'event_id', -default='', -override=(action_param: 'event_id');

_admin_addvar: 'error_skip', -default=0, -session='_siteadmin', -override=(action_param: 'error_skip');
_admin_addvar: 'error_max', -default=(integer: (admin_getpref: 'lasso_admin_errorsize', -default=25));
_admin_addvar: 'error_navigation', -override=(action_param: 'error_navigation');
_admin_addvar: 'error_jump', -override=(action_param: 'error_jump');
_admin_addvar: 'error_found', -default=0, -session='_siteadmin';

_admin_addvar: 'error_sortfield', -default='id', -session='_siteadmin', -override=(action_param: 'error_sortfield');
_admin_addvar: 'error_sortorder', -default='descending', -session='_siteadmin', -override=(action_param: 'error_sortorder');

_admin_addvar: 'error_oldfilter', -override=(action_param: 'error_oldfilter');
if: ($error_oldfilter == '') || ($error_oldfilter != $error_filter);
	var: 'error_skip' = 0;
/if;

var: 'error_skip' = (integer: $error_skip);
var: 'error_max' = (integer: $error_max);
var: 'error_found' = (integer: $error_found);

if: ($error_navigation >> 'Next');
	$error_skip = (integer: ($error_skip + $error_max));
else: ($error_navigation >> 'Prev');
	$error_skip = (integer: (math_max: $error_skip - $error_max, 0));
else: ($error_navigation >> 'Last');
	$error_skip = $error_found - $error_max;
else: ($error_navigation >> 'First') || ($error_navigation >> 'Sort');
	$error_skip = 0;
else: ($error_navigation >> 'Jump') || ((action_param: 'error_navigation_skip') != '');
	$error_skip = (math_max: (integer: (action_param: 'error_navigation_skip')) - 1, 0);
/if;

if: ($error_skip > 0) && ($error_found > 0);
	$error_skip = (math_max: (math_min: $error_found - 1, $error_skip), 0);
/if;


var: 'error_inline' = (array);

$error_inline->(insert: -search='');
$error_inline->(insert: -database='site');
$error_inline->(insert: -table='schedule_error');

$error_inline->(insert: -maxrecords=$error_max);
$error_inline->(insert: -skiprecords=$error_skip);

$error_inline->(insert: -sortfield=$error_sortfield);
$error_inline->(insert: -sortorder=$error_sortorder);

if: $error_action >> 'Show All';

	var: 'event_id' = '';

else: $event_id != '';

	$error_inline->(insert: -op='eq');
	$error_inline->(insert: 'id_schedule'=$event_id);

/if;

if: $error_filter != '';

	$error_inline->(insert: -op='cn');
	$error_inline->(insert: 'error'=$error_filter);

/if;

if: ($error_action >> 'Events') && ($error_action >> 'Pause');

	global: '__Schedule_Status__' = 'Pause';
	admin_setpref: -name='lasso_schedule_pause', -value='Y';
	log_warning: 'Schedule: Pausing Event Queue';

else: ($error_action >> 'Events') && ($error_action >> 'Resume');

	global: '__Schedule_Status__' = 'Active';
	admin_setpref: -name='lasso_schedule_pause', -value='N';
	log_warning: 'Schedule: Restarting Event Queue';
	
	admin_setpref: -name='lasso_schedule_pause', -value='N';

else: ($error_action >> 'Clear');

	var: 'error_found' = 0;
	var: 'error_skip' = 0;

	inline: -log=$__startup_loglevel__, -database='site', -sql='DELETE FROM schedule_error' + ($event_id != '' ? ' WHERE  id_schedule = "' + (integer: $event_id) + '"' | '');
	/inline;

/if;

?>
