<?LassoScript
	inline: -log=$__startup_loglevel__, $event_inline;
		var: 'event_found' = found_count;
		var: 'found_count' = (found_count);
		var: 'shown_count' = (shown_count);
		var: 'shown_first' = (shown_first);
		var: 'shown_last' = (shown_last);
	var: 'queue_ids' = (array);
	records;
		$queue_ids->(insert: (field: 'id'));
	/records;
	if: $queue_ids->size > 0;
		inline: -log=$__startup_loglevel__,
				-database='site',
				-table='schedule_error',
				-SQL='SELECT * FROM schedule_error WHERE id_schedule IN (' + $queue_ids->(join: ', ') + ') ORDER BY id DESC',
				-maxrecords='all',
				-inlinename='schedule_error';
		/inline;
	/if;
?>
<div class="sidebar">

<form autocomplete="off" action="[var: 'admin_link', -encodenone]" method="post">
<input type="hidden" name="event_oldfilter" value="[var: 'event_filter']">
<input type="hidden" name="event_skip" value="[var: 'event_skip']">	
<input type="hidden" name="event_found" value="[var: 'event_found']">

	<h2 onclick="toggleDisplayBlock('srch')">Scheduled Events</h2>
	<div id="srch">
		<p>
			<b>Filter</b>
			<br />
			<input type="text" name="event_filter" value="[var: 'event_filter']" size="16" />
		</p>
		<p style="margin-bottom: 3px; align: right;">
			<input type="submit" name="mysql_action" value="Select" class="half" />
			<input type="submit" name="mysql_action" value="Refresh" class="half" />
		</p>
	</div>

	<div id="none">
		<p>
			<input type="submit" name="event_action" value="[if: ((Global: '__Schedule_Status__') == 'Pause')]Resume[else]Pause All[/if] Events"  />
		</p>
	</div>
	
	<h2 onclick="toggleDisplayBlock('sum')">Summary</h2>
	<div id="sum">
		<p>
			[if: ((var: 'found_count') > 0) && ((var: 'shown_count') > 0)]
				Showing 
				[if: (var: 'shown_count') == 1] record [var: 'shown_first'][else][var: 'shown_count'] records[/if]
				[if: (var: 'found_count') > 1]of [var: 'found_count'] found[/if]
			[else]
				No Events Found
			[/if]
		</p>
		<p>
			Status: [Global: '__Schedule_Status__'] [if: (Global: '__Schedule_Status__') >> 'Sleep'] Until [Date_Format: (Global: '__Schedule_Sleep__'), -Format='%T'][/If]
		</p>
	</div>

	<h2 onclick="toggleDisplayBlock('act')">Actions</h2>
	<div id="act"[if: (var: 'found_count') == 0] style="display: none;"[/if]>
		<p>
			<input type="submit" name="event_action" value="Delete All Events" onclick="return confirm('Are you sure you want to delete all events?');" />
		</p>
	</div>

	<h2 onclick="toggleDisplayBlock('nav')">Navigation</h2>
	<div id="nav"[if: ((var: 'found_count') <= (var: 'shown_count'))] style="display: none;"[/if]>
		[if:((var: 'shown_first') > 1)]
			<p>
				<input type="submit" value="<< First" name="event_navigation" />
			</p>
		[/if]
		[if:((var: 'shown_first') > 1)]
			<p>
				<input type="submit" value="< Prev" name="event_navigation" />
			</p>
		[/if]
		<p>
			<input type="text" value="[var: 'shown_first']" name="event_navigation_skip" class="half"><input type="submit" value="Jump" name="event_navigation" class="half" />
		</p>
		[if:((var: 'shown_last') < (var: 'found_count'))]
			<p>
				<input type="submit" value="Next >" name="event_navigation" />
			</p>
		[/if]
		[if:((var: 'shown_last') < (var: 'found_count'))]
			<p>
				<input type="submit" value="Last >>" name="event_navigation" />
			</p>
		[/if]
	</div>

</form>

</div>

<div class="content_full2">
	[records]
<?LassoScript
	var: 'options' = (array);
	if: ((field: 'date_time_start') >> '3001-01-01 00:00:00');
		$options->(insert: 'Paused');
	/if;
	if: ((field: 'date_time_start') == '') && ((field: 'date_time_start') == '');
		$options->(insert: 'Never');
	else: ((field: 'repeat') == 1);
		var: 'repeat' = 'Repeat ';
		if: (field: 'delay') == 7 * 24 * 60;
			$repeat += 'Weekly';
		else: (field: 'delay') == 24 * 60;
			$repeat += 'Daily';
		else;
			$repeat += 'Every ' + (field: 'delay') + ' Minutes';
		/if;
		if: ((field: 'date_time_end') != '') && ((field: 'date_time_end') !>> '3001-01-01 00:00:00')
			$repeat += ' Until ' + (date: (field: 'date_time_start'), -format='%Q %T');
		/if;
		$options->(insert: $repeat);
	else;
		$options->(insert: 'Perform Once');
	/if;
	if: ((field: 'restart') != '1');
		$options->(insert: 'Delete After Restart');
	/if;
	?>
	<div class="content_panel"><b class="b1"></b><b class="b2"></b><b class="b3"></b><b class="b4"></b><div class="content_inner">
		<span>
			<span class="onethird" style="text-align: right">
			[if: $options >> 'Paused']
				<a href="[$admin_link + '&event_action=resume&event_filter=' + $event_filter + '&event_id=' + (field: 'id')]">[if: ((Global: '__Schedule_Status__') == 'Pause')](Resume)[Else]Resume[/if]</a><br />
			[else]
				<a href="[$admin_link + '&event_action=pause&event_filter=' + $event_filter + '&event_id=' + (field: 'id')]">[if: ((Global: '__Schedule_Status__') == 'Pause')](Pause)[Else]Pause[/if]</a><br />
			[/if]
				<a href="[$admin_link + '&event_action=edit&event_filter=' + $event_filter + '&event_id=' + (field: 'id')]">Edit</a><br />
				<a href="[$admin_link + '&event_action=delete&event_filter=' + $event_filter + '&event_id=' + (field: 'id')]" onclick="return confirm('Are you sure you want to delete this event?');">Delete</a>
			</span>
		<b>Event: </b> [field: 'executeAction']<br />
			[protect]<b>Next Execute:</b> [date_format: (field: 'next_execute'), -format='%Q %T']<br />[/protect]
			[if: (field: 'user') != '']<b>User: </b> [field: 'user']<br />[/if]
			<b>Options:</b> [encode_html: $options->(join: ', ')]
		</span>

[var: 'id_schedule' = (field: 'id')]
[records: -inlinename='schedule_error'][if: (field: 'id_schedule') != $id_schedule][loop_continue][/if]
	<div class="content_panel" style="background: #999999"><b class="c1"></b><b class="c2"></b><b class="c3"></b><b class="c4"></b><div class="content_inner">
		<span>
			<span class="onethird" style="text-align: right">
				<a href="[$admin_link + '&event_action=error&event_id=' + $id_schedule]">Show All</a><br />
				<a href="[$admin_link + '&event_action=clear&event_id=' + $id_schedule]">Clear</a>
			</span>
			<b>Last Error:</b> [field: 'code']<br />
			<b>Message: </b> [field: 'error']<br />
			[protect]<b>Time:</b> [date_format: (field: 'date_time'), -format='%Q %T'][/protect]
		</span>
	</div><b class="c4"></b><b class="c3"></b><b class="c2"></b><b class="c1"></b></div>
	[loop_abort]
[/records]

	</div><b class="b4"></b><b class="b3"></b><b class="b2"></b><b class="b1"></b></div>
	[/records]
[if: (found_count) == 0]
	<p class="error">No Events Found</p>
[/if]

</div>

[/inline]