<?lassoscript

	define_tag('updatecheck',
		-namespace = 'lasso_',
		-required = 'component');

		local
		(
			'lpversion' = lasso_version(-lassoversion),
			'lpplatform' = lasso_version(-lassoplatform),
			'out',
			'serverreturn',
			'version'
		);

		error_code = 0;
		error_msg = '';

		if(#lpversion->find(' '));
			#lpversion = #lpversion->substring(1, #lpversion->find(' ') - 1);
		/if;

		if(#component != 'professional');
			if(#component != 'startup');
				if($__startup_version__ == 'Unknown');
					fail_if(error_code == 404, -1, '[Lasso_UpdateCheck]: The specified component LassoApp, ' #component ', cannot be checked because it does not contain a version.txt file.');
				else;
					#version = $__startup_version__;
				/if;
			else;
				#version = include_url('http://' server_name '/' #component '.LassoApp?-responselassoapp=version.txt');
			/if;
			fail_if(error_code == 404, -1, '[Lasso_UpdateCheck]: The specified component LassoApp, ' #component ', cannot be checked because it does not contain a version.txt file.');
		/if;

		// we need a good place to put this, other than where it is right now.
		#serverreturn = include_url('http://sun.lassosoft.com/default.lasso?lpv=' #lpversion '&c=' encode_stricturl(#component) '&p=' encode_stricturl(#lpplatform) '&v=' #version);
		fail_if(error_code != 0, -1, '[Lasso_UpdateCheck]: Could not reach the notification server.' error_code);
		#out->unserialize(#serverreturn);

		return(@#out);

	/define_tag;

?>